=== added directory 'doc'
=== added file 'doc/adoption.txt'
--- doc/adoption.txt	1970-01-01 00:00:00 +0000
+++ doc/adoption.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,118 @@
+****************
+Driving adoption
+****************
+
+Getting adoption means persuading people that it's a good choice.
+
+
+I think the key is to have something that key project leaders see as
+worth using.  Imagine what it would take to get tridge, havoc, or akpm
+to switch.  Or not even to switch, but to even just try it out.
+
+* Simple operations must be simple.
+
+* The project and the implementation must not have bad smells.
+
+* Given their current understanding of the problem, there must be at
+  one feature that's clearly better than what they're currently
+  using.
+
+
+What holds it back now?
+
+* Too complex on initial impression
+
+* Bad smell from having so many forks/wrappers/kooky opinions
+
+* Some of the more exotic features can only be appreciated on
+  familiarity
+
+* It doesn't actually achieve by default a lot of the advantages that
+  it ought to: for example it still blocks on the network
+
+
+Good features at the moment
+
+* Archive storage is clean; probably makes a favorable impression on
+  people who look at it
+
+* Relatively few dependencies (if you don't look too closely at
+  hackerlab, etc)
+
+
+From `Ben Collins-Sussman`__
+
+__ http://www.red-bean.com/sussman/svn-anti-fud.html
+
+   If you're learning about Subversion and thinking of using it in
+   your group or company, please approach it the way you'd approach
+   any new product: with caution. This isn't to say that Subversion is
+   unreliable... but that doesn't mean you shouldn't use some common
+   sense either. Don't blindly jump into the deep end without a
+   test-drive. No user wants a new product forced upon them, and if
+   you're going to be responsible for administering the system, you
+   better have some familiarity with it before rolling it out to
+   everyone. Find a smallish project, and set it up as a "pilot" for
+   Subversion. Ask for enthusiastic volunteers to test-drive the
+   experiment. In the end, if Subversion turns out to be a good fit,
+   you'll have much happier developers (who have been part of the
+   process from the start) and you'll be ready to support a larger
+   installation as well. [...]
+
+   When Subversion hit "alpha" it was already being used by dozens of private developers and shops for real work. Any other project probably would have called the product "1.0" at that point, but we deliberately decided to delay that label as long as possible. Because we're talking managing people's irreplaceable data, the project was extremely conservative about labeling something 1.0. We were aware that many people were waiting for that label before using Subversion, and had very specific expectations about the meaning of that label. So we stuck to that standard. All it takes is one high-profile case of data loss to destroy an SCM's reputation.
+
+
+`John S. Yates, Jr.`__:
+
+__ http://lists.gnu.org/archive/html/gnu-arch-users/2004-10/msg00370.html
+
+  First let me say that I have nothing but increasing respect for
+  Tom's skills and accomplishments.
+  
+  That said I see Gnu Arch as really just emerging from a period
+  of prototype development.  If the project really wants to take
+  over the world, and especially supplant projects with momentum
+  and commercial customers (e.g. Subversion, BitKeeper, etc) then
+  I would warn against two mistakes I have experienced repeatedly
+  in my career:
+  
+  1) Deferring to a tiny installed base instead of focusing on
+     eliminating barriers to adoption
+  
+  2) Believing that great technology will be irresistible no matter
+     how it is presented
+  
+  Appearances matter.  Expectations matter.  Standards (official
+  or de facto) matter.
+
+There is also a `reply from Tom`__.
+
+__ http://lists.gnu.org/archive/html/gnu-arch-users/2004-10/msg00430.html
+
+Clear wins
+----------
+
+To convince people to use Baz, there has to be some feature they can
+clearly understand which will be much better under Baz.  It must be
+something they do today.
+
+* Offline support
+
+* Almost no network delays
+
+* Atomic changes (svn already has this)
+
+* Correct repeated merges
+
+* Read-only mirroring archives (not really important) 
+
+My model is that people will consider changing if 
+
+1. it's at least as good as cvs/svn
+2. AND there are no big concerns about implementation/safety
+3. AND there is at least one feature which is easy to use and a big win
+
+This gets you to some people at least trying it.  Will people migrate
+big projects to it?  Maybe, if it looks safe, it fixes there problem,
+and it doesn't look like something substantially better is on the
+horizon.

=== added file 'doc/bitkeeper.txt'
--- doc/bitkeeper.txt	1970-01-01 00:00:00 +0000
+++ doc/bitkeeper.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,24 @@
+Bitkeeper compared to Arch
+==========================
+
+BK has a default GUI, which is good, but it's ugly and not all that
+friendly to the new user.  It does pay attention to allowing quick
+keyboard navigation.
+
+The tool itself is also a bit unfriendly in terms of emitting a lot of
+noise messages and having lots of wierd commands.
+
+Bitkeeper always requires both per-file and per-changeset commands.
+It seems bad to always require this; at most per-file messages should
+be optional.  Are they really the best option?
+
+Claimed to have extremely space-efficient storage, keeping 19 years of
+history in slightly more than twice the size of the working copy. 
+
+Hashes: does Baz always have these even without signing?  It really
+should.
+
+Fine-grained event triggers, pre- and post-event.
+
+Can remotely find status of a tree, e.g. parent, number of comitters,
+versioned files, extras, modified, etc. 

=== added file 'doc/changelogs.txt'
--- doc/changelogs.txt	1970-01-01 00:00:00 +0000
+++ doc/changelogs.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,30 @@
+**********
+ChangeLogs
+**********
+
+Changelogs have an interesting relation to version control systems.
+They are, for some projects, the primary way of examining history.
+They provide a pattern and standard for writing commit history, which
+may encourage people to enter more details (function names, etc) in a
+systematic way than they otherwise might.  The ChangeLog is available
+offline, in tarfiles, or even when the project has been switched into
+a different VCS.
+
+GNU ChangeLog format is only the most important, not the only such
+file.  Debian uses a different format for packages.  At a higher
+level, 
+
+At the same time the information there is some redundancy: both the
+ChangeLog and the VCS want to hold the description of what has been
+done, including descriptive text, names of files changed, etc.
+
+Some people say__ that ChangeLogs are mostly needed because of the
+limitations of CVS (and originally RCS): if it was easy to read the VC
+history when disconnected and at local speed, and if there are atomic
+commits then they might be needed rather less.
+
+__ http://gcc.gnu.org/ml/gcc/2004-06/msg00270.html
+
+There should be hooks called to create the log message template and
+before committing it.  These might, for example, populate it with
+space for per-file comments, or check that it is in the right format.

=== added file 'doc/cherry-picking.txt'
--- doc/cherry-picking.txt	1970-01-01 00:00:00 +0000
+++ doc/cherry-picking.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,42 @@
+**************
+Cherry picking
+**************
+
+Bazaar-NG allows you to try to 'cherry pick' changes from one branch
+to another.  That is to say that you can merge across only the changes
+from a particular commit, without getting anything else from that
+branch.
+
+However, because of dependencies in the source, it's not always very
+practical to pick changes out of a widely-diverged branch.  The
+general principle is that it's easier to keep things separate and
+combine them later than to mix things up and try to separate them.
+
+Therefore, we suggest using branches for each line of development that
+might want to separately merge.  Create a branch for each major
+feature; create branches for code that is ready to go upstream and for
+code that is very experimental.  Branches are cheap.  As changes pass
+through these branches they accumulate interesting metadata.
+
+Design
+------
+
+There is little that a tool can do to help with merges once you start
+cherry-picking changes; we need to rely on the merge tool detecting
+that some changes have already been applied.
+
+We should note that the changes have already come across, but I don't
+see many places where that will be terribly helpful.
+
+Sometimes a succession of cherry picks will be equivalent to merging
+the whole history up to some point, in which case we can fall back to
+a proper merge.
+
+When choosing a merge ancestor I think knowing non-contiguous
+cherry-picked changes will not help.
+
+Cherry-picking is equivalent to putting the merge ancestor just before
+the changeset(s) to be picked in.  So we can do this regardless of
+whether we have the whole history of the tree.
+
+

=== added file 'doc/cmdref.txt'
--- doc/cmdref.txt	1970-01-01 00:00:00 +0000
+++ doc/cmdref.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,789 @@
+***********************
+Reference for Bazaar-NG
+***********************
+
+:Author: Martin Pool
+:Copyright: Copyright 2004, 2005 Martin Pool; GNU GPL v2
+
+.. contents::
+
+
+
+Generalities
+------------
+
+Note that this document refers to many features which are not
+implemented yet.  Some may never be implemented.
+
+The top level command is ``bzr``.  Everything else is invoked as a
+subcommand of that, as is common in version control systems.
+
+A source directory containing some files to be versioned is called a
+*tree*; this contains a number of *files* and possibly some
+subdirectories.  The point of bzr is to keep track of the *versions*
+(or *revisions*) of the tree at various points in time.  A sequence of
+versions of a tree form a *branch*.  All branches begin with the empty
+directory, called the null revision.  Two branches may have some
+revisions in common and then *diverge* later -- which is why they're
+called branches.  We can distinguish the *working copy* of the files,
+which is available for modification, from their previous versions.
+
+Each file has a unique *file-id*, which remains the same for the life
+of the file, even when files are renamed.  Files also have a *kind*,
+which can currently be *file* or *directory*, and which cannot change
+for any file-id.
+
+The difference between two revisions is a *changeset*.  Changesets
+include the textual changes to files, the affected file-ids, the date
+of the change, the author, the name of the branch.  Changesets have a
+globally unique identifier.
+
+A changeset committed to a branch is *local* to that branch; otherwise
+it is foreign.  (Note that a changeset may be local to several
+different branches if it was created prior to their divergence.)
+
+Changesets may include a note that they *incorporate* other
+changesets; this is used when changes are merged from one branch into
+another.  After changes have been merged but before they are committed
+they are listed as *pending merges*; when they are committed they are
+listed within their changeset.
+
+All files in a versioned directory can be divided into four classes:
+
+Versioned
+  Anything assigned a file-id.  Changes to these files are tracked.
+Control
+  Anything under ``.bzr/``.  Should not be edited by users.
+Ignored
+  Anything matching an ignore pattern.  As the name suggests, ignored
+  by Bazaar.
+Unknown
+  Everything else.  Generally ignored, except that they are reported
+  as 'unknown' and can be added by a recursive add_.
+
+We say a tree, or a file, is *unmodified* if it is the same as in the
+most recent version, or *modified* otherwise.
+
+*Committing* creates a new revision equal to the current state of the
+tree.  Immediately after committing, all files are unmodified, since
+they are the same as the just-committed state.
+
+
+
+
+File states
+-----------
+
+A file is in exactly one of these *states*.  These are identified by
+single characters which should be familiar to people used to svn/cvs.
+
+?, Unknown
+    Not versioned, ignored, or control.
+    Typically new files that should be versioned or
+    ignored but have not been marked as either yet.
+., Up-to-date
+    This versioned file is the same as in the last revision on this
+    branch.  (The file had the same name and text and properties in
+    the previous revision.)
+A, Added
+    This file will be added by the next commit.  (The file ID was not
+    present in the previous revision.)
+M, Modified
+    This file has been changed from the previous revision and will be
+    recorded in the next commit.  (The file had the same name but
+    different text in the previous revision.)  Directories have no 
+    text and so can never be in this state.
+D, Deleted
+    This file has been removed from the inventory or deleted in the 
+    working copy and will be removed in the next revision.
+R, Renamed
+    This file had a different name in the previous revision; the next
+    commit will record the new name.  The file text may also have been
+    modified.
+
+These are only summaries, not complete descriptions.  For example the
+'D' state does not distinguish between a file removed by the remove_
+command and one whose text has been deleted.  (There should perhaps be
+a variation of the ``info`` command, or a ``file-info`` that shows
+enough details.)
+
+A directory may be up-to-date even if some files inside it have
+different states.
+
+.. _pinned: pinned.html
+
+
+
+Global options
+--------------
+
+These can be applied to many or all commands.
+
+--help     Show help, either globally or for the selected command.
+
+-v, --verbose  Show progress/explanatory information.  This is good if
+               for example using a slow network and you want to see
+               that something is happening.
+
+--debug    Show way too much detail about files being opened, locking,
+           etc.  Intended for
+
+--silent   Show nothing but errors.  (Perhaps unnecessary; you could
+           just redirect stdout to /dev/null.)
+
+--version  Show version and quit.
+
+--dry-run         Show what would be done, but don't make any
+                  permanent changes.
+
+--directory DIR   Operate in given directory rather than cwd.
+                  (Perhaps this should be ``-d``, but that might be
+                  better saved for ``--delete``.  Perhaps -b?)
+
+--recurse, -R     When a directory name is given, operate not only on
+                  that directory but also any files or directories
+                  contained within it.
+
+                  (XXX: Should this be on by default?  It will often
+                  be what people want, but also possibly more
+                  surprising.  If it is, we will want a
+                  ``--no-recurse``.)
+
+--force           Relax safety checks.
+
+--format=FORMAT
+   Choose output format; options might include XML, YAML, text.
+
+--id-only
+    Only update the inventory, don't touch the working copy.  (May
+    need a better name.)
+
+--show-ids
+    List file ids, as well as names.
+
+
+
+init
+----
+
+Create bzr control files in the current directory::
+
+    bzr init
+
+Use this, followed by add_ and then commit_ to import or start a new
+project.
+
+
+
+add
+---
+
+Add one or more files or directories to the branch::
+
+    bzr add FILE...
+
+Each added file is assigned a new file-id, and will be in the Added
+state.  They will be recorded in the next commit that covers that
+file, and then in the Up-to-date state.
+
++-------------+-------------------------------------------------+
+|File state   |Action                                           |
++=============+=================================================+
+|?            |New file id given to file; now in A state        |
++-------------+-------------------------------------------------+
+|I            |"Adding previously ignored file"; now in A       |
++-------------+-------------------------------------------------+
+|Z, ZM        |Add file with new ID; now in A state.            |
+|             |(To get the old ID back, use revert_ on that     |
+|             |file.)                                           |
++-------------+-------------------------------------------------+
+|U, A, M, R,  |Warning "already added"; no change               |
+|RM           |                                                 |
++-------------+-------------------------------------------------+
+|!, D         |Error "no such file"; no change                  |
++-------------+-------------------------------------------------+
+|#            |Error "cannot add control file"; no change       |
++-------------+-------------------------------------------------+
+
+--id ID
+      Add file with given ID rather than a random UUID.  Error if this
+      id is assigned to any other file.  (not implemented yet)
+
+--recurse
+    Add directory and all Unknown children, recursively.  This
+    includes U children of previously-added subdirectories.
+    (not implemented yet)
+
+This command will add any new source files, except for those matching
+ignore rules::
+
+  $ bzr add --recurse .
+
+(Note: I hope this might satisfy people who are fond of arch
+name-based tagging, and who dislike individually adding & removing
+files.  All they need to do is set up the appropriate ignore patterns,
+then 'add -R .' and they're done.)
+
+
+remove
+------
+
+Make a file no longer be versioned, and record its deletion from the
+inventory::
+
+    $ bzr remove FILE...
+
+This does not remove the working copy.  If you wish to both remove the
+working copy and unregister the file, you can simply delete it using
+regular ``rm``.  This is the opposite of add_.
+
+:State table:
+
++--------------+--------------------------------------------------+
+| File state   | Action                                           |
++==============+==================================================+
+| M, R, RM, .  | File to D state.                                 |
++--------------+--------------------------------------------------+
+| A            | File back to I or ? state                        |
++--------------+--------------------------------------------------+
+| I, ?, Z, ZM  | Error, no change                                 |
++--------------+--------------------------------------------------+
+| !            | Change to D                                      |
++--------------+--------------------------------------------------+
+| D            | Warning "already deleted"                        |
++--------------+--------------------------------------------------+
+| #            | "Cannot remove control file"                     |
++--------------+--------------------------------------------------+
+
+
+
+diff
+----
+
+Show all changes compared to the pristine as a text changeset.
+
+--full      Include details for even binary files, uuencoded.  Makes the
+            diff long but lossless.
+
+
+
+export
+------
+
+::
+
+    bzr export TO-DIR
+
+Copy the tree, but leave out Bazaar-NG control files.  This includes copying
+uncommitted changes.
+
+This is equivalent to copying the branch and then deleting the control
+directory (except more efficient).
+
+Should this also delete any other control files like ``.bzrignore``?
+
+
+
+status
+------
+
+Show which files are added/deleted/modified/unknown/missing/etc, as in
+subversion.
+
+Given the ``--check`` option, returns non-zero if there are any
+uncommitted changes.
+
+
+
+info
+----
+
+Display various information items about the branch.  Can be given
+various options to pull out particular fields for easier use in
+scripts.
+
+Should include:
+
+* branch name
+* parent
+* number of revisions
+* number of files that are versioned/modified/deleted/added/unknown
+* number of versioned directories
+* branch format version
+* number of people who have made commits
+* date of last commit
+
+
+
+delta
+-----
+
+Compute a two-way non-history-sensitive delta from one branch or
+version to another.  Basically a smart diff between the two.
+
+(Perhaps this should just be a ``--format`` option to diff_?)
+
+
+
+merge
+-----
+
+Merge changes in from another branch, and leave them uncommitted in
+this tree::
+
+   merge [FROM-BRANCH]
+
+This makes a note of the revisions which were merged.
+
+A range of revisions may be specified to cherry-pick changes from that
+branch, or to merge changes only up to a certain point.
+
+Merge refuses to run if there are uncommitted changes unless forced,
+so that merged changes don't get mixed up with your own changes.
+
+You can use a merge rather than an update to accomplish any of several
+things:
+
+* Merge in a patch, but modify it to either suit your taste or fix
+  textual or semantic conflicts.
+
+* Collapse several merged patches into a single changeset.  A feature
+  may go through many revisions when being developed on its own
+  branch, but you might want to hide that detail when it merges onto a
+  main branch.
+
+--revision RANGE  Merge only selected revisions, rather than
+                  everything that's not present yet.
+
+Before a merge is committed, it may be reversed with the revert_
+command.
+
+
+
+sync
+----
+
+::
+
+    sync [OTHER-BRANCH]
+
+--revision RANGE  Pull only selected revisions.
+
+Synchronize mirrored branches.
+
+A mirror branch is a branch that strictly follows a parent branch,
+without any changes being committed to it.  This is useful in several
+ways:
+
+* Moving a backup of a branch onto another machine to protect against
+  disk failure or laptop theft.
+
+* Making the complete history of a upstream branch available for
+  offline use.
+
+The result is the same as copying the whole branch, but it is more
+efficient for remote branches because only newly-added changesets are
+moved.   The result is similar to rsync except it respects Bzr locking.
+
+The same command can be used for push mirrors (changesets are moved
+from this branch to the other) or pull mirrors (vice versa).  Bzr
+automatically determines which to do by looking at which branch has
+more patches.   (Perhaps it would be clearer to have separate *push*
+and *pull* commands?)
+
+This command can only be used when the history of one branch is a
+subset of the other.  If you commit different changes to both
+branches, then ``sync`` will say that the branches have diverged and
+it will refuse to run.  This command also refuses to run if the
+destination branch has any uncommitted changes.  Uncommitted changes
+on the origin are not copied.
+
+Method:
+
+* Get the ordered list of change ids on both branches.
+
+* One list should be a prefix of the other; if not, fail.  The shorter
+  list will be the destination branch.
+
+* Check the destination has no uncommitted changes.
+
+* For each change present only in the origin, download it to the
+  destination, add to the changeset history and update the tree and
+  control files.
+
+
+
+commit
+------
+
+::
+
+   commit MESSAGE [WHAT]
+
+Commit changes from the working copy into the branch.  By default
+commits everything, but can be given a list of files directories or
+files.
+
+Partial commits (not implemented yet) should ideally be allowed even when the partial thing
+you want to commit is an add, delete or rename.  Partial commits are
+**not** allowed if patches have been merged in this change.
+
+Method:
+
+* check preconditions
+* get log, if not present or given on command line
+* re-check preconditions
+* calculate diff from pristine to working copy
+* store this diff, plus headers, into the patches directory
+* add the diff to the list of applied patches
+* update pristine tree
+
+Commit can optionally run some pre-commit and post-commit hooks,
+passing them the delta which will be applied; this might mail the
+delta or apply it to an export and run a test case there.
+
+:State table:
+
++-------------+-------------------------------------------------+
+|File state   |After commit                                     |
++=============+=================================================+
+|?, I, #      |Unchanged                                        |
++-------------+-------------------------------------------------+
+|A, M, R, RM  |Recorded, U                                      |
++-------------+-------------------------------------------------+
+|D            |Gone                                             |
++-------------+-------------------------------------------------+
+|Z, ZM        |Recorded, working copy remains as I or ?         |
++-------------+-------------------------------------------------+
+|!            |Error "file is missing"; must be deleted or      |
+|             |reverted before commit                           |
++-------------+-------------------------------------------------+
+
+
+
+lint
+----
+
+Check for problems in the working copy.
+
++-------------+-------------------------------------------------+
+|File state   |Lint output                                      |
++=============+=================================================+
+|?            |"Unknown file, please add/ignore/remove"         |
++-------------+-------------------------------------------------+
+|Z, ZM        |"Zombie file, please add/ignore/remove/revert"   |
++-------------+-------------------------------------------------+
+|!            |"File is missing, please recreate, delete or     |
+|             |revert."                                         |
++-------------+-------------------------------------------------+
+|A, M, D, R,  |No output                                        |
+|RM, #, I     |                                                 |
++-------------+-------------------------------------------------+
+
+
+
+check
+-----
+
+Run various consistency/sanity checks on the branch.  These might
+include:
+
+* Make sure all patches named by the inventory exist.
+
+* No patch IDs are duplicated.
+
+* Make sure hash of each patch is correct.
+
+* Starting at zero, apply each patch and make sure it does not
+  conflict.
+
+* All files named in inventory are reasonable.
+
+* No file IDs are duplicated in inventory.
+
+* Possibly many more.
+
+* No patches are in both ``patch-history`` and ``merged-patches``.
+
+* The patches in the bag are exactly those listed in ``patch-history``.
+
+Maybe add a separate option to say that you believe the tree is clean.
+
+
+
+backout
+-------
+
+Reverse the changes made by previous changesets::
+
+   bzr backout REVISION
+   bzr backout REV1 REV2
+
+If a single revision is given, that single changeset is backed out.
+If two revisions are given, all changes in that range are backed out.
+
+The change that is reversed need not be the most recently committed
+change, but if there are revisions after the ones to be reverse which
+depend on them this command may cause conflicts.
+
+This undoes the changes but remembers that it was once applied, so it
+will not be merged again.  Anyone who pulls from later versions of
+this tree will also have that patch reversed.
+
+You can backout a backout patch, etc, which will restore the previous changes.
+
+This leaves the changeset prepared but not committed; after doing this
+you should commit it if you want.
+
+You can also backout only the parts of  a changeset touching a
+particular file or subdirectory::
+
+  bzr reverse foo.c@31
+
+
+revert
+------
+
+Undo changes to the working copy of files or directories, and discard
+any pending merge notes::
+
+  $ bzr revert [FILE...]
+
+If no files are specified, the entire tree is reverted, which is
+equivalent to specifying the top-level directory.  In either case, the
+list of pending merges is also cleared.
+
+This does not affect history, only the working copy.  A corollary is
+that if no changes have been made to the working copy, this does
+nothing.
+
+If a file was Modified, it is returned to the last committed state,
+reversing changes to the working copy.  If the file has been Added, it
+is un-added but the working copy is not removed, so it returns to
+either the Unknown or Ignored state.  If the file has been Deleted, it
+is resurrected and returns to the Up-to-date state.  If the file is
+Unknown, Ignored, or a Control file then it is not changed and a
+warning is issued::
+
+  bzr: warning: cannot revert ignored file foo.c
+
+If the file has been Renamed, it is returned to its original name and
+any textual changes are reversed.  This may cause an error if the
+rename clashes with an existing file::
+
+  bzr: error: cannot revert foo.c to old name bar.c: file exists
+
+If a directory is listed, by default only changes to the directory
+itself are undone.
+
+Ideally this would not lose any changes, but rather just set them
+aside, so that the revert command would be undoable.  One way is to
+follow Arch and write out the discarded changes to a changeset file
+which can be either re-applied or discarded at a later date.  This
+very nicely allows for arbitrarily nested undo.  A simpler
+intermediate mechanism would be to just move the discarded files to
+GNU-style tilde backups.
+
+--merges        Clear the list of pending merges.  If files are
+                specified, their text is also reverted, otherwise no
+                files are changed.
+
+--id-only       Don't touch the working text, only the inventory.
+
+
++-------------+-------------------------------------------------+
+| File state  | Actions                                         |
++=============+=================================================+
+| A           | Returned to ? or I state, working text unchanged|
++-------------+-------------------------------------------------+
+| D           | Working copy restored, returned to U            |
++-------------+-------------------------------------------------+
+| Z           | Returned to U                                   |
++-------------+-------------------------------------------------+
+| ZM          | Working copy restored to previous               |
+|             | version, returned to U                          |
++-------------+-------------------------------------------------+
+| R           | Moved back to old                               |
+|             | name.                                           |
++-------------+-------------------------------------------------+
+| RM          | Moved back to old name and restored to previous |
+|             | text.                                           |
++-------------+-------------------------------------------------+
+|I, #, ?      | "Cannot revert"                                 |
++-------------+-------------------------------------------------+
+
+
+log
+---
+
+Show a log of changes::
+
+    bzr log
+
+By default shows all changes on this branch.
+
+The default format shows merged changes indented under the change that
+merged them.
+
+Alternatively changes can be sorted by date disregarding merges, which
+shows the order in which they were written not the order they were
+merged.  Changes which were merged are flagged as such.  Such an order
+is needed for a GNU-style ChangeLog.  The option is comparable to
+choosing a threaded or unthreaded display in an email client, and
+should perhaps have those names.
+
+Another option is to show just short descriptions of the merged
+changes, similar to arch.
+
+The log can be filtered in any of these ways:
+
+* Logs touching a particular file or directory.
+
+* Changes touching a particular file-id, regardless of what name it
+  had in the past.
+
+* Changes by a particular author.
+
+* Changes from a particular branch name (not necessarily the same
+  branch).
+
+Another option is to also include diffs (which may make it quite
+large).
+
+
+ignore
+------
+
+Mark a file pattern to be ignored and not versioned::
+
+    bzr ignore PATTERN
+
+The pattern should be quoted on Unix to protect it against shell
+expansion.
+
+The pattern is appended to ``.bzr-ignore``.  This file is created if
+it does not already exist, and added if it is not already versioned.
+bzr prints a message showing the pattern added so that people can see
+where to go to remove it::
+
+    $ bzr ignore \*.pyc
+    bzr: notice: created .bzr-ignored
+    bzr: notice: added pattern '*.pyc' to .bzr-ignore
+    $ bzr status
+    A      .bzr-ignore
+
+If the wrong pattern is added it can be removed by either editing
+``.bzr-ignore`` or by reverting__ that file.
+
+__ revert_
+
+
+is
+--
+
+Test various predicates against a branch, similar to the Unix shell
+``test`` command::
+
+    bzr is TEST [ARGS]
+
+Takes a third-level command:
+
+``clean``
+  Tree has no uncommitted changes.
+
+``in-tree``
+  Pwd is in a versioned tree.
+
+``in-control-dir``
+  Pwd is inside a Bazaar-NG control directory (and therefore should
+  not be modified directly).
+
+``tree-top``
+  Pwd is the top of a working tree.
+
+
+protect
+-------
+
+(Proposed idea, may not be implemented or may need a better name.)
+
+Sets a voluntary write-protect flag on a branch, to protect against
+accidental changes::
+
+    bzr protect
+    bzr unprotect
+
+This is typically used on branches functioning as tags, which should
+not normally be committed to or updated.
+
+There may, in the future, be a mechanism to allow only particular
+users to protect/unprotect a branch.
+
+
+uncommit
+--------
+
+(It is not certain this command will be implemented.)
+
+This command removes the most recent revision from the branch::
+
+    bzr uncommit
+
+This does not affect the working copy, which can be fixed up and a new
+commit run.  The new commit will have a different revision ID.
+
+Removal of the revision will not propagate to any other branches.
+
+The command may be repeated to successively remove more and more
+revisions.
+
+This command should perhaps have a more obviously dangerous name,
+since it can lose information or cause confusion.
+
+By default the revision is removed from the history, but its text is
+left in the store, which allows some chance of recovery.
+
+You cannot partially uncommit; you can however uncommit the whole
+revision and then re-commit just part of it.
+
+:Use cases:
+    `Wrong commit message`_
+
+
+.. _`Wrong commit message`: use-cases.html#wrong-commit-message
+
+
+
+find
+----
+
+Finds files, versions, etc in a branch::
+
+   bzr find [OPERATORS]
+
+The behaviour is similar to regular unix *find*, but this understands
+about bzr versioning.  Eventually this may gain all the
+and/or/grouping options of Unix find, but not yet.
+
+This does not have the quirky syntax of unix find, but rather just
+specifies commands as regular words.
+
+Operators:
+
+* ``directory``
+* ``file``
+* ``unknown``
+* ``ignored``
+
+By default the operators are anded together; there is also an ``or``
+operator.
+
+If no action is specified, just prints the file name.  Other actions:
+
+``print``
+    Print just the filename.
+``printf``
+    Print various fields about the object, using a formating system.
+``exec``
+    Execute a command on the file.
+

=== added file 'doc/common-format.txt'
--- doc/common-format.txt	1970-01-01 00:00:00 +0000
+++ doc/common-format.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,39 @@
+***********************
+Common changeset format
+***********************
+
+It might be useful to have a common changeset format for interchange
+between projects.
+
+It is not clear that you would be able to capture everything that
+every tool produces, but perhaps a lot could be done.
+
+Scenarios: (in order of difficulty?)
+
+ * dump/load
+
+ * convert repo from one tool to another
+
+ * one-way sync from exotic tool into read-only CVS or Svn repo
+
+ * two way sync between writable archives
+
+Perforce's RevML and ``vcp`` may be some use but apparently don't go
+all the way.
+
+Things like darcs and monotone may have such a different model that it
+may be hard to map them.
+
+Two-way sync may require keeping external state and is probably pretty
+hard.
+
+Apparently tlord tried to do something about this before but it
+stalled.
+
+Eventually perhaps we could arrange for someone to export key
+bitkeeper archives in this format, allowing all tools to read them in.
+
+Colin__ points the existing mailing list about this which is just a
+bunch of spam.
+
+__ http://web.verbum.org/blog/freesoftware/fsrc-responses

=== added file 'doc/compared-aegis.txt'
--- doc/compared-aegis.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-aegis.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,110 @@
+****************
+Ideas from Aegis
+****************
+
+* Very mature -- in use for 14 years, many large projects, etc.
+
+* "Essential process can be learned in a day" -- which is still kind
+  of a long time; i'd like it to be well under an hour.
+
+* Good process integration; show who is supposed to be working on what
+  and how far through they are.
+
+* Very poor Windows support.
+
+* Distributed repositories. (??)
+
+* Very focussed on security -- can reproduce any previous revision;
+  availability/integrity/confidentiality; uses Unix permissions and
+  seteuid() to prevent users changing the database.
+
+* Does not itself track history -- assumes this will be done by some
+  other tool such as RCS operating on the baseline.
+
+* I think every individual project needs a single baseline. (??)
+
+* The baseline is always working and always releasable -- to the
+  extent that you have scripts which can enforce this.
+
+* Integration step is somewhat similar to that used by distributed
+  systems.  It seems that you could build some features of aegis as
+  policy macros on top of Bazaar-NG.
+
+* The baseline also contains object files built from current source,
+  which can be used to pre-populate working directories.  Also people
+  only need a copy of the source files they're changing.  I think the
+  economics of this have changed a bit.  Also tends to assume all
+  developers are on the same Unix host, which is no longer generally
+  true.
+
+* Only one review/integration can be in process at a time.
+
+* One process difference is that developers produce all changes;
+  reviewers/integrators can only accept or reject them.  This is
+  different from the integrator-makes-right model of many distributed
+  tools.  (Though the integrator still has the choice to reject, but
+  they have the option of fixing it too.)
+
+* Can automatically append Signed-off-by field.  Interesting idea.  I
+  wonder if we should have a metadata facility to include licence
+  data?
+
+* Much of the functionality of Aegis is to prevent people doing things
+  they could otherwise do.  That can be useful in enforcing a healthy
+  process but bazaar-ng is not the place for it. 
+
+* Can serialize an (in-progress) changeset to text, and then mail from
+  one place to another.
+
+* Branches are an extension of the 'change' concept; they can be
+  merged into the parent in the same way that a change can be.
+
+  Merging branches onto the mainline seems to hit a similar problem to
+  that of centralized branches.  If someone else has committed, you
+  need to make a new changeset reconciling all their changes, commit
+  that to the child branch, then commit everything to the parent.
+
+  This suggests a different way to do shared branches in Bazaar-NG:
+
+    You can push to the parent if you incorporate either directly or
+    by merger all changes on the parent.  That means that everything
+    someone has committed to the parent is present in some way in your
+    branch.  By extension, it is safe to transform the parent text
+    into your branch without losing anything.  We can therefore
+    remotely record that changeset to the parent.  This is more or
+    less what Aegis does.
+
+    The problem with this in the Bazaar-NG model is that then the new
+    commit will be only in the parent, and not on the child.  So if
+    you run ``bzr log`` on the child, you won't see what you just
+    committed.  We can't apply it to both because the predecessor is
+    different.  (darcs could do that, but it has a looser patch
+    history than I want.)
+
+
+
+
+Overall, the process model is good for a particular type of
+organization.  It would be good to build this on top of Bazaar-NG.  To
+support that we need:
+
+ - patches are submitted, rather than being directly written in 
+
+ - arbitrary levels of branching/review
+
+ - users can submit changes to branches they are not directly allowed
+   to write to 
+
+ - branches can be cleanly removed when they're no longer necessary
+
+ - strong audit trail
+
+
+Interestingly, the BitKeeper model which is criticized__ by Greg
+Hudson is similar to that of Aegis: a single integrator (or small
+team?) who ultimately decide what gets into the main tree.
+
+__ http://web.mit.edu/ghudson/thoughts/bitkeeper.whynot
+
+
+The Aegis workflow can probably be `emulated in bzr <workflow.html>`_.

=== added file 'doc/compared-codeville.txt'
--- doc/compared-codeville.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-codeville.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,71 @@
+Codeville
+*********
+
+Documentation on how this actually works is pretty scarce to say the
+least.
+
+I *think* I understand their merge algorithm though, and it's pretty
+clever.  Basically we do a two-way merge between annotated forms of
+the two files: that is, with each line marked with the revision in
+which it last changed.  (I am simplifying here by speaking of lines
+and changes, but I don't think it causes any essential problem.)
+
+Now we walk through each file, line by line.  If the change that
+introduced the line state in branch A is already merged into branch B,
+then we can just take B.
+
+Now is this actually better?
+
+It may be better in several ways:
+
+* Do not need to choose just a single ancestor, but rather can
+  take advantage of all possible previous changes.
+
+* Can handle OTHER containing changes which have been merged into
+  THIS, but have then been overwritten.
+
+* Can handle cherrypicks(!) by remembering which lines came in from
+  that cherrypick; then we don't need to merge them again.
+
+Some questions:
+
+* Do we actually need to store the annotations, or can we just infer
+  it at the time we do the merge?
+
+* Can this be accomodated in something like an SCCS weave format?  I
+  think something like a weave may work, in as much as it is basically
+  a concatenation of annotations, but I don't know if it represents
+  merges well enough to cope.
+
+Can this handle binaries or type-specific merges, and if so how?
+Unmergeable binaries are easy: just get the user to pick one.  Things
+like XML are harder; we probably need to punt out to a type-specific
+three-way merge.  Of course this approach does not forbid also
+offering a 3-way merge.
+
+----
+
+I suppose this could be accomodated by an annotation cache on top of
+plain history storage, or by using a storage format such as a weave
+that can efficiently produce annotation information.
+
+That is to say there is nothing inherently necessary about remembering
+the line history at the point when it is committed, except that it
+might be more efficient to do this once and remember it than to 
+
+----
+
+There is another interesting approach that can be used even in a tool
+that does not inherently remember annotations:
+
+Given two files to merge, find all regions of difference.  For each
+such, try to find a common ancestor having the same content for the
+region.  Subdivide the region if necessary.
+
+This naive approach is probably infeasible, since it would mean
+checking every possible predecessor.
+
+----
+
+So the conclusion is that this is very cool, but it does not require a
+fundamental change of model and can be implemented later.

=== added file 'doc/compared-cvsnt.txt'
--- doc/compared-cvsnt.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-cvsnt.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,32 @@
+*****
+CVSNT
+*****
+
+
+http://www.cvsnt.com/cvspro/
+
+ * Remembers last-merge-point__ between two branches, and uses this to
+   do smarter incremental merges.
+
+__ http://www.cvsnt.org/wiki/MergePoint
+
+http://www.cvsnt.org/wiki/CvsntAdvantages
+
+ * SSPI authentication on Windows, and built-in Putty SSH code.
+
+ * Branch ACLs.
+ 
+ * Remote user administration using cvs passwd command.
+
+ * Repository browsing via cvs ls command (update: now provided in
+   standard CVS since version 1.12.9)
+
+ * LockServer on a second port replaces filesystem-based locks &
+   provides file level locking
+
+
+Various other improvements relative to CVS, particularly for Windows
+users.  Worth looking at, but nothing apparently earth-shaking.
+
+Interesting that the advanced merge support is basically that it
+remembers what was pulled across.
\ No newline at end of file

=== added file 'doc/compared-opencm.txt'
--- doc/compared-opencm.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-opencm.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,36 @@
+******************
+Compared to OpenCM
+******************
+
+  http://opencm.org/
+
+
+Not very stable; apparently inactive.  
+
+* Separated working copy & repository model.
+
+* Files have long-lived identifiers.
+
+* Files and revisions identified by the SHA-1 hash of their content
+  (as in monotone); explicitly makes it easier to be sure we have the
+  right one and prevents some tricks.
+
+* Binding of objects to external names done on the client, so you can
+  version e.g. database objects, instead of files.
+
+* Directories are inferred by having files that exist under them;
+  empty directories are a special case with an object of type DIR.
+  
+  This is a bit ugly.  I might rather have files given a name only
+  relative to their parent directory.  So renaming a directory will
+  only update the entry for the directory, and everything will move
+  with it.
+
+* Access-control rules about who can write to a central server. 
+
+* Their design is somewhat similar to ours and used a lot of disk
+  space -- enough to be a significant problem.
+
+* Assigning human names to branches proved problematic -- i think this
+  is a good reason to rely on the filesystem/URL space, which people
+  already know how to manage and deal with.

=== added file 'doc/compared-prcs.txt'
--- doc/compared-prcs.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-prcs.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,49 @@
+********************
+Comparison with PRCS
+********************
+
+  http://prcs.sourceforge.net/
+
+* No network support; no Windows or Mac support.
+
+* Long-lived file IDs, generated from .  Files can be reintroduced
+  after they are deleted. 
+
+* Named branches.
+
+* Custom keyword replacement: can specify keywords such as the release
+  number.  Commands to update keywords, and to strip them out.
+  Separate ``rekey`` command can be used after a checkin to bring
+  keywords up to date.
+
+* Users are allowed to edit the manifest file, which also contains
+  some system-maintained data.  This apparently works OK but I think
+  it makes people uncomfotable.
+
+* ``populate`` command adds all unversioned files and unregister files
+  which are no longer present.
+
+* Merge algorithm is similar to the best-parent three-way merge we're
+  planning on using; in particular it remembers merged parents to help
+  with later choices.
+
+* ``$Format$`` feature useful in generating arbitrary tags inside text,
+  example__::
+
+    /* $Format: "static char* version = \"$ProjectVersion$\";"$ */
+    static char* version = "x.x";
+
+  transformed to::
+
+    /* $Format: "static char* version = \"$ProjectVersion$\";"$ */
+    static char* version = "1.2";
+
+  Also a good bundle of other keywords.
+
+* ``prcs execute`` is like find-xargs; perhaps easier to have a
+  find/exec pattern.
+
+__ http://svn.haxx.se/dev/archive-2004-12/1065.shtml
+
+
+Should have a look at their storage format; probably pretty efficient.
\ No newline at end of file

=== added file 'doc/compared-teamware.txt'
--- doc/compared-teamware.txt	1970-01-01 00:00:00 +0000
+++ doc/compared-teamware.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,34 @@
+Compared to Sun Teamware
+************************
+
+(**note**: I have never used Sun Teamware, so this document is just
+based on public documentation and information from other people.
+Corrections would be appreciated.)
+
+http://docs.sun.com/app/docs/doc/806-3573
+
+Needless to say bazaar-ng is currently far less mature, and some of
+the advantages listed below don't work in the current pre-1.0 code.
+But they are accounted for in the design.
+
+TeamWare has file locking.  Distributed systems can't easily support
+file locking because you can't prevent people diverging.  But perhaps
+we can have scripts or a higher-level tool to communicate that changes
+to a particular file are in train.  (One possibility: there is a
+development branch where that file has been changed, but not yet
+checked in.  Or if Bob can see Alice's work area, he can see that a
+particular file has been fetched read/write.)
+
+parent/child workspaces.
+
+Advantages of bazaar-ng:
+
+* Free / open source software
+
+* Prior tree revisions are always exactly reproducible (atomic
+  changesets, etc)
+
+* Can get whole-tree diff
+
+* Versioned, mergeable renames.
+

=== added file 'doc/compression.txt'
--- doc/compression.txt	1970-01-01 00:00:00 +0000
+++ doc/compression.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,66 @@
+Compression
+***********
+
+At the moment bzr just stores the full text of every file state ever.
+(Files unmodified from one revision are stored only once.)
+
+This is simple to write, and adequate for even reasonably large trees
+with many versions.  Disk is very cheap.  
+
+Eventually we might like something more compressed, but this is
+neither an interesting nor urgent problem.  (Not "interesting" in the
+sense that doing it is just a matter of coding; there is no
+theoretical problem or risk.)  
+
+There are various possibilities:
+
+* Store history of each file in RCS, relying on RCS to do line-by-line
+  delta compression.  (Does not handle binaries very well.)
+
+  OpenCMS paper has a horror story about using RCS for file storage.
+
+* Store full copies of each file in a container with gzip compression,
+  which should fairly efficiently eliminate unchanged areas.  This
+  works on binaries, and gives compression of file text as a side
+  benefit.
+
+  (Note that ``.zip`` will *not* do for this, because every file is
+  compressed independently.)
+  
+  The OpenCMS paper notes that RCS storage is only 20% more efficient
+  than gzip'd storage of individual file versions.
+
+* Store history of each file in SCCS; allows quick retrieval of any
+  previous state and may give more efficient storage than RCS.  Allows
+  for divergent branches within a single file.
+
+* Store xdeltas between consecutive file states.
+
+* Store xdeltas according to a spanning delta algorithm; this probably
+  requires files are stored with some kind of sequence number so that
+  we can predict related version names.
+
+* Store in something like XDFS.
+
+* Any of the above, but with the final storage in some kind of
+  database: psql, sqlite, mysql, whatever is convenient.   
+
+  It should be something that is safe across system crashes, which
+  rules out tdb at the moment.
+
+----
+
+These properties are seen as desirable in darcs and arch:
+
+* Passive HTTP downloads: without requiring any server-side
+  intelligence, a client can get updates from one version to the next
+  by requesting a set of self-contained files.  
+
+  The number of files necessary to do this must not be unfeasibly
+  large, and the size of each of those files should be proportionate
+  to the amount of actual change.  In other words the data downloaded
+  should be of comparable size to the actual edits between the trees.
+
+
+* Write-once storage: once a file is written to the repository, it is
+  not modified.

=== added file 'doc/config-specs.txt'
--- doc/config-specs.txt	1970-01-01 00:00:00 +0000
+++ doc/config-specs.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,47 @@
+************
+Config specs
+************
+
+A *config spec* is a set of instructions for assembling a source tree
+from separately maintained branches.  This is like CVS's "modules"
+format.  Config specs are very commonly used in Clearcase, and the
+main way of getting a new checkout.
+
+Scenarios:
+
+ * One module is shared by several projects, and it needs to be
+   present in a subdirectory of their trees to build.
+
+ * There are different commit or stability rules for different parts
+   of a tree.
+
+The simplest form is just a specification of branch sources, and where
+they should be assembled into the tree.  Example::
+
+  .              http://foo.net/fooapp
+  ./libbaz       http://foo.net/libbaz
+
+Normally the entire branch will be placed at this point, but sometimes
+subdirectory should be selected.  Selecting just a single file rather
+than subdirectory might be problematic because we wouldn't have
+anywhere to put the control files.
+
+Each branch will have a .bzr directory at the top level.  Changes on
+each branch can be pushed back independently.
+
+The tool needs to support (and be tested with) nested checkouts.
+Commands should normally only apply to a single tree, but there might
+be an option to descend into nested trees.
+
+One very important use case is a naive user checking out a tree that
+happens to use a configspec.  This is transparent in cvs, but not at
+all so in Arch.
+
+The ``svn:externals`` mechanism in Subversion works like this.
+
+One interesting idea from Aaron is that all branches should be like
+this: the latest-patch pointer can be generalized to in fact name
+several patches that should be assembled in subdirectories.  A
+simplest branch names just one, assembled to the base directory.  You
+might want to specify the parent branches for each one as well....
+

=== added file 'doc/conflicts.txt'
--- doc/conflicts.txt	1970-01-01 00:00:00 +0000
+++ doc/conflicts.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,45 @@
+Types of conflict
+*****************
+
+The following types of conflict can be encountered during a merge, or
+a merge-like operation (such as resyncing local changes with
+upstream):
+
+Aaron's list:
+
+* Parent directory missing when attempting to add a file
+
+* Attempt to create directory that already exists
+
+* Some patch hunks failed to apply
+
+* While changing permissions, the "old" permissions in the changeset do
+  not match the file.
+
+* While replacing contents of a file, the old contents of a file do not
+  match the changeset
+
+* Attempt to remove non-empty directory: This only occurs when the
+  directory has contents that it didn't have the last time it was deleted.
+  It's pretty easy to handle adds, renames and deletes for exact
+  patching.  There's no need to rm -rf directories as tla does.
+
+* Attempt to create a symlink when there is already a file/dir/etc with
+  that name
+
+* Attempt to apply a patch to a file that does not exist
+
+* Attempt to remove a file that does not exist
+
+* Attempt to rename a file that does not exist
+
+* Attempt to change permissions of a file that does not exist
+
+* Can't determine filename during three-way merging
+
+* Can't determine file parent directory during three-way merging
+
+* Can't determine file permissions during three-way merging
+
+Aaaron says: I have no doubt there are more.  For example, attempt to
+change permissions of a symlink.

=== added file 'doc/costs.txt'
--- doc/costs.txt	1970-01-01 00:00:00 +0000
+++ doc/costs.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,21 @@
+Costs
+=====
+
+User thought is most expensive.  User time spent waiting is next.
+Developer time for the version control system is also relatively
+expensive.  
+
+Machine resources are cheap.  In particular; disk is generally very
+cheap; an ordinary programmer earns enough to buy hundreds of GB of
+disk per day.  However, it is sometimes limited, as on a laptop.
+Therefore it is generally OK to trade off disk space for anything
+else, but it should be possible to be compact.
+
+Network round trips are very bad.
+
+Consider scalability also; avoid anything worse than O(n).  Try to
+avoid anything that needs e.g. to hold the whole tree in memory at any
+time, or to hold the entire history of the project.
+
+
+

=== added file 'doc/darcs.txt'
--- doc/darcs.txt	1970-01-01 00:00:00 +0000
+++ doc/darcs.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,39 @@
+Darcs compared to Arch
+======================
+
+Simpler to use; perhaps harder to completely understand.
+
+Always local; always fast.
+
+Patch commution is slow and perhaps doesn't clearly do what people
+want.  
+
+Too slow!
+
+Can't reliably get back to any previous point.  Explicitly not
+addressing source archive/librarian function.
+
+Loads everything into memory.
+
+Written in Haskell.
+
+Breaking commits into hunks at commit time is interesting, but I think
+not totally necessary.  Sometimes it won't break hunks where you want
+it. 
+
+A really simple pre-commit check hook is remarkably useful.
+
+http://www.scannedinavian.org/DarcsWiki/DifferencesFromArch
+
+Token replace
+-------------
+
+Very cute; possibly handy; not absolutely necessary in most places.
+Somewhat limited by the requirement that it be reversible.
+
+This is one of very few cases where it does seem necessary that we
+store deltas, rather than tree states.  But that seems to cause other
+problems in terms of being able to reliably sign revisions.
+
+This can perhaps be inferred by a smart 3-way merge tool.  Certainly
+you could have it do sub-line merges.

=== added file 'doc/deadly-sins.txt'
--- doc/deadly-sins.txt	1970-01-01 00:00:00 +0000
+++ doc/deadly-sins.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,50 @@
+**************************
+Deadly sins in tool design
+**************************
+
+http://gcc.gnu.org/wiki/DeadlySins
+
+They don't directly apply, but many do correspond.
+
+  The "Deadly Sins" from P. J. Brown's *Writing Interactive Compilers and Interpreters*, Wiley 1979. We've committed them all at least once in GCC.
+
+  The deadly sins are:
+
+  1. to code before you think.
+
+  2. to assume the user has all the knowledge the compiler writer has.
+
+  3. to not write proper documentation.
+
+  4. to ignore language standards.
+
+  5. to treat error diagnosis as an afterthought.
+
+  6. to equate the unlikely with the impossible.
+
+  7. to make the encoding of the compiler dependent on its data formats.
+
+  8. to use numbers for objects that are not numbers.
+
+  9. to pretend you are catering to everyone at the same time.
+
+  10. to have no strategy for processing break-ins.
+
+      (A break-in is when you interrupt an interactive compiler, and
+      then possibly continue it later. This is meaningful in an
+      environment in which the compiler is run dynamically, such as
+      many LISP and some BASIC environments. It is not meaningful for
+      typical uses of C/C++ (although there was at least one
+      interactive C environment, from Sabre).)
+
+      (Perhaps this corresponds to handling user interrupts during
+      operation -- they should not leave anything in an inconsistent
+      state.)
+
+  11. to rate the beauty of mathematics above the usability of your
+      compiler.
+
+  12. to let any error go undetected.
+
+  13. to leave users to find the errors in your compiler.
+

=== added file 'doc/design.txt'
--- doc/design.txt	1970-01-01 00:00:00 +0000
+++ doc/design.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,1172 @@
+****************
+Bazaar-NG design
+****************
+
+
+:Author:
+  Martin Pool <mbp@sourcefrog.net>
+
+:Date: December 2004, Noosa.
+
+.. sectnum::
+.. contents::
+
+
+Abstract
+--------
+
+  *Bazaar-NG should be a joy to use.*
+
+  What if we started from scratch and tried to take the best features
+  from darcs, svn, arch, quilt, and bk?
+
+  Don't get the sum of all features; rather get the minimum features
+  that make it a joy to use.  Choose simplicity, in both interface and model.
+  Do not multiply entities
+  beyond necessity.
+
+  *Make it work; make it correct; make it fast* -- Ritchie(?)
+
+
+
+Design model
+------------
+
+* Unify archives and branches; one archive holds one branch.  If you
+  want to publish multiple branches, just put up multiple directories.
+
+* Explicitly add/remove files only; no names or tagline tagging.  If
+  someone wants to do heuristic detection of renames that's fine, but
+  it's not in the core model.
+
+Quilt indicates an interesting approach: patches themselves are the
+thing we're trying to build.  We don't just want a record of what
+happened, but we want to build up a good description of the change
+that will be implied when it's integrated.  This implies that we want
+to be able to change history quite a lot before merging upstream; or
+at least change our description of what will go up.
+
+
+Principles
+----------
+
+* Unix design philosophy (via Peter Miller), tempered by modern
+  expectations:
+
+  - least unnecessary output
+
+  - little dependence on *specific* external tools
+
+  - short command lines
+
+  - least overlap with cooperating tools
+
+* `Worse is better`__
+
+__ http://www.jwz.org/doc/worse-is-better.html
+
+ - *Simplicity: the design must be simple, both in implementation and
+   interface. It is more important for the implementation to be
+   simple than the interface. Simplicity is the most important
+   consideration in a design.*
+
+ - *Correctness: the design must be correct in all observable
+   aspects. It is slightly better to be simple than correct.*
+
+
+ - *Consistency: the design must not be overly inconsistent. Consistency
+   can be sacrificed for simplicity in some cases, but it is better to
+   drop those parts of the design that deal with less common
+   circumstances than to introduce either implementational complexity
+   or inconsistency.*
+
+ - *Completeness: the design must cover as many important situations as
+   is practical. All reasonably expected cases should be
+   covered. Completeness can be sacrificed in favor of any other
+   quality. In fact, completeness must sacrificed whenever implementation
+   simplicity is jeopardized. Consistency can be sacrificed to achieve
+   completeness if simplicity is retained; especially worthless is
+   consistency of interface.*
+
+* Try to get a reasonably tasteful balance between having something
+  that works out of the box but also has composable parts.  Provide
+  mechanism rather than policy but not to excess.
+
+* Files have ids to let us detect renames without having to walk the
+  whole path.  
+
+  If there are conflicts in ids they can in principle be resolved.
+  There might be a ``merge --by-name`` to allow you to force two trees
+  into agreement on IDs.  If the merge sees two files with the same
+  name and text then it should conclude that the files merged.
+
+  It would be nice if there were some way to make repeated imports of
+  the same tree give the same ids, but I don't think there is a safe
+  feasible way.  Sometimes files start out the same but really should
+  diverge; boilerplate files are one example. 
+
+* Archives are just directories; if you can read/write the files in
+  them you can do what you need.  This works even over http/sftp/etc.
+  Or at least this should work for read-only access; perhaps for
+  writing it is reasonable to require a svn+ssh style server invoked
+  over a socket.  
+
+  Of course people should not edit the files in there by hand but in
+  an emergency it should be possible.
+
+* Storing archives in plain directories means making some special
+  effort to make sure they can be rolled back if the commit is
+  interrupted any time.  On truly malicious filesystems (NFS) this may
+  be quite difficult, but at a minimum it should be possible to roll
+  back whatever was uncommitted and get to a reasonable state.  It
+  should also be reasonably possible to mirror branches using rsync,
+  which may transfer files in arbitrary order and cannot handle files
+  changing while in flight.  
+
+  Recovering from an interrupted commit may require a special ``bzr
+  fix`` command, which should write the results to a new branch to
+  avoid losing anything.
+
+* Branches carry enough information to recreate any previous state of
+  the branch (including its ancestors).  
+
+  This does not necessarily mean holding the complete text of all
+  those patches, but we do store at least a globally unique identifier
+  so that we can retrieve them.
+
+* Commands should correspond to svn or cvs as much as possible: add,
+  get, copy, commit, diff, status, log, merge. 
+
+* We have all the power of mirroring, but without needing to introduce
+  special concepts or commands.  If you want somebody's branch
+  available offline just copy it and keep updating to pull in their
+  changes; if you never make any changes the updates will always
+  succeed.
+
+* It is useful to be able to easily undo a previous change by
+  committing the opposite.  I had previously imagined requiring all
+  patches to be stored in a reversible form but it's enough to just do
+  backwards three-way merges.
+
+* Patches have globally unique IDs which uniquely identify them.
+
+* As a general principle we separate identification (which must be
+  globally unique) from naming (which must be meaningful to users).
+  Arch fuses them, which makes the human names long and prevents them
+  ever being reused.  Monotone doesn't have human-friendly names.
+
+* Users are identified by something like an email address;
+  ``user@domain``.  This need not actually be a working email
+  address; the point is just to piggyback on domain names to get
+  human-readable globally unique names.
+
+* Everything will be designed from the beginning to be safe and
+  reasonable on Windows and Unix.
+
+* History is append-only.  Patches are recorded along with the time at
+  which they were committed; if time steps backwards then we give a
+  warning (but probably commit anyhow.)  This means we can reliably
+  reproduce the state of the branch at any previous point, just by
+  backing out patches until we get back there.
+  
+  This is also true at a physical level as much as possible; once a
+  patch is committed we do not overwrite it.  This should make it less
+  likely that a failure will corrupt past history.  However, we may
+  need some indexes which are updated rather than replaced; they
+  should probably be atomically updated.
+
+* Storage should be reasonably transparent, as much as possible.  (ie
+  don't use SQLite or BDB.)  At the same time it should be reasonably
+  efficient on a wide range of systems (ie don't require reiserfs to
+  work well.)
+  
+  Programmers who look behind the covers should feel comfortable that
+  their data is safe, and hopefully pleased that the design is
+  elegant.
+
+* Unrecognized files cause a warning when you try to commit, but you
+  can still commit.  (Same behavior as CVS/Subversion; less discipline
+  than Arch.)
+
+  If you wish, you can change this to fail rather than just warn; this
+  can be done as tree policy or as an option (eg ``commit --strict``)
+
+* Files may be ignored by a glob; this can be applied globally (across
+  the whole tree) or for a particular directory.  As a special
+  convenience there is ``bzr ignore``. 
+
+* If branches move location (e.g. to a new host or a different
+  directory), then everyone who uses them needs to know the new URL by
+  some out-of-band method.
+
+* All operations on a branch or pair of branches can be done entirely
+  with the information stored in those branches.  Bazaar-NG never needs to
+  go and look at another branch, so we don't need unique branch names
+  or to remember the location of branches.
+
+* Store SHA-1 hashes of all patches, also store hashes of the tree
+  state in each revision.  (We need some defined way to make a hash of
+  a tree of files; for a start we can just cat them together in order
+  by filename.)
+  
+  Hashes are stored in such a way that we can switch hash algorithms
+  later if needed if SHA-1 is insecure.
+
+* You can also sign the hashes of patches or trees.
+
+* All branches carry all the patches leading up to their current
+  state, so you can recreate any previous state of that branch,
+  including the branches leading up to it.
+
+* A branch has an append-only history of patches committed on this
+  branch, and also an append-only history of patches that have been
+  merged in.
+
+* A commit log message file is present in .bzr-log all the time; you
+  can add notes to it as you go along.  Some commands automatically
+  add information to this file, such as when merging or reversing
+  changes. 
+  
+  The first line of the message is used as the summary.
+
+* Commands that make changes to the working copy will by default baulk
+  if you have any uncommitted changes.  Such commands include ``merge``
+  and ``reverse``.  This is done for two reasons: to avoid losing your
+  changes in the case where the merge causes problems, and to try to
+  keep merges relatively pure.  You can force it if you wish.
+
+  (*pull* is possibly a special case; perhaps it should set aside
+  local changes, update, and then reapply them/remerge them?)
+
+* Within a branch, you can refer to commits by their sequence number;
+  it's nice and friendly for the common case of looking at your
+  commits in order.
+
+* You can generate a changelog any time by looking at only local
+  files.  Automatically including a changelog in every commit is
+  redundant and so can be eliminated.  Of course if you want to
+  manually maintain a changelog you can do that too.
+
+* At the very least we should have ``undo`` as a reversible
+  ``revert``.  It might be even better to have a totally general undo
+  which will undo any operation; this is possible by keeping a journal
+  of all changes.
+
+* Perhaps eventually move to storing changesets in single text files,
+  containing file diffs and also information on renames, etc.  The
+  format should be similar to that of ``tla show-changeset``, but
+  lossless. 
+
+* Pristines are kept in the control directory; pristines are
+  relatively expensive to recreate so we might want to keep more than
+  one.  
+
+  (Robert says that keeping pristines under there can cause trouble
+  with people running recursive commands across the source tree, so
+  there should probably be some other way to do it.  If pristines are
+  identified by their hash then we can have a revlib without needing
+  unique branch names.)
+  
+* Can probably still have cacherevs for revisions; ideally
+  autogenerated in some sensible way.  We know the tree checksum for
+  each revision and can make sure we cached the right thing.
+
+* Bazaar-NG should ideally combine the best merging features of
+  Bitkeeper and Arch: both cherry-picking and arbitrary merging within
+  a graph.  The metaphor of a bazaar or souk is appropriate: many
+  independent agents, exchanging selected patches at will.
+
+* Code should be structured as a library plus a command-line client;
+  the library could be called from any other client.  Therefore
+  communication with the user should go through a layer, the library
+  should not arbitrarily exit() or abort(), etc.
+
+* Any of these details are open to change.  If you disagree, write and
+  say so, sooner rather than later.  There will be a day in the future
+  where we commit to compatibility, but that is a while off.
+
+* Timestamps obviously need to be in UTC to be meaningful on the
+  network.  I guess they should be displayed in localtime by default
+  and you can change that by setting $TZ or perhaps some option like
+  ``--utc``.  It might be cool to also capture the local time as an
+  indicator of what the committer was doing.
+
+* Should probably have some kind of progress indicator like --showdots
+  that is easy to ignore when run from a program (especially an
+  editor); that probably means avoiding tricks with carriage return.
+  (That might be a problem on Windows too.)
+
+* What date should be present on restored files?  We don't remember
+  the date of individual files, but we could set the date for the
+  entire commit.
+
+* One important layer is concerned with reproducing a previous
+  revision from a given branch; either the whole thing or just a
+  particular file or subdirectory.  This is used in many different
+  places.  We can potentially plug in different storage mechanisms
+  that can do this; either a very transparent and simple file-based
+  store as in darcs and arch, or perhaps a more tricky/fast
+  database-based system.         
+
+
+Entities and terminology
+------------------------
+
+The name of the project is *Bazaar-NG*; the top-level command is
+``bzr``.
+
+Branch
+''''''
+
+Development in Bazaar-NG takes places on branches.  A branch records
+the progress of a *tree* through various *revisions* by the
+accumulation of a series of *patches*.
+
+We can point to a branch by specifying its *location*.  At first this
+will be just a local directory name but it might grow to allow remote
+URLs with various schemes.
+
+Branches have a *name* which is for human convenience only; changesets
+are permanently labelled with the name of the branch on which they
+originated.  Branch names complement change descriptions by providing
+a broader context for the purpose of the change.  Typically the branch
+name will be the same as the last component of the directory or path.
+
+There is no higher-level grouping than branches.  (Nothing that
+corresponds to repositories in CVS or Subversion, or
+archives/categories/versions in Arch.)  Of course it may be a good
+practice to keep your branches organized into directories for each
+project, just as you might do with tarballs or cvs working
+directories.  
+
+Bazaar-NG makes forking branches very easy and common.  
+
+
+
+Revision
+''''''''
+
+The tree in a branch at a particular moment, after applying all the
+patches up to that point.
+
+
+File id
+'''''''
+
+A UUID for a versioned file, assigned by ``bzr add``.
+
+
+Delta
+'''''
+
+A smart diff, containing:
+
+* unidiff hunks for textual changes
+
+* for each affected file, the file id and the name of that file before
+  and after the delta (they will be the same if the file was not renamed)
+
+* in future, possibly other information describing symlinks,
+  permissions, etc
+
+A delta can be generated by comparing two trees without needing any
+additional input. 
+
+Although deltas have some diff context that would allow fuzzy
+application they are (almost?) always exactly applied to the correct
+predecessor. 
+
+
+Changeset
+'''''''''
+
+(also known as a patch)
+
+A changeset represents a commit to a particular branch; it
+incorporates a *delta* plus some header information such as the name
+of the committer, the date of the commit, and the commit message.
+
+
+Tree
+''''
+
+A tree of files and directories.  A branch minus the Bazaar-NG control files.
+
+
+
+
+Syntax
+------
+
+Branches
+''''''''
+
+Branches are identified by their directory name or URL::
+
+  bzr branch http://kernel.org/bzr/linux/linux-2.6
+  bzr branch ./linux-2.6 ./linux-2.6-mbp-partitions
+
+Branches have human-specified names used for tracing patches to their
+origin.  By default this is the last component of the directory name. 
+
+
+Revisions
+'''''''''
+
+Revisions within a branch may be identified by their sequence number
+on that branch, or by a tag name::
+
+  bzr branch ./linux-2.6@43 ./linux-2.6-old
+  bzr branch ./linux-2.6@rel6.8.1 ./linux-2.6.8.1
+
+You may also use the UUID of the patch or by the hash of that
+revision, though sane humans should never (need to) use these::
+
+  bzr log ./linux-2.6@uuid:6eaa1c41-34b8-4e0e-8819-acb5dfcabb78
+  bzr log ./linux-2.6@hash:4bf00930372cce9716411b266d2e03494f7fe7aa
+
+Revision ranges are given as two revisions separated by a colon (same
+as Svn):
+
+  bzr merge ../distcc-doc@4:10 
+
+
+Authors
+'''''''
+
+Authors are identified by their email address, taken from ``$EMAIL``
+or ``$BZR_EMAIL``.
+
+
+
+
+Tree inventory
+--------------
+
+When a revision is committed, Bazaar-NG records an "inventory"  which
+essentially says which version of each file should be assembled into
+which location in the tree.  It also includes the SHA-1 hash and the
+size of each file.
+
+
+
+Merging
+-------
+
+Merges are carried out in Bazaar-NG by a three-way merge of trees.  Users
+can choose to merge all changes from another branch, or a particular
+subset of changes.  In either case Bazaar-NG chooses an appropriate
+common base appropriately, although there should perhaps also be an
+option to specify a different base.
+
+I have not solved all the merge problems here.  I do think that this
+design preserves as much information as possible about the history of
+the code and so gives a good foundation for smart merging.
+The basic merge operation is a 3-way diff: we have three files *BASE*,
+*OTHER* and *MINE* and want to produce a result.  There are many
+different tools that could be used to resolve this interactively or
+automatically. 
+
+There are some cases where the best base is not a state that ever
+occurred on the two branches.  One such case is when there are two
+branches that have both tracked an upstream branch but have never
+previously synced with each other.  In this case we suggest that
+people manually specify the base::
+
+  bzr merge --base linus-2.6 my-2.6 
+
+Merges most commonly happen on files, but can also occur on metadata.
+For example we may need to resolve a conflict between file ids to
+decide what name a file should have, or conversely which id it should
+have.
+
+When merging an entire branch, the base is chosen as the last revision
+in which the trees manifests were identical.
+
+If merging only selected revisions from a branch (ie cherry picking)
+then the base is set just before the revisions to be merged.
+
+A three-way merge operates on three inputs: THIS, OTHER, and a BASE.
+Any regions which have been changed in only one of THIS and OTHER, or
+changed the same way in both will be carried across automatically.
+Regions which differ in all three trees are conflicts and must be
+manually resolved.
+
+The merge does not depend upon any states the trees may have
+passed through in between the revisions that are merged. 
+
+After the merge, the destination tree incorporates all the patches
+from the branch region that was merged in.  
+
+
+
+Sending patches by email
+------------------------
+
+Patches can be sent to someone else by email, just by posting the
+string representation of the changeset.  Could also post the GPG
+signature.
+
+The changeset cannot itself contain its uniquely-identifying hash.
+Therefore I suppose it needs some kind of super-header which says what
+the patch id is; this can be verified by comparing it to the hash of
+the actual changeset.  This in turn applies that the text must be
+exactly preserved in email, so possibly we need some kind of
+quoted-printable or ascii-armoured form.
+
+Another approach would be to not use the hash as the id, but rather
+something else which allows us to check the patch is actually what it
+claims to be.  For example giving a GPG key id and a UUID would do
+just as well, and *would* allow the id to be included within the
+patch, as would giving an arch-style revision ID, assuming we can
+either map the userid to a GPG key and/or check against a trusted
+archive. 
+
+There are two ways to apply such a received patch.  Ideally it tells
+us a revision of our branch from which it was based, probably by
+specifying the content hash.  We can use that as the base, make a
+branch there, apply the patch perfectly, and then merge that branch
+back in through a 3-way merge.  This gives a clean reconciliation of
+changes in the patch against any local changes in the branch since the
+base.
+
+If we do not have the base for the patch we can try apply it using
+a similar mechanism to regular patch, which might cause conflicts.  Or
+maybe it is not worth special-casing this; we could just require
+people to have the right basis to accept a patch.
+
+
+
+Rewriting history
+-----------------
+
+History is generally append-only; once something is committed it
+cannot be undone.  We need this to make several important guarantees
+about being able to reconstruct previous versions, about patches being
+consistent, and so on and on.
+
+However, pragmatically, there are a few cases where people will insist
+on being able to fudge it.  We need to accommodate those as best we
+can, within the limits of causality.  In other words, what is
+physically and logically possible should not be arbitrarily forbidden
+by the software (though it might be enormously discouraged).
+
+The basic transaction is a changeset/patch/commit.  There is little
+value and hellish complexity in introducing meta-changesets or trying
+to update already-committed changes.
+
+
+Wrong commit message
+''''''''''''''''''''
+
+*Oops, I pressed Save too soon, and the commit message is wrong.*  This
+happens all the time.
+
+If no other branch has taken that change, there is no harm in fixing
+the message.  Noticing the problem right away is probably a very
+common case.
+
+Therefore, you can change the descriptive text (but not any other
+metadata) of a changeset in your tree.  This will not propagate to
+anyone else who has already accepted the change.  Nothing will break,
+but they'll still see the original (incorrect/incomplete) commit.
+
+
+Committed confidential information
+''''''''''''''''''''''''''''''''''
+
+If you just added a file you didn't mean to add then you can simply
+commit a second changeset to remove it again.  However, sometimes
+people will accidentally commit sensitive/confidential information,
+and they need to remove it from the history. 
+
+If anyone else has already taken the changeset we can't prevent them
+seeing or keeping the information.  You need to find them and ask them
+nicely to remove it as well.  Similarly, if you've mirrored your
+branch elsewhere you need to fix it up by hand.  This additional
+manual work is a feature because it gives you some protection against
+accidentally destroying the wrong thing.
+
+A similar but related case is accidentally committing an enormous
+file; you don't want it to hang around in the archive for ever.  (In
+fact, it would need to be stored twice, once for the original commit
+and again for a reversible remove changeset.)
+
+Here is our suggestion for how to fix this: make a second branch from
+just before the undesired commit, typically by specifying a timestamp.
+If there are any later commits that need to be preserved, they can be
+merged in too.  Possibly that will cause conflicts if they depended on
+the removed changeset, and those changes then need to be resolved.
+
+
+
+
+
+
+History truncation
+------------------
+
+(I don't think we should implement this soon, if at all, but people
+might want to know it's possible.)
+
+Bazaar-NG relies on each branch being able to recreate any of its
+predecessor states.  This is needed to do really intelligent merging.
+
+However, you might eventually get sick of keeping all the history
+around forever.  Therefore, we can set a history horizon, ignoring all
+patches before that point. 
+
+The patches are still recorded as being merged but we do not keep the
+text of the patches.  Perhaps we add them to a special list.  
+
+Merges with a tree that have no history in common since the horizon
+will be somewhat harder.
+
+
+A development path
+------------------
+
+**See also work-log.txt for what I'm currently doing.**
+
+* Start by still using Arch changeset format, do-changeset and delta
+  commands, possibly also for merge.
+
+* Don't do any merges automatically at first but rather just build
+  some trees and let the user run dirdiff or something.
+
+* Don't handle renames at first.
+
+* Don't worry about actually being distributed yet; just work between
+  local directories.  There are no conceptual problems with accessing
+  remote directories.
+
+
+Compared to others
+------------------
+
+* History cannot be rewritten, aside from a couple of special
+  pragmatic cases.
+
+* Allows cherry-picking, which is not possible on bk or most others.
+
+* Allows merges within an arbitrary graph (rather than a line, star or
+  tree), which can be done by bk but not by arch or others.
+
+* History-sensitive merges allow safe repeated merges and mutual
+  merges between parallel lines.
+
+* Patches are labelled with the history of branches they traversed to
+  their current location, which is previously unique to Arch.
+
+* Would aim to be almost as small and simple as Quilt.
+
+* Does not need archives to be registered.  
+
+* Like darcs and bk, remembers the last archive you pulled from and
+  uses this as the default.  Also as a bonus remembers all branches
+  you previously pulled and their name, so that it is as if they were
+  registered.
+
+* Because patches do not change when they move around (as in Darcs),
+  they can be cryptographically signed.
+
+* Recognizes that textually non-conflicting merges may not be a
+  correct merge and may not work, and so should not be auto-committed.
+  The developer must have a chance to intervene after the merge and
+  before a commit.  (I think Monotone is wrong on this.)
+
+
+
+
+Best practices
+--------------
+
+We recommend that people using Bazaar-NG follow these practices and
+protocols:
+
+* Develop independent features in separate branches.  It's easier to
+  keep them separate and merge later than to mix things together and
+  then try to separate them.  Although cherry picking is possible,
+  it's generally harder than keeping the code separate in the first
+  place.
+
+* Although you can merge in a graph, it can be easier to understand
+  things if you keep them roughly sorted into a star of downstream and
+  upstream branches.
+
+* Merge off your laptop/workstation into a personal stable tree at
+  regular changes; this protects against accidentally losing your
+  development branch for any reason. 
+
+* Try to have relatively "pure" merges: a single changeset that merges
+  changes should make only those merges and any edits needed to fix
+  them up. 
+
+* You can use reStructuredText (like this document) for commit
+  messages to allow nicer formatting and automatic detection of URLs,
+  email addreses, lists, etc.  Nothing requires this.
+
+
+
+Mechanics
+---------
+
+Patch format
+''''''''''''
+
+A patch (i.e. commit to a branch) exists at three levels:
+
+* the hash of the patch, which is used as its globally-unique name
+
+* the headers of the patch, including:
+
+  - the human-readable name of the branch to which the changeset was committed
+
+  - free-form comments about the changeset
+
+  - the email address and name of the user who committed the changeset
+
+  - the date when the changeset was committed to the branch
+
+  - the UUIDs of any patches merged by this change
+
+  - the hash of the before and after trees
+
+  - the IDs of any files affected by the change, and their names
+    before and after the change, and their hash before and after the
+    change
+
+* the actual text of the patch, which may include
+
+  - unidiff hunks
+
+  - xdeltas (in reversible pairs?)
+
+  - complete files for adds/deletes, or for binaries
+
+At the simplest level a branch knows just the IDs of all of the
+patches committed to it.  More usually it will also have all their
+logs or all their text.
+
+Using the IDs, it can retrieve the patches when necessary from a
+shared or external store.  By this means we can have many checkouts,
+each of which looks like it holds all of its history, without actually
+using a lot of space.  When pulling down a remote branch by default
+everything will be mirrored, but there might be an option to only get
+the inventory or only the logs. 
+
+Keeping the relatively small header separate from the text makes it
+easy to get only the header information from a remote machine.  One
+might also when offline like to see only the logs but not necessarily
+have the text.
+
+Only the basic policy (keep everything everywhere) needs to be done in
+the first release of course.
+
+The headers need to be stored in some format that allows moderately
+structured data.  Ideally it would be both human readable and
+accessible from various languages.  In the prototype I think I'll use
+Python data format, but that's probably not good in the long term.  It
+may be better to use XML (tasteless though that is) or perhaps YAML or
+RFC-2822 style.  Python data is probably not secure in the face of
+untrusted patches.
+
+The date should probably be shown in ISO form (unoptimal though that
+is in some ways.)
+
+
+
+  
+
+Unresolved questions and other ideas
+------------------------------------
+
+
+Pulling in inexact matches
+''''''''''''''''''''''''''
+
+If ``update`` pulls in patches noninteractively onto the history, then
+there are some issues with patches that do not exactly match.  Some
+consequences:
+
+* You may pull in a patch which causes your tree to semantically
+  break.  This might be avoided by having a test case which is checked
+  before committing.
+
+* The patch may fuzzily apply; this is OK. 
+
+If we pull in a patch from elsewhere then we will have a signature on
+the patch but not a signature for the whole cacherev. 
+
+
+
+
+Have pristines/working directory by default?
+''''''''''''''''''''''''''''''''''''''''''''
+
+It seems a bit redundant to have two copies of the current version of
+each file in every repository, even ones in which you'll never edit.
+Some fixes are possible:
+
+* don't create working copy files 
+
+* hard link working copies into pristine directory (can detect
+  corruption by having SHA-1 sums for all pristine files)
+
+I think it's reasonable to have 
+
+
+
+Directory name
+''''''''''''''
+
+We have a single metadata directory at the top-level of the tree: ``.bzr``.
+There is no value in having it non-hidden, because it can't be seen
+from subdirectories anyhow.  Apparently three-letter names after a dot
+are fine on Windows -- it works for ``.svn``.
+
+
+File encodings
+''''''''''''''
+
+Unicode, line endings, etc.  Ignore this for now?
+
+Case-insensitive file names?  Maybe follow Darcs in forbidding files
+that differ only in case.
+
+
+Always use 3-way merge
+''''''''''''''''''''''
+
+I think using .rej files and fuzzy patches is confusing/unhelpful.  
+
+I would like to use 3-way merges between appropriate coordinates as
+the fundamental mechanism for all 'merge'-type operations.  
+
+Is there any case where .rej files are more useful?  Why would you
+ever want that?  Some people seem to `prefer them`__ in Arch.
+
+__ http://wiki.gnuarch.org/moin.cgi/Process_20_2a_2erej_20files 
+ 
+I guess when cherry-picking you might not be able to find an
+appropriate ancestor for diff3?  I think you can; anyhow wiggle can
+transform rejects into diff3-style conflicts so why not do that?
+
+Miles says there that he prefers .rej files to conflict markers
+because they give better results for complex conflicts. 
+
+Perhaps we should just always produce both and let people use whatever
+they want.
+
+Another suggestion is the *rej_* tool, which helps fix up simple
+rejects:
+
+  There are four basic rejects fixable via rej.
+
+  1) missing context at the top or bottom of the hunk
+  2) different context in the middle of the hunk
+  3) slightly different lines removed by the hunk than exist in the file
+  4) Large hunks that might apply if they were broken up into smaller ones.
+
+.. _rej: ftp://ftp.suse.com/pub/people/mason/rej/
+
+
+Mirroring
+'''''''''
+
+One reason people say they like archives is that all new work in that
+archive will be automatically mirrored off your laptop, if it's
+already set up to mirror that archive.
+
+
+
+Control files out of tree
+'''''''''''''''''''''''''
+
+Some people would like to have absolutely no control files in their
+tree.  This is conceptually easy as long as we can find both the
+control files and working directory when a command is run.
+
+As a first step, the ``.bzr`` directory can be replaced by a symlink,
+which will prevent recursive commands looking into it.  Another
+approach is to put all actual source in a subdirectory of the tree, so
+that you never need to see the directory unless you look above the
+ceiling.
+
+If this is not enough, we might ask them to have an environment
+variable point to the control files, or have a map somewhere
+associating working directories with their control files.
+Unfortunately both of those seem likely to come loose and whip around
+dangerously.
+
+
+Representation of changesets
+''''''''''''''''''''''''''''
+
+Using patches is nice for plain text files.  In general we want the
+old and new names to correspond, but these are only for decoration;
+the file id determines where the patch really goes.
+
+* Should they be reversible?
+
+* How to represent binary diffs?
+
+* How to represent adds/removes?
+
+* How to zip up multiple changes into a single bundle?
+
+Reversibility is very important.  We do not need it for regular
+merges, since we can always recover the previous state.  We do need it
+for application of isolated patches, since we may not be able to
+recover the prior state.  It might also help when building a previous
+tree state.  
+
+Of course we can have an option to show deletes or to make the diff
+reversible even if it normally is not.
+
+It is very nice that plain diffs can be concatenated into a single
+text file.  This is not easily possible with binary files, xdeltas,
+etc.  Of course it is uncommon to display binary deltas directly or
+mail them, but if mailing is really required we could use base64 or
+MIME.
+
+Perhaps it would be reasonable to just store xdeltas between versions.
+
+Perhaps each changeset body should be a tar or zip holding the
+patches, though in simpler form than Arch.
+
+(Since these are free choices, perhaps stick closely to what Arch
+does?)
+
+
+Continuations
+'''''''''''''
+
+Do we need the generalized continuations currently present in Arch, or
+will a more restricted type do?  
+
+One use case for arch continuation tags is to make a release branch
+which contains only tags from the development branch.
+
+Maybe want darcs-style tags which just label the tree at various
+points; more familiar to users perhaps?
+
+::
+
+    bzr fork http://samba.org/bzr/samba/main ./my-samba
+ 
+1. creates directory my-samba
+2. copies contents of samba main branch
+3. the parent becomes samba-main
+4. parent is the default place you'll pull from & push to
+   
+Is there a difference between "contains stuff from samba-main" and "is
+branched from samba-main"?
+
+
+
+File split/merge
+''''''''''''''''
+
+Is there any sense in having a command to copy a file, or to rejoin
+several files with different IDs?
+
+Joining might be useful when the same tree is imported several times,
+or the same new-file operation is done in different trees.
+
+
+
+Time skew
+'''''''''
+
+Local clocks can be wrong when they record a commit.  This means that
+changes may be irrevocably recorded with the wrong time, and that in
+turn means that later changes may seem to come from before earlier
+changes.  We can give a warning at the later time, but short of
+refusing the commit there is not much we can do about it.
+
+
+Annotate/blame/praise
+---------------------
+
+``cvs annotate`` is pretty useful for understanding the history of
+development.  At the same time it is not quite trivial to implement,
+so I plan to make sure all the necessary data is easily accessible and
+then defer actually writing it.  Possibly the most complicated part is
+something to read in a diff and find which lines came from where. 
+
+What we need is a way to easily follow back through the history of a
+file, this is easily done by walking back along the branch.  Since we
+have revision numbers within a branch we have a short label which can
+be put against each line; we can also put a key at the bottom with
+some fields from each revision showing the committer and comment.
+
+For the case of merge commits people might be interested to know which
+merged patch brought in a change.  We cannot do this completely
+accurately since we don't know what the person did during the manual
+resolution of the merge, but by looking for identical lines we can
+probably get very close.  We can at the very least tell people the
+hash of all patches that were merged in so they can go and have a look
+at them.
+
+
+
+Performance
+-----------
+
+I think nothing here requires loading the whole tree into memory, as
+Darcs does.  We can detect renames and then diff files one by one.
+
+Because patches cannot change or be removed once they are committed or
+merged, we do not need to diff the patch-log, which is a problem in
+Arch.
+
+We do need to hold the whole list of patches in memory at various
+points but that should be at most perhaps 100,000 commits.
+
+We do need to pull down all patches since forever but that's not too
+unreasonable.
+
+Most heavy lifting can be done by GNU diff, patch and diff3, which are
+hopefully fast.
+
+Patches should be reasonably proportionate to the actual size of
+changes, not to the total size of the tree -- we should only list the
+hash and id for files that were touched by the change.  This implies
+that generating the manifest for any given revision means walking from
+the start of history to that revision.   Of course we can cache that
+manifest without necessarily caching the whole revision.
+
+* The dominant effect on performance in many cases will be network
+  round-trips; as Tom says "every one is like punching your user in
+  the face."
+
+  The network protocol can/should try to avoid them.
+
+  However, here's an even lazier idea: by making it possible to use
+  rsync for moving trees around, we get an insanely pipelined protocol
+  *for free*.
+
+  It's not always suitable (as when committing to a central tree), but
+  it will often work.  Cool!
+
+  Safely using rsync probably requires user intervention to make sure
+  that the tree is idle at the time the command runs; otherwise the
+  ordering of files arriving makes it really hard to know that we have
+  a consistent state.  I guess we can just ignore patches that are
+  missing...
+
+
+Hashing
+-------
+
+It might be nice to present hashes in BubbleBabble or some similar
+form to make it a bit easier on humans who have to see them.  This can
+of course be translated to and from binary.  On the other hand there
+is something in favour of regular strings that can be easily verified
+with other tools.
+
+We can have a Henson Mode in which it never trusts that files with the
+same hash are identical but always checks it.  Of course if SHA-1 is
+broken then GPG will probably be broken too...
+
+Comparison:
+
+binary:
+  20 bytes
+bubblebabble
+  > xizif-segim-vipyz-dyzak-gatas-sifet-dynir-gegon-borad-cetit-tixux
+  65 bytes
+base64:
+  > qvTGHdzF6KLavt4PO0gs2a6pQ00=
+  28 bytes
+hex:
+  > aaf4c61ddcc5e8a2dabede0f3b482cd9aea9434d
+  40 bytes
+
+Hex is probably the most reasonable tradeoff.
+
+
+File metadata
+-------------
+
+I don't want to get into general versioning of file metadata like
+permissions, at least in the first version; it's hard to say what
+should be propagated and what should not be.  This is a source code
+control system.
+
+It may be useful to carry some very restricted bits, like *read only*
+or *executable*; I think these are harmless.
+
+The only case where people generally want to remember permissions and
+ownership is when versioning ``/etc``, which is quite a special case.
+Perhaps this should be deferred to a special script such as the
+``cvs-conf`` package.
+
+
+Faster comparisons
+------------------
+
+There are many cases where we need to compare trees; perhaps the most
+common is just diffing the tree to see what changed.  For small to
+medium trees it is OK to just diff everything in the tree, and we can
+do just this in the first version.  This runs into trouble for
+kernel-sized trees, where reading every 
+
+
+Fear of forking
+---------------
+
+There is some fear that distributed version control (many branches)
+will encourage projects to fork.  I don't think this is necessarily
+true of Bazaar.
+
+A fundamental principle of Bazaar is that is not the tool's place to
+make you run a project a particular way.  The tool enables you to do
+what you want.  The documentation and community might suggest some
+practices that have been useful for other projects, but the choice is
+up to you.  There are principles for running open source projects that
+are useful regardless of tool, and Bazaar supports them.  They include
+encouraging new contributors, building community, managing a good
+release schedule and so on, but I won't enumerate them all here (and I
+don't claim to know them all.)
+
+Bazaar reduces some pressures that can lead to forking.  There need
+not be fights about who gets commit access: everyone can have a branch
+and they can contribute their changes.  Radical new development can
+occur on one branch while stabilization occurs on another and a new
+feature or port on a third.  Both creating the branches and merging
+between them should be easier in the Bazaar than with existing
+systems.  (Though of course there may be technical difficulties that
+no tool can totally remove.)
+
+Sometimes there really is a time for a fork, for various reasons:
+irreconcilable differences on technical direction or personality.  If
+that happens, Bazaar makes the break less total: the projects can
+still merge patches, share bug fixes and features, and even eventually
+reunite.
+
+
+Why a new project?
+------------------
+
+A key goal is simplicity and user-friendliness; this is easier to
+build into a new tool than to fix in an existing tool.  Nevertheless
+we want to provide a smooth upgrade path from Arch, CVS, and other
+systems.
+
+
+References
+----------
+
+* http://www.dwheeler.com/essays/scm.html
+
+  Good analysis; should try to address everything there in a way he will like.
+
+
+.. Local variables:
+.. mode: indented-text
+.. End:
+
+.. Would like to use rst-mode, but it's too slow on a document of this
+.. size.
\ No newline at end of file

=== added file 'doc/extra-commands.txt'
--- doc/extra-commands.txt	1970-01-01 00:00:00 +0000
+++ doc/extra-commands.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,33 @@
+************************
+Bazaar-NG Extra Commands
+************************
+
+:Copyright: Copyright 2005 Canonical Ltd.
+
+.. contents::
+
+This document lists some "extra" commands that are intended for
+developer, debugging, or advanced-hacker use.  You should not need to
+know about them for normal operations.
+
+
+
+inventory
+    List files in the working copy, in an XML format including the
+    filename, id and content hash.
+
+unknowns
+    List unknown files.
+
+uuid
+    Emit a new UUID.
+
+add-to-store
+    Add given files to the full-text store, indexed by their hash.
+
+doctest
+    Run test suite.
+
+revno
+    Print number of revisions on this branch (or equivalently, the
+    latest revision number.)
\ No newline at end of file

=== added file 'doc/faq.txt'
--- doc/faq.txt	1970-01-01 00:00:00 +0000
+++ doc/faq.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,14 @@
+Bazaar-NG frequently asked questions
+************************************
+
+
+*The XML is unreadable!*
+
+  Try running it through a pretty-printer like this::
+
+    xmllint --format *.xml
+
+
+*There's only two questions here?*
+  
+  Yes.

=== added file 'doc/formats.txt'
--- doc/formats.txt	1970-01-01 00:00:00 +0000
+++ doc/formats.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,240 @@
+*****************
+Bazaar-NG formats
+*****************
+
+.. contents::
+
+Since branches are working directories there is just a single
+directory format.
+
+There is one metadata directory called ``.bzr`` at the top of each
+tree.  Control files inside ``.bzr`` are never touched by patches and
+should not normally be edited by the user.
+
+These files are designed so that repository-level operations are ACID
+without depending on atomic operations spanning multiple files.  There
+are two particular cases: aborting a transaction in the middle, and
+contention from multiple processes.  We also need to be careful to
+flush files to disk at appropriate points; even this may not be
+totally safe if the filesystem does not guarantee ordering between
+multiple file changes, so we need to be sure to roll back.
+
+The design must also be such that the directory can simply be copied
+and that hardlinked directories will work.  (So we must always replace
+files, never just append.)
+
+A cache is kept under here of easily-accessible information about
+previous revisions.  This should be under a single directory so that
+it can be easily identified, excluded from backups, removed, etc.
+This might contain pristine tree from previous revisions, manifests
+and inventories, etc.  It might also contain working directories when
+building a commit, etc.  Call this maybe ``cache`` or ``tmp``.
+
+I wonder if we should use .zip files for revisions and cacherevs
+rather than tar files so that random access is easier/more efficient.
+There is a Python library ``zipfile``.
+
+
+Signing XML files
+*****************
+
+bzr relies on storing hashes or GPG signatures of various XML files.
+There can be multiple equivalent representations of the same XML tree,
+but these will have different byte-by-byte hashes.
+
+Once signed files are written out, they must be stored byte-for-byte
+and never re-encoded or renormalized, because that would break their
+hash or signature.
+
+
+
+
+Branch metadata
+***************
+
+All inside ``.bzr``
+
+``README``
+  Tells people not to touch anything here.
+
+``branch-format``
+  Identifies the parent as a Bazaar-NG branch; contains the overall
+  branch metadata format as a string.
+
+``pristine-directory``
+  Identifies that this is a pristine directory and may not be
+  committed to.
+
+``patches/``
+  Directory containing all patches applied to this branch, one per
+  file.  Patches are stored as compressed deltas.  We also store the
+  hash of the delta, hash of the before and after manifests, and
+  optionally a GPG signature.
+
+``cache/``
+  Contains various cached data that can be destroyed and will be
+  recreated.  (It should not be modified.)
+
+``cache/pristine/``
+  Contains cached full trees for selected previous revisions, used
+  when generating diffs, etc.
+
+``cache/inventory/``
+  Contains cached inventories of previous revisions.
+
+``cache/snapshot/``
+  Contains tarballs of cached revisions of the tree, named by their
+  revision id.  These can also be removed, but 
+
+``patch-history``
+  File containing the UUIDs of all patches taken in this branch,
+  in the order they were taken.
+  Each commit adds exactly one line to this file; lines are
+  never removed or reordered.
+
+``merged-patches``
+  List of foreign patches that have been merged into this branch.
+  Must have no entries in common with ``patch-history``.  Commits that
+  include merges add to this file; lines are never removed or
+  reordered.
+
+``pending-merge-patches``
+  List of foreign patches that have been merged and are waiting to be
+  committed. 
+
+``branch-name``
+  User-qualified name of the branch, for the purpose of describing the
+  origin of patches, e.g. ``mbp@sourcefrog.net/distcc--main``.
+
+``friends``
+  List of branches from which we have pulled; file containing a list
+  of pairs of branch-name and location.
+
+``parent``
+  Default pull/push target.
+
+``pending-inventory``
+  Mapping from UUIDs to file name in the current working directory.  
+
+``branch-lock``
+  Lock held while modifying the branch, to protect against clashing
+  updates.
+
+
+Locking
+*******
+
+Is locking a good strategy?  Perhaps somekind of read-copy-update or
+seq-lock based mechanism would work better?
+
+If we do use a locking algorithm, is it OK to rely on filesystem
+locking or do we need our own mechanism?  I think most hosts should
+have reasonable ``flock()`` or equivalent, even on NFS.  One risk is
+that on NFS it is easy to have broken locking and not know it, so it
+might be better to have something that will fail safe.
+
+Filesystem locks go away if the machine crashes or the process is
+terminated; this can be a feature in that we do not need to deal with
+stale locks but also a feature in that the lock itself does not
+indicate cleanup may be needed.
+
+robertc points out that tla converged on renaming a directory as a
+mechanism: this is one thing which is known to be atomic on almost all
+filesystems.  Apparently renaming files, creating directories, making
+symlinks etc are not good enough.
+
+
+
+Delta
+*****
+
+XML document plus a bag of patches, expressing the difference between
+two revisions.  May be a partial delta.
+
+* list of entries
+
+  * entry
+  
+    * parent directory (if any)
+    * before-name or null if new
+    * after-name or null if deleted
+    * uuid
+    * type (dir, file, symlink, ...)
+    * patch type (patch, full-text, xdelta, ...)
+    * patch filename (?)
+
+
+Inventory
+*********
+
+XML document; series of entries.  (Quite similar to the svn
+``entries`` file; perhaps should even have that name.)
+Stored identified by its hash.
+
+An inventory is stored for recorded revisions, also a
+``pending-inventory`` for a working directory.
+
+
+
+Revision
+********
+
+XML document.  Stored identified by its hash.
+
+committer
+  RFC-2822-style name of the committer.  Should match the key used to
+  sign the revision.
+
+comment
+  multi-line free-form text; whitespace and line breaks preserved
+
+timestamp
+  As floating-point seconds since epoch.
+
+precursor
+  ID of the previous revision on this branch.  May be absent (null) if
+  this is the start of a new branch.
+
+branch name
+  Name of the branch to which this was originally committed.    
+
+  (I'm not totally satisfied that this is the right way to do it; the
+  results will be a bit wierd when a series of revisions pass through
+  variously named branches.)
+
+inventory_hash
+  Acts as a pointer to the inventory for this revision.
+
+merged-branches
+  Revision ids of complete branches merged into this revision.  If a
+  revision is listed, that revision and transitively its predecessor
+  and all other merged-branches are merged.  This is empty except
+  where cherry-picks have occurred.
+
+merged-patches
+  Revision ids of cherry-picked patches.  Patches whose branches are
+  merged need not be listed here.  Listing a revision ID implies that
+  only the change of that particular revision from its predecessor has
+  been merged in.   This is empty except where cherry-picks have
+  occurred.
+
+The transitive closure avoids Arch's problem of needing to list a
+large number of previous revisions.  As ddaa writes:
+
+    Continuation revisions (created by tla tag or baz branch) are associated
+    to a patchlog whose New-patches header lists the revisions associated to
+    all the patchlogs present in the tree. That was introduced as an
+    optimisation so the set of patchlogs in any revision could be determined
+    solely by examining the patchlogs of ancestor revisions in the same
+    branch. This behaves well as long as the total count of patchlog is
+    reasonably small or new branches are not very frequent.
+
+    A continuation revision on $tree currently creates a patchlog of
+    about 500K. This patchlog is present in all descendent of the revision,
+    and all revisions that merges it.
+
+It may be useful at some times to keep a cache of all the branches, or
+all the revisions, present in the history of a branch, so that we do
+need to walk the whole history of the branch to build this list.
+  
+

=== added file 'doc/hashes.txt'
--- doc/hashes.txt	1970-01-01 00:00:00 +0000
+++ doc/hashes.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,73 @@
+Use of hashes in Bazaar-NG
+**************************
+
+* http://infohost.nmt.edu/~val/review/hash.html
+* http://infohost.nmt.edu/~val/review/hash2.html
+
+The main attraction of hashes in bazaar-ng is as an easy way to get
+universally-unique IDs, or at least with a low chance of collision:
+
+The first paper is a bit paranoid; the second has some sensible
+advice:
+
+1. Will compare-by-hash provide significant benefit -- save time,
+   bandwidth, etc?
+
+2. Is the system usable if hash collisions can be generated at will?
+
+3. Can the hashes be regenerated with a different algorithm at any
+   time?
+
+We should try to abide by these rules.  I think they are possibly too
+paranoid -- a real break of SHA-1 would have much wider security
+implications -- but if a design that respects them is practical, it
+should be preferred.
+
+The first is probably true; the third is just a matter of making sure
+we allow for the choice of hash to be varied in the format.
+
+There are actually two variations on the second:
+
+2a. Is the system safe if an attacker can generate hash collisions?
+
+2b. Is the system safe if a user's own files contain collisions.
+
+Regardless of cryptographic weakness, SHA-1 is unlikely to
+"accidentally" collide, but it's possible that someone will
+intentionally generate collisions (in research on SHA) and then want
+to store them.  It would be unfortunate if that did not work.
+
+An advantage of naming by hash is that it lets us store only a single
+copy of identical files, but we have already decided__ that disk space
+is pretty cheap.  It is perhaps enough to have a single copy of files
+that do not change from one tree revision to the next.
+
+__ costs.html
+
+As far as an attacker: we will not automatically trust that ids from
+one branch have the same value in another.  It is possible for a
+branch to contain "lies" about its history or contents, but that
+doesn't corrupt anything else.  It may confuse or mislead someone who
+looks at the branch, but there is no substitute for human review
+anyhow.
+
+-------
+
+The safest position may be to never rely on identifying content by
+hash.  Rather, things which need a universally unique ID should get a
+UUID instead.
+
+This has a slight advantage that the id can be stored directly in the
+object it refers to, when that's useful.
+
+So a `Revision` holds a UUID for the `Inventory`.  
+
+An inventory holds `InventoryEntry` objects, each with
+
+* file-id
+* filename (location in tree)
+* type (file, dir, etc)
+* text-id (uuid identifying the text)
+* text-sha1
+* text-length (for catching bugs)
+* parent-file-id

=== added file 'doc/index.txt'
--- doc/index.txt	1970-01-01 00:00:00 +0000
+++ doc/index.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,229 @@
+Bazaar-NG
+*********
+
+..   These documents are formatted as ReStructuredText.  You can    ..
+..   convert them to HTML, PDF, etc using the ``python-docutils``   ..
+..   package.                                                       ..
+
+
+*Bazaar-NG* (``bzr``) is a project of `Canonical Ltd`__ to develop an
+open source distributed version control system that is powerful,
+friendly, and scalable.  The project is at an early stage of
+development.
+
+__ http://canonical.com/
+
+
+**Note:** These documents are in a very preliminary state, and so may
+be internally or externally inconsistent or redundant.  Comments are
+still very welcome.  Please send them to <mbp@sourcefrog.net>.
+
+
+Summary status
+--------------
+
+(as of 2005-02-23)
+
+* Bazaar-NG can track the history of a single local branch, similar to
+  RCS.  The storage format should be reasonably close to what will be
+  used for 1.0.
+
+* The following commands work: ``add``, ``remove``, ``commit``,
+  ``log``, ``diff`` (whole tree against basis revision), ``status``, ``help``,
+  ``export`` (any revision).
+
+* Subdirectories and files within them are now supported.
+
+
+
+User documentation
+------------------
+
+* `Project overview/introduction <intro.html>`__
+
+* `Command reference <cmdref.html>`__ -- intended to be user
+  documentation, and gives the best overview at the moment of what the
+  system will feel like to use.  Fairly complete.
+
+* `Quick reference <quickref.html>`__ -- single page description of
+  how to use, intended to check it's adequately simple.  Incomplete.
+
+* `FAQ <faq.html>`__ -- mostly user-oriented FAQ.
+
+* `Demonstration/tutorial <short-demo.html>`__
+
+
+Requirements and general design
+-------------------------------
+
+* `Various purposes of a VCS <purpose.html>`__ -- taking snapshots and
+  helping with merges is not the whole story.
+
+* `Requirements <requirements.html>`__
+
+* `Costs <costs.html>`__ of various factors: time, disk, network, etc.
+
+* `Deadly sins <deadly-sins.html>`__ that gcc maintainers suggest we avoid.
+
+* `Overview of the whole design <design.html>`__ and miscellaneous
+  small design points.
+
+* `File formats <formats.html>`__
+
+* `Random observations <random.html>`__ that don't fit anywhere else yet.
+
+
+
+Design of particular features
+-----------------------------
+
+* `Automatic generation of ChangeLogs <changelogs.html>`__
+
+* `Cherry picking <cherry-picking.html>`__ -- merge just selected non-contiguous changes  from a branch.
+
+* `Common changeset format <common-format.html>`__ for  interchange
+  format between VCS.
+
+* `Compression <compression.html>`__ of file text for more efficient storage.
+
+* `Config specs <config-specs.html>`__ assemble a tree from several places.
+
+* `Conflicts <conflicts.html>`_ that can occur during merge-like operations.
+
+* `Recovering from interrupted operations <interrupted.html>`__
+
+* `Inventory command <inventory.html>`__
+
+* `Branch joins <join-branches.html>`__ represent that all the changes
+  from one branch are integrated into another.
+
+* `Kill a version <kill-version.html>`__ to fix a broken commit or
+  wrong message, or to
+  remove confidential information from the history.
+
+* `Hash collisions <hashes.html>`__ and weaknesses, and the security
+  implications thereof.
+
+* `Layers <layers.html>`__ within the design
+
+* `Library interface <library-interface.html>`__ for Python.
+
+* `Merge <merge.html>`__
+
+* `Mirroring <mirroring.html>`__
+
+* `Optional edit command <optional-edit.html>`__: sometimes people
+  want to make the  working copy read-only, or not present at all.
+
+* `Partial commits <partial-commit.html>`__
+
+* `Patch pools <pool.html>`__ to efficiently store related branches.
+
+* `Revision syntax <revision-syntax.html>`__ -- ``hello.c@12``, etc.
+
+* `Roll-up commits <rollup.html>`__ -- a single revision incorporates
+  the changes from several others.
+
+* `Scalability <scalability.html>`__
+
+* `Security <security.html>`__
+
+* `Shared branches <shared-branches.html>`__ maintained by more than
+  one person
+
+* `Supportability <supportability.html>`__ -- how to handle any bugs
+  or problems in the field.
+
+* `Place tags on revisions for easy reference <tagging.html>`__
+
+* `Detecting unchanged files <unchanged.html>`__
+   
+* `Merging previously-unrelated branches <unrelated-merge.html>`__
+
+* `Usability principles <usability.html>`__ (very small at the moment)
+
+* `<use-cases.html>`__
+
+* `<web-interface.html>`__
+
+* `<workflow.html>`__ Modelling/controlling flow of patches.
+
+* `<yaml.html>`__ --  Discussion of using YAML_ as a storage or transmission format.
+
+.. _YAML: http://www.yaml.org/
+
+
+
+Comparisons to other systems
+----------------------------
+
+* `Taxonomy <taxonomy.html>`__: basic questions a VCS must answer.
+
+* `Bitkeeper <bitkeeper.html>`__, the proprietary system used by some
+  kernel developers.
+
+* `Aegis <compared-aegis.html>`__, a tool focussed on enforcing
+  process and workflow.
+
+* `Codeville <compared-codeville.html>`__ has an intruiging but
+  scarcely-documented merge algorithm.
+
+* `CVSNT <compared-cvsnt.html>`__, with more Windows support and some
+  merge enhancements.
+
+* `OpenCM <compared-opencm.html>`__, another hash-based tool with a
+  good whitepaper.
+
+* `PRCS <compared-prcs.html>`__, a non-distributed inventory-based tool.
+
+* `GNU Arch <todo-from-arch.html>`__, with many pros and cons.
+
+* `Darcs <darcs.html>`__, a merge-focussed tool with good usability.
+
+* `Quilt <quilt.html>`__ -- Andrew Morton's patch scripts, popular with kernel maintainers.
+
+* `Monotone <monotone.html>`__, Graydon Hoare's hash-based distributed system.
+
+* `SVK <svk.html>`__ --     distributed operation stacked on Subversion.
+
+* `Sun Teamware <compared-teamware.html>`__
+
+
+Project management and organization
+-----------------------------------
+
+* `Development news <news.html>`__
+
+* `Notes on how to get a VCS adopted <adoption.html>`__
+
+* `Testing plan <testing.html>`__ -- very sketchy.
+
+* `Thanks <thanks.html>`__ to various people
+
+* `Roadmap <roadmap.html>`__: High-level order for implementing features.
+
+* `<work-order.html>`__: current tasks.
+
+* `Extra commands <extra-commands.html>`__ for
+  internal/developer/debugger use.
+
+* `Choice of Python as a development language <python.html>`__
+
+
+Download
+--------
+
+There are no releases yet.
+
+The Bazaar-NG development code may be downloaded using GNU Arch by the
+following steps::
+
+   tla register-archive http://sourcefrog.net/arch/mbp@sourcefrog.net--2004
+   tla get mbp@sourcefrog.net--2004/bazaar-ng--0  bazaar-ng
+
+(By contrast, when Bazaar-NG network operations are complete, a single
+much shorter command will do.)
+
+Note that the current code is under heavy development and so is not
+guaranteed to do anything useful whatsoever.
+

=== added file 'doc/interrupted.txt'
--- doc/interrupted.txt	1970-01-01 00:00:00 +0000
+++ doc/interrupted.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,113 @@
+Interrupted operations
+**********************
+
+Problem: interrupted operations
+===============================
+
+Many version control systems tend to have trouble when operations are
+interrupted.  This can happen in various ways:
+
+ * user hits Ctrl-C
+
+ * program hits a bug and aborts
+
+ * machine crashes
+
+ * network goes down
+
+ * tree is naively copied (e.g. by cp/tar) while an operation is in
+   progress
+
+We can reduce the window during which operations can be interrupted:
+most importantly, by receiving everything off the network into a
+staging area, so that network interruptions won't leave a job half
+complete.  But it is not possible to totally avoid this, because the
+power can always fail.
+
+I think we can reasonably rely on flushing to stable storage at
+various points, and trust that such files will be accessible when we
+come back up.
+
+I think by using this and building from the bottom up there are never
+any broken pointers in the branch metadata: first we add the file
+versions, then the inventory, then the revision and signature, then
+link them into the revision history.  The worst that can happen is
+that there will be some orphaned files if this is interrupted at any
+point. 
+
+rsync is just impossible in the general case: it reads the files in a
+fairly unpredictable order, so what it copies may not be a tree that
+existed at any particular point in time.  If people want to make
+backups or replicate using rsync they need to treat it like any other
+database and either
+
+ * make a copy which will not be updated, and rsync from that
+
+ * lock the database while rsyncing
+
+The operating system facilities are not sufficient to protect against
+all of these.  We cannot satisfactorily commit a whole atomic
+transaction in one step.
+
+Operations might be updating either the metadata or the working copy.
+
+The working copy is in some ways more difficult:
+
+ * Other processes are allowed to modify it from time to time in
+   arbitrary ways.
+
+   If they modify it while bazaar is working then they will lose, but
+   we should at least try to make sure there is no corruption.
+
+ * We can't atomically replace the whole working copy.  We can
+   (semi) atomically updated particular files.
+
+ * If the working copy files are in a wierd state it is hard to know
+   whether that occurred because bzr's work was interrupted or because
+   the user changed them.
+
+   (A reasonable user might run ``bzr revert`` if they notice
+   something like this has happened, but it would be nice to avoid
+   it.)
+
+We don't want to leave things in a broken state.
+
+
+Solution: write-ahead journaling?
+=================================
+
+One possibly solution might be write-ahead journaling:
+
+  Before beginning a change, write and flush to disk a description of
+  what change will be made.
+
+  Every bzr operation checks this journal; if there are any pending
+  operations waiting then they are completed first, before proceeding
+  with whatever the user wanted.  (Perhaps this should be in a
+  separate ``bzr recover``, but I think it's better to just do it,
+  perhaps with a warning.)
+
+  The descriptions written into the journal need to be simple enough
+  that they can safely be re-run in a totally different context.  They
+  must not depend on any external resources which might have gone
+  away.
+
+  If we can do anything without depending on journalling we should.
+
+  It may be that the only case where we cannot get by with just
+  ordering is in updating the working copy; the user might get into a
+  difficult situation where they have pulled in a change and only half
+  the working copy has been updated.  One solution would be to remove
+  the working copy files, or mark them readonly, while this is in
+  progress.  We don't want people accidentally writing to a file that
+  needs to be overwritten.
+
+  Or perhaps, in this particular case, it is OK to leave them in
+  pointing to an old state, and let people revert if they're sure they
+  want the new one?  Sounds dangerous.
+
+Aaron points out that this basically sounds like changesets.  So
+before updating the history, we first calculate the changeset and
+write it out to stable storage as a single file.  We then apply the
+changeset, possibly updating several files.  Each command should check
+whether such an application was in progress.

=== added file 'doc/intro.txt'
--- doc/intro.txt	1970-01-01 00:00:00 +0000
+++ doc/intro.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,109 @@
+Introduction to Bazaar
+======================
+
+Bazaar's goal is *to make a distributed version control system that
+open source developers will love to use*.  Using Bazaar should feel
+good.
+
+.. epigraph::
+
+  Language designers want to design the perfect language. They want to
+  be able to say, "My language is perfect. It can do everything." But
+  it's just plain impossible to design a perfect language, because
+  there are two ways to look at a language. One way is by looking at
+  what can be done with that language. The other is by looking at how
+  we feel using that language -- how we feel while programming.
+
+  Because of the Turing completeness theory, everything one
+  Turing-complete language can do can theoretically be done by another
+  Turing-complete language, but at a different cost. You can do
+  everything in assembler, but no one wants to program in assembler
+  anymore. From the viewpoint of what you can do, therefore, languages
+  do differ -- but the differences are limited. For example, Python
+  and Ruby provide almost the same power to the programmer.
+
+  Instead of emphasizing the what, I want to emphasize the how part: how
+  we feel while programming.
+
+  -- `Yukihiro Matsumoto`__
+
+__ http://www.artima.com/intv/ruby.html
+
+Bazaar tries to make simple things simple, and complex things
+possible.  In particular:
+
+ * Distributed operation is easy: you can work while disconnected; you
+   can fork any other project; you can contribute changes back
+   easily.  
+
+ * The system is designed to scale to supporting very large trees with
+   a lot of history.  No operations require downloading the entire
+   history of the project.
+
+ * Changes can be "cherry-picked" out of branches as needed.   Because
+   of dependencies between 
+
+
+
+History-sensitive merging
+=========================
+
+Baz keeps track of what changes have been merged into a branch.  You
+can repeatedly merge from one branch into another and Baz will pull
+across only the new changes since you last merged.
+
+
+Speed
+=====
+
+For most users, the most important factor for performance is to avoid
+unnecessary network round trips.  Baz tries hard to avoid ever
+downloading the same data twice.  
+
+Remote archives are automatically cached on your local machine by
+default.  If you have ever accessed a remote revision you should be
+able to get it again without going to the network.  The cache policy
+may be tuned.
+
+
+
+Code history
+============
+
+One important function of a revision control system is to maintain a
+record of when, why, how and by whom changes were made. 
+
+Baz requires that branches and archives be named.
+
+Unlike most other systems, Baz keeps a record for each changeset of
+which branches and archives it passed through on its way to its
+eventual destination.  This allows people to go back later and see the
+context in which the patch was written or merged.
+
+
+
+Scalability
+===========
+
+We regularly test Baz on projects with tens of thousands of commits,
+and tens of thousands of files.
+
+
+
+Merging
+=======
+
+The basic method of integration is a three-way merge.  Baz selects an
+appropriate basis version
+
+
+
+File renaming
+=============
+
+Baz allows files and directories to be renamed in a project.  Unlike
+Subversion, Baz will correctly merge changes spanning file renames.
+This is done by automatically assigning a unique ID to each file,
+which is persistent across renames.
+
+

=== added file 'doc/inventory.txt'
--- doc/inventory.txt	1970-01-01 00:00:00 +0000
+++ doc/inventory.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,10 @@
+Should be a simple command that shows something similar to 'svn
+status':
+
+  what is not added but perhaps should be
+  what is source, backup, precious, junk, etc
+
+Or a nice simple command like 'bk extras' to show what's not added but
+should be.
+  
+baz inventory almost does this but it way too hard to understand
\ No newline at end of file

=== added file 'doc/join-branches.txt'
--- doc/join-branches.txt	1970-01-01 00:00:00 +0000
+++ doc/join-branches.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,81 @@
+****************
+Joining branches
+****************
+
+(I think this is pretty brilliant. :-)
+
+Branches diverge when people create more than one changeset following
+on from a common ancestor::
+
+  A:   0 ------- 1
+  B:    \------- 2
+
+We also allow branches to reunite.  This means that all the decisions
+taken on multiple branches have been reconciled and unified into a
+single successor::
+
+  A: 0 ------- 1 ----- 3
+      \               /
+  B:   \------ 2 ----/
+
+The predecessor of 3 is 1, in the sense that it was created on that
+branch.  We could have created the exact same state as a successor to
+2, and we can move that state onto branch 2 without any loss of
+information.
+
+(One thing we can do here is just delete B.  Because all of the work
+there has been merged onto A, this will not lose anything.  We might
+do this if the purpose of B has been achieved, such as completing a
+feature or bug.  But if the work is still in progress, we might keep
+it around.  It makes little difference whether we decide to do new
+work in a branch called B or make a new one called C.)
+
+That is to say that 3 can be perfectly (trivially) merged onto B,
+with, say ``bzr push``, ``bzr pull`` or ``bzr update`` (whatever name
+works best).  Perfectly merged means that we know there will be no
+conflicts or need for manual intervention, and that we can just
+directly store it without forming a roll-up changeset.
+
+I think we might also like the choice of merging A onto B, rather than
+pulling the changeset.  That causes a new changeset to be created on
+B, noted as a successor of 2 and 3::
+
+  A: 0 ------- 1 ----- 3 ------+
+      \               /         \
+  B:   \------ 2 ----+---------- 4
+
+One complication is that 3 is probably stored in A's history as a
+patch relative to 1; we can't just move this representation across.
+Instead, we need to recalculate the delta from 2 to 3 and store that.
+
+Despite that the delta is stored differently, the original signature
+on 3 should still be valid.  So it must be a signature of the tree
+state, not the diff.
+
+Note from `Kernel Traffic discussion`__:
+
+__ http://www.kerneltraffic.org/kernel-traffic/kt20030323_210.txt
+
+    But anyway, what made Bitkeeper suck less is the real DAG
+    structure.  Neither arch (http://arch.fifthvision.net/bin/view)
+    nor subversion seem to have understood that and, as a result,
+    don't and won't provide the same level of semantics. Zero hope for
+    Linus to use them, ever. They're needed for any decently
+    distributed development process.
+
+This in turn suggests that possibly deltas should be stored separately
+from the commits that create them.  Commits name points of
+development; deltas describe how to get from one to the other.
+
+The separation is nice in allowing us to send just a delta when
+diffing trees or recording for undo.  We might want to compute many
+deltas between different trees.
+
+Is this a problem?  Does this ignore Tom's advice about the primacy of
+storing changesets?
+
+Splitting them is probably good, but then what manifest is stored in
+changesets?  We don't want to store the manifest of the whole tree if
+we can avoid it.  So I suppose the changeset just gives the hash of
+the manifest, and the manifest then can be stored separately, possibly
+delta-encoded.

=== added file 'doc/kill-version.txt'
--- doc/kill-version.txt	1970-01-01 00:00:00 +0000
+++ doc/kill-version.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,128 @@
+Killing versions
+****************
+
+Sometimes people really need to rewrite history.  The canonical
+example is that they have accidentally checked confidential
+information into the wrong tree.
+
+There is a tension between two imperatives:
+
+* Accurately record all history.
+
+* Remove critical information.
+
+Of course we cannot control who may have made use of the information
+in the time it was public, but often these things are caught early enough.
+
+After history has been rewritten, anything that depends on that
+history may be inconsistent.  We cannot consistently continue on a
+version that has had some revisions knocked out; therefore it seems
+simplest to kill the version over all.  
+
+You can make a tag onto a new version from a previous consistent
+revision.  
+
+Downstream users will need to switch on to the new version.
+
+We can mark the version as killed so that mirroring will delete the
+revisions and clients looking at the version can suggest switching.
+
+This should be an extremely infrequent operation so it is OK that it
+is simple as long as it fulfils the basic requirement.
+
+A related problem is that people sometimes commit the wrong log
+message, or (more seriously) the wrong files.  It is common to notice
+immediately afterwards.
+
+
+Uncommit
+--------
+
+I think this is the best and most useful option at the moment: the
+`uncommit command`_ undoes the last commit, and nothing else.  It can
+be repeated to successively remove more and more history.
+
+.. _`uncommit command`: cmdref.html#uncommit
+
+Example::
+
+    % cd my-project
+    % bzr add launch-codes.txt
+    % bzr commit -m 'add launch codes'
+    A     launch-codes.txt
+    recorded r23
+    [oops!]
+    % bzr uncommit
+    [now back to just before the commit command]
+    
+    % bzr status
+    A     launch-codes.txt
+    % bzr revert launch-codes.txt
+    % bzr status
+    ?     launch-codes.txt
+
+If anyone else has depended on the option then the branches will have
+diverged and that needs to be resolved somehow, probably by the other
+people starting a new branch with the correct commit.  In particular
+uncommitting from a shared branch will break anyone who has seen that
+revision; possibly there needs to be a policy option on such branches
+to deny uncommit.
+
+If someone else on that shared branch did a the equivalent of a
+switch_ command then they would bring their changes onto the correct
+basis.  Would it be reasonable to do that automatically?
+
+.. _switch: cmdref.html#switch
+
+
+
+UI proposals
+------------
+
+Aaron's proposal::
+
+    % cd my-project
+    % baz add launch-codes.txt
+    % baz commit -s 'add launch codes'
+    recorded patch-4
+    % baz add good-code.c
+    % baz commit -s 'add good code'
+    recorded patch-5
+    [oops!]
+    % baz undo patch-3
+    % baz pull patch-5
+    % baz commit --as-latest
+    renamed old branch to my-project-old-1
+    % baz eradicate my-project-old-1
+
+Long form::
+
+  % cd my-project
+  % baz add launch-codes.txt
+  % baz commit -s 'add launch codes'
+  recorded patch-4
+  % baz add good-code.c
+  % baz commit -s 'add good code'
+  recorded patch-5
+  [oops!]
+  % cd ../
+  % baz fork my-project--patch3 my-project-fixed
+  % cd my-project-fixed
+  % baz pull ../my-project patch5
+  % cd ../
+  % rm -rf my-project
+  % mv my-project-fixed my-project
+
+Robert's proposal::
+
+  % cd my-project
+  % baz add launch-codes.txt
+  % baz commit -s 'add launch codes'
+  recorded patch-4
+  % baz add good-code.c
+  % baz commit -s 'add good code'
+  recorded patch-5
+  [oops!]
+  % baz branch patch-3 $(baz tree-version)
+  % baz pull . patch-5
+  % baz eliminate patch-4

=== added file 'doc/layers.txt'
--- doc/layers.txt	1970-01-01 00:00:00 +0000
+++ doc/layers.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,88 @@
+ * Write-once store of files identified by globally-unique names
+   (e.g. hashes or UUIDs).
+
+   Simplest option is to just dump them in a directory.  
+
+   Optionally do delta-compression between similar/related files; or
+   build this on top of deltas.
+
+ * Tree manifests/inventories which say which files should be assembled at
+   particular points to build a tree.  These too can be stored indexed
+   by hash.
+
+   - Reconstruct a revision by pulling out the manifest and then all
+     the individual files. 
+  
+   - Manipulate working copy of inventory by add/mv/remove/commands.
+
+ * Retrieve deltas 
+ 
+   - Calculate diffs between two file versions, just by getting them
+     from the store.
+
+   - Retrieve deltas between any two revisions: requires looking for
+     changes to the structure of the tree, and then text changes for
+     anything inside it.
+
+   - Deltas may be either stored or calculated on demand.  They can be
+     put in the store just indexed by the from and to manifest id.
+
+   - Calculate diff between a previous revision and the working copy. 
+
+ * Commit and retrieve revisions
+
+   - Revisions hold metadata (date, committer, comment, optional
+     parents, merged patches), and a pointer to the inventory.
+
+   - Stored in a write-once store.
+
+ * Branch holds a linear history of revisions.
+
+   - This is mostly redundant; we could just remember the current base
+     revision and walk backwards from there.  But it still seems
+     possibly useful to hold; we can check that the two are always
+     consistent.
+
+     (This suggests that we actually *could* do ``switch`` if we
+     really wanted to, by replacing the revision history and head
+     revision.  But I don't think it's a good idea.)
+
+   - Can add a new revision to the end.
+
+   - By indexing into this can translate between 0-based revision
+     numbers and revision ids. 
+
+   - By walking through and looking at revision dates can find
+     revisions in a particular date range.
+
+ * Calculations on branch histories:
+
+   - Find if one branch is a prefix of another.
+
+   - Find the latest common ancestor of another.
+
+ * Three-way merge between revisions
+
+   - Resolve shape of directory
+   
+   - Then resolve textual conflicts
+
+ * Pull/push changes when they perfectly match
+
+   - Possible when the destination is a prefix of the source
+
+   - Just move all revisions, manifests and texts across, and 
+
+ * Merge all changes from one branch into another
+
+ * Signatures applied to revisions
+
+   - There is a separable module for checking a signature: this is
+     passed the claimed author, changeset, date.  This needs to fetch
+     an appropriate key, decide if it is trusted to correspond to that
+     author, is not revoked, etc.
+
+   - If it is unknown, untrusted, revoked, etc, that is reported.
+     Depending on a paranoia level it may cause the operation to
+     abort.
+

=== added file 'doc/library-interface.txt'
--- doc/library-interface.txt	1970-01-01 00:00:00 +0000
+++ doc/library-interface.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,11 @@
+*****************
+Library interface
+*****************
+
+Should have a pleasant library interface.
+
+* Be clear what is supposed to be in a stable public interface and
+  what is not.  (A common failing of Python programs.)
+
+* If a function changes the working directory (as may be necessary to
+  run patch) it should restore it.

=== added file 'doc/merge.txt'
--- doc/merge.txt	1970-01-01 00:00:00 +0000
+++ doc/merge.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,20 @@
+Merging
+=======
+
+There should be one merge command which does the right thing, and
+which is called 'merge'.
+
+The merge command pulls a changeset or a range of changesets into your
+tree.  It knows what changes have already been integrated and avoids
+pulling them again.
+
+There should be some intelligence about working out what changes have
+already been merged. 
+
+The tool intelligently chooses (or perhaps synthesizes) an ancestor
+and two trees to merge.  These are then intelligently merged.
+
+Merge should refuse to run (unless forced) if there are any
+uncommitted changes in your tree beforehand.  This has two purposes:
+if you mess up the merge you won't lose anything important; secondly
+this makes it more likely that the merge will be relatively pure.

=== added file 'doc/mirroring.txt'
--- doc/mirroring.txt	1970-01-01 00:00:00 +0000
+++ doc/mirroring.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,14 @@
+Mirroring
+=========
+
+The basic idea of mirroring is good, but it's too hard to understand.
+
+Push mirrors and pull mirrors.
+
+Suggest that people commit to their local machine and then regularly
+mirror elsewhere as a backup.
+
+bk and darcs's design inherently avoids this; just make another repo
+and decide to use it that way.
+
+On the other hand they do not keep track of the progress of a patch.
\ No newline at end of file

=== added file 'doc/monotone.txt'
--- doc/monotone.txt	1970-01-01 00:00:00 +0000
+++ doc/monotone.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,16 @@
+********************
+Thoughts on Monotone
+********************
+
+Great project, but not perfect.
+
+My main feeling is that it exposes too much mechanism and in the wrong
+ways.  For example, hashes are all very well for representing
+identity, but I don't want to see them; I just want to say "r43 of
+this branch".  
+
+Cryptographic signing is good for making sure revisions are really
+what they claim to be, but I don't want to directly deal with it: I
+want it as a check that things are really happening as they should
+be.  It should be barely seen and not heard unless/until something
+goes wrong.

=== added file 'doc/news.txt'
--- doc/news.txt	1970-01-01 00:00:00 +0000
+++ doc/news.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,147 @@
+Bazaar-NG Development News
+**************************
+
+
+2005-02-20
+==========
+
+* Added documentation of `patch pools <pool.html>`_, explication of
+  commands in terms of file state transitions, `uncommit
+  <kill-version.html>`_, `journalling <interrupted.html>`_ through
+  recording changesets.  Feedback from Aaron on some of the design
+  documentation.
+
+* Much cleaner ``diff`` and ``status`` commands, based on a new Tree
+  class that abstracts access to either a current working copy or a
+  historical revision.
+
+* ``remove`` command now both removes the working copy and updates the
+  inventory, and has a new alias ``rm``.  
+
+* Basic local versioning works well::
+
+    % bzr init   
+    % echo 'int main() {}' > hello.c
+    % bzr add hello.c
+    % bzr commit 'my test program'
+    % bzr status
+    U    hello.c
+    % echo 'int main() { return 0; }' > hello.c 
+    % bzr status                               
+    M    hello.c
+    % bzr diff        
+    --- old/hello.c 
+    +++ new/hello.c 
+    @@ -1,1 +1,1 @@
+    -int main() {}
+    +int main() { return 0; }
+    % bzr commit 'fix return code'
+    % bzr log
+    ----------------------------------------
+    revno: 1
+    committer: mbp@sourcefrog.net
+    timestamp: Wed 2005-02-16 11:39:13.003095 EST +1100
+
+    my test program
+    ----------------------------------------
+    revno: 2
+    committer: mbp@sourcefrog.net
+    timestamp: Wed 2005-02-16 11:43:13.010274 EST +1100
+
+    fix return code
+    % bzr status
+    U    hello.c
+    % bzr rm hello.c
+    % ls
+    % bzr status    
+    D    hello.c
+    % bzr commit 'this program sucks!'
+    % bzr stauts
+    bzr: error: unknown command 'stauts'
+    exit 1
+    % bzr status
+    %
+
+
+
+* Many internal/hacker commands: ``revno``, ``get-inventory``,
+  ``get-file``, ...
+
+* Most of the implementation is split into reasonably clean objects:
+  `Branch`, `Revision`, `Tree`, `Inventory`.  I think these will give
+  a good foundation for non-intrusive remote operations.  They 
+  live in submodules of `bzrlib`.
+
+ ====== ==================================
+    596 bzr.py
+    608 bzrlib/branch.py
+     39 bzrlib/errors.py
+     25 bzrlib/__init__.py
+    320 bzrlib/inventory.py
+    126 bzrlib/osutils.py
+     66 bzrlib/revision.py
+    173 bzrlib/store.py
+    107 bzrlib/tests.py
+     62 bzrlib/trace.py
+    239 bzrlib/tree.py
+     41 bzrlib/xml.py
+ ------ ----------------------------------
+   2402 total
+ ====== ==================================
+
+
+* After feedback and reflection I have decided not to use `SHA-1
+  hashes`__ as the main identifier of texts, inventories, revisions,
+  etc.  It would probably be safe, but there is a certain amount of
+  concern (or even FUD) about the security of these hashes.  Since
+  they cannot be trusted to be safe in the long term, it is better
+  just to use something cheaper to compute, and equally unique in the
+  absence of malice: UUIDs.
+
+__ hashes.html
+
+  We now store the SHA-1 of files, but use it only as a check that the
+  files were stored safely.  At tridge's suggestion we also keep the
+  size, which can catch some classes of bug or data corruption::
+
+    % bzr diff
+    bzr: error: wrong SHA-1 for file
+    '680757bf-2f6e-4ef3-9fb4-1b81ba04b73f' 
+    in ImmutableStore('/home/mbp/work/bazaar-ng/toy/.bzr/text-store')
+      inventory expects d643a377c01d3e29f3e6e05b1618eb6833992dd0
+      file is actually 352586b84597ea8915ef9b1fb5c9c6c5cdd26d7b
+      store is probably damaged/corrupt
+
+
+2005-02-27
+==========
+
+Revisions are now named by something based on the username and date,
+plus some random bytes to make it unique.  This may be a reasonable
+tradeoff against uniqueness and readability.   This same id is used by
+default for revision inventories::
+
+  mbp@sourcefrog.net-20050220113441-34e486671a10f75297e03986
+
+Keeping them separate is still a good thing, because the inventory may
+be large and we often want only the revision and not the inventory.
+It is possible for the revision to point to an older inventory if it
+has not changed (but this is not implemented yet.)
+
+Tridge pointed out some `possible performance problems`__ with the
+assumption that we can simply compare all files to check for changes. 
+
+__ unchanged.html
+
+XML has newlines to make it a bit more readable.
+
+Nested subdirectories are now supported down to an arbitrary depth.
+
+bzr can successfully import and reproduce itself.
+
+
+
+ongoing
+=======
+
+* Systematic command-line handling and option parsing, etc.
\ No newline at end of file

=== added file 'doc/optional-edit.txt'
--- doc/optional-edit.txt	1970-01-01 00:00:00 +0000
+++ doc/optional-edit.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,30 @@
+******************************
+Optional explicit edit command
+******************************
+
+The default is for each branch to have an editable working copy, which
+can be modified and committed.  However, in some cases (following RCS
+and BK) people might prefer to have either a read-only working copy,
+or none at all.
+
+Reasons:
+
+ - Branches which are never edited don't need it; removing it saves
+   some time and space.  In particular this applies to branches on a
+   server which are meant to be branched from or committed too, not
+   edited.
+
+ - Files for which there is no working copy or a read-only copy are
+   known not to be edited, and this can make some operations such as
+   diffing a bit simpler.
+
+Since this is mostly an optimization and requires user knowledge it
+perhaps should not be added.  Certainly not yet.
+
+Sketch::
+
+  $ bzr get --no-wc SOURCE TARGET
+  $ bzr edit --remove
+  $ bzr edit --read-only .
+  $ bzr edit --write foo.c
+

=== added file 'doc/partial-commit.txt'
--- doc/partial-commit.txt	1970-01-01 00:00:00 +0000
+++ doc/partial-commit.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,20 @@
+Partial commit
+**************
+
+In the first cut, commit covers the whole tree.
+
+Secondly, people might want to commit only particular files or
+subdirectories.  Semantics of this in the case of renames/adds/deletes
+may be a bit complex, but I think it can be done.  The basic point is
+to build an inventory which includes only the specified changes from
+the working copy. 
+
+Beyond that, it can be very nice in darcs to commit only selected
+changes to a file.  I think this should not be the default though;
+perhaps only do it with ``-i``.  Even better (for some users) kick off
+a graphical tool to select the particular regions.  Beyond a certain
+point it may become easier for the user to explicitly set aside some
+changes and commit others first.
+
+In any case, it is a good idea to run a test suite on the revision to
+be committed, to make sure there were no missed dependencies.
\ No newline at end of file

=== added file 'doc/pool.txt'
--- doc/pool.txt	1970-01-01 00:00:00 +0000
+++ doc/pool.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,65 @@
+Patch pools
+***********
+
+*Patch pools* are an optimization for efficient storage of related
+branches.  They are not required for the first release.
+
+Revisions, inventories, and file states are identified in Bazaar-NG by
+universally unique hashes, and they are never modified once they are
+created.  Objects which are common between branches may therefore be
+stored only once and referenced from each branch.  Various strategies
+are available for doing this.
+
+Objects can be held hard-linked between related branches on
+filesystems that support hardlinks.  This provides automatic reference
+counting as branches are deleted.
+
+It is common to have several branches of the same project on a
+machine, with many objects in common.  These can be configured with
+each other on the pool path.  The parent should be the default pool
+path when creating a new branch.
+
+Each user might also have a pool that acts as a cache of all remote
+revisions.  Such a cache might use some kind of least-recently-used
+policy to limit its size.
+
+The user might nominate a series or hierarchy of pools to be searched for a
+patch; these might be progressively on the local machine, local
+network and remotely.  
+
+A system like the supermirror might make good use of a pool that
+gradually accumulates all public objects in the world, and stores
+branches very cheaply.
+
+One complication is garbage collection.  Naive implementations that
+store references from branches into the pool will not be able to
+detect objects that are no longer referenced by any active branch; as
+branches are created and deleted over time such objects will
+accumulate.  This may not be a problem in many cases, given the
+relative abundance of disk compared to programmer time, and the
+relatively small number of long branches that are discarded.  There
+are some partial solutions:
+
+* Keep a reference count for each object.  There is no problem of
+  circular references.  However, keeping the count accurately requires
+  that branches are never lost or deleted other than through the
+  correct mechanism.
+
+* From time to time, building a new pool including only objects from
+  active branches.
+
+* Keeping a pool that holds only patches known to be available from
+  elsewhere, so the pool is only a cache and never the single source
+  of a particular object.  Such a pool can then be discarded at will
+  and the objects will be re-fetched from their original source.
+
+This last point suggests that new objects should never be written
+solely into a pool, because of the risk that they might be
+accidentally lost.
+
+Using the parent on the default pool path allows for varying
+greed or laziness in fetching objects.  By default, objects might be
+read only as necessary, and then stored in the local cache.  If the
+user wants to keep the whole history available locally that could be
+specified with a ``--greedy`` option when making the branch, or
+through later pulling down the history.
\ No newline at end of file

=== added file 'doc/purpose.txt'
--- doc/purpose.txt	1970-01-01 00:00:00 +0000
+++ doc/purpose.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,58 @@
+What is the purpose of version control?
+***************************************
+
+There are several overlapping purposes:
+
+* Allowing concurrent development by several people.  Primarily,
+  helping resolve changes when they are integrated, but also making
+  each person aware of what the others have been doing, allowing them
+  to talk about changes, etc.
+
+* To allow different lines of development, with sensible
+  reintegration.  e.g. stable/development, or branches for
+  experimental features.
+
+* To record a history of development, so that you can find out why a
+  feature went in or who added it, or which releases might be affected
+  by a bug.
+
+* In particular, as a *record of decisions* about the project made by
+  the developers.
+
+* Help in writing a gloss on that history; not simply a record of
+  events but an explanation of what happened and why.  Such a record
+  may need to be written at several levels: a very detailed
+  explanation of changes to a function; a note that a bug was fixed
+  and why; and then a brief NEWS file for the whole release.  
+
+  While past events can never change, the intepretation placed upon
+  them may change, even after the event.  For example, even after a
+  release has gone out, one might want to go back and note that a bug
+  was actually fixed.
+
+  The system is helping the developers tell a story about the
+  development of the project.
+
+* As an aid to thinking about the project.  (Much as a personal
+  journal is not merely a record or even analysis of events, but also
+  a chance to reflect and to think of the future.)
+
+  People can review diffs, and then write a description of what
+  changed, and in doing so perhaps realize something else they should
+  do, or realize they made a mistake.  Making branches helps work out
+  the order of feature integration and the stability of different
+  lines of development.
+
+* As an 'undo' protection mechanism.  This is one reason why version
+  control can be useful on projects that have only a single developer
+  and never branch.
+
+* Incidentally, as a backup mechanism.  Version control systems,
+  particularly distributed systems, tend to cause code to exist on
+  several machines, which gives some protection against loss of any
+  single copy.  It's still a good idea to use a separate backup system
+  as well.
+
+* As a file-sharing mechanism: even with just a single developer and
+  line of development it can be useful to keep files synchronized
+  between several machines, which may not always be connected.

=== added file 'doc/python.txt'
--- doc/python.txt	1970-01-01 00:00:00 +0000
+++ doc/python.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,101 @@
+Choice of Python
+----------------
+
+This will be written in Python, at least for the first cut, just for
+ease of development -- I think I am at least 2-3 times faster than in
+C or C++, and bugs may be less severe.  I am open to the idea of
+switching to C at some time in the future, but because that is
+enormously expensive I want to avoid it until it's clearly necessary.
+Python is also a good platform to handle cross-platform portability.
+
+Possible reasons to go to C:
+
+Audience acceptance
+  If Linus says "I'd use it if it were written in
+  C" that would be persuasive.  I think the good developers we want to
+  do not consider implementation language as a dominant factor.  A few
+  related but separate questions are important to them: modest
+  dependencies, easy installation, presence in distributions (or as
+  packages), active support, etc.  A few queries show that Python is
+  seen as relatively safe and acceptable even by people who don't
+  actually use it.
+
+Speed
+  Having scalable designs is much more important.
+  Secondly, we will do most of the heavy lifting in external
+  C programs in the first cut, and perhaps move these into native
+  libraries later.  (Subversion people had trouble in relying on GNU
+  diff on legacy platforms and they had to integrate the code eventually.)
+
+Bindings to other languages
+  If we have only a Python interpretation then it can be run as a
+  shell script from emacs or similar tools.  It can also be natively
+  called from Python scripts, which would allow GUI bindings to almost
+  every toolkit, and it can possibly be called from Java and
+  .NET/Mono.    By the time this is
+  mature, it's possible that Python code will be able to cross-call
+  Perl and other languages through Parrot.  
+  There should be enough options there to support a good
+  infrastructure there of additional tools.
+  If it was necessary to provide a C API that can perhaps be wrapped around a 
+  Python library.
+
+Reuse of tla code
+  That may be useful, if there are substantial sections that approach
+  or meet our goals for both design and implementation (e.g. being
+  good to use from a library.)
+
+  This does not necessarily mean doing the whole thing in C; we could
+  call out to tla or could wrap particular bits into libraries.
+
+
+----
+
+Erik Bgfors:
+
+  However, I think it's very important that a VCS can be wrapped in other
+  languages so that it can be integrated in IDE's and have tools written
+  for them.
+  
+  A library written in c would be simple to wrap in other languages and
+  therefore could be used from for example monodevelop and friends. I
+  really believe this is important for a VCS.
+
+I agree; this is a more important argument against Python than speed,
+where I think we can be entirely adequate just using smart design.
+But there are some partial answers:
+
+We can design bzr to be easily called as an external process -- not
+depending on interactive input, having systematically parsed output,
+--format=xml output, etc.  This is the only mode CVS supports, and
+people have built many interesting tools on top of it, and it's still
+popular for svn and tla.  For things like editor integration this is
+often the easiest way.
+
+Secondly, there is a good chance of calling into Python from other
+languages.  There are projects like Jython, IronPython, Parrot and so
+on that may well fix this.
+
+Thirdly, we can present a Python library through a C interface; this
+might seem a bit wierd but I think it will work fine.  Python is
+easily embeddable; this might be the best way for Windows IDE
+integration.
+
+Finally, if none of these work, then we can always recode in C,
+treating Python only as a prototype.
+
+I think working in Python I can develop it at least twice as fast as
+in C, particularly in this early phase where the design is still being
+worked out.  Although all other things being equal it might be nice to
+be in pure C, but I don't think it's worth paying that price.
+
+  One of the problems with darcs is that it's such a mess wrapping it.
+
+Yes.
+
+----
+
+Experiments to date on large trees show that even with little
+optimization, bzr is mostly disk-bound, and the CPU time usage is only
+a few seconds.  That supports the position that Python performance
+will be adequate.

=== added file 'doc/quickref.txt'
--- doc/quickref.txt	1970-01-01 00:00:00 +0000
+++ doc/quickref.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,28 @@
+bzr init 
+    Prepare to record history in a new working directory.
+
+bzr add FILE...
+    Make one or more files be versioned.  This puts the file in the "added"
+    state, and it will be added by the next commit.
+
+bzr commit [-s MESSAGE] [FILE...]
+    Commit pending changes, with the given commit message.  If no
+    message is given you will be prompted to enter one.
+
+bzr diff [-r REV] [FILE...]
+
+bzr status [FILE...]
+    Show a brief description of the status of a file. 
+
+
+Status codes
+------------
+
+
+
+A 
+    Added 
+D
+    Deleted
+M
+    Modified
\ No newline at end of file

=== added file 'doc/quilt.txt'
--- doc/quilt.txt	1970-01-01 00:00:00 +0000
+++ doc/quilt.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,11 @@
+Quilt
+=====
+
+Descendent of Andrew Morton's patch scripts.
+
+Demonstrates that quite a powerful tool can be built in a relatively
+short time.
+
+Is largely not concerned with preserving a history record.  Allows 
+
+Pop patches off, similar to excluding them.
\ No newline at end of file

=== added file 'doc/random.txt'
--- doc/random.txt	1970-01-01 00:00:00 +0000
+++ doc/random.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,228 @@
+I think Ruby's point is right: we need to think about how a tool
+*feels* as you're using it.
+
+Making regular commits gives a nice rhythm to to working; in some
+ways it's nicer to just commit single files with C-x v v than to build
+complex changesets.  (See gmane.c.v-c.arch.devel post 19 Nov, Tom
+Lord.)
+
+
+* Would like to generate an activity report, to e.g. mail to your boss
+  or post to your blog.  "What did I change today, across all these
+  specified branches?"
+
+
+* It is possibly nice that tla by default forbids you from committing
+  if emacs autosave or lock files exist -- I find it confusing to
+  commit somethin other than what is shown in the editor window
+  because there are unsaved changes. 
+
+  However, grumbling about unknown files is annoying, and requiring
+  people to edit regexps in the id-tagging-method file to fix it is
+  totally unreasonable.
+
+  Perhaps there should be a preference to abort on unknown files, or
+  perhaps it should be possible to specify forbidden files.
+
+  Perhaps this is related to a mechanism to detect conflicted files:
+  should refuse to commit if there are any .rej files lying around.
+
+
+
+   *Those who lose history are doomed to recreate it.*
+         -- broked (on #gnu.arch.users)
+
+   *A universal convention supplies all of maintainability, clarity, consistency, and a foundation for good programming habits too. What it doesn't do is insist that you follow it against your will. That's Python!*
+
+    -- Tim Peters on comp.lang.python, 2001-06-16
+
+    (Bazaar provides mechanism and convention, but it is up to you
+    whether you wish to follow or enforce that convention.)
+
+----
+
+jblack asks for 
+
+   A way to subtract merges, so that you can see the work you've done
+   to a branch since conception.
+
+----
+
+:: 
+
+  <mpool> now that is a neat idea: advertise branches over zeroconf
+  <mpool> should make lca fun :-)
+
+----
+
+http://thedailywtf.com/ShowPost.aspx?PostID=24281
+
+  Source control is necessary and useful, but in a team of one (or even two) people the setup overhead isn't always worth it--especially if you're going to join source control in a month, and you don't want to have to migrate everything out of your existing (in my case, skunkworks) system before you can use it.
+
+  At least that was my experience--I putzed with CVS a bit and knew other source control systems pretty well, but in the day-to-day it wasn't worth the bother (granted, I was a bit offended at having to wait to use the mainline source control, but that's another matter).
+
+I think Bazaar-NG will have such low setup overhead (just ``init``,
+``add``) that it can be easily used for even tiny projects.  The
+ability to merge previously-unrelated trees means they can fold their
+project in later.
+
+
+----
+
+From tridge:
+
+* cope without $EMAIL better
+
+* notes at start of .bzr.log:
+  * you can delete this
+  * or include it in bug reports
+
+* should you be able to remove things from the default ignore list?
+
+* headers at start of diff, giving some comments, perhaps dates
+ 
+  * is diff against /dev/null really OK?  I think so.
+
+* separate remove/delete commands?  
+
+* detect files which were removed and now in 'missing' state
+
+* should we actually compare files for 'status', or check mtime and
+  size; reading every file in the samba source tree can take a long
+  time.
+
+  without this, doing a status on a large tree can be very slow.  but
+  relying on mtime/size is a bit dangerous.
+
+  people really do work on trees which take a large chunk of memory
+  and which will not stay in memory
+
+* status up-to-date files: not 'U', and don't list without --all
+
+* if status does compare file text, then it should be quick when
+  checking just a single file
+
+* wrapper for svn that every time run logs
+
+  - command
+  - all inputs
+  - time it took
+  - sufficient to replay everything
+  - record all files
+
+* status crashes if a file is missing
+
+* option for -p1 level on diff, etc.  perhaps
+
+* commit without message should start $EDITOR
+
+* don't duplicate all files on commit
+
+* start importing tridge-junkcode
+
+* perhaps need xdelta storage sooner rather than later, to handle very
+  large file
+
+----
+
+The first operation most people do with a new version-control system
+is *not* making their own project, but rather getting a checkout of an
+existing project, building it, and possibly submitting a patch.  So
+those operations should be *extremely* easy.
+
+----
+
+* Way to check that a branch is fully merged, and no longer needed:
+  should mean all its changes have been integrated upstream, no
+  uncommitted changes or rejects or unknown files.
+
+* Filter revisions by containing a particular word (as for log).
+  Perhaps have key-value fields that might be used for
+  e.g. line-of-development or bug nr?
+
+* List difference in the revisions on one branch vs another.
+
+* Perhaps use a partially-readable but still hopefully unique ID for
+  revisions/inventories?
+
+* Preview what will happen in a merge before it is applied
+
+* When a changeset deletes a file, should have the option to just make
+  it unknown/ignored.
+
+  Perhaps this is best handled by an interactive merge.  If the file
+  is unchanged locally and deleted remotely, it will by default be
+  deleted (but the user has the option to reject the delete, or to
+  make it just unversioned, or to save a copy.)  If it is modified
+  locall then the user still needs to choose between those options but
+  there is no default (or perhaps the default is to reject the delete.)
+
+* interactive commit, prompting whether each hunk should be sent (as
+  for darcs)
+
+* Write up something about detection of unmodified files
+
+* Preview a merge so as to get some idea what will happen:
+
+  * What revisions will be merged (log entries, etc)
+
+  * What files will be affected?
+
+  * Are those simple updates, or have they been updated locally as
+    well.
+
+  * Any renames or metadata clashes?
+
+  * Show diffs or conflict markers.
+
+  * Do the merge, but write into a second directory.
+
+* "Show me all changesets that touch this file"
+
+  Can be done by walking back through all revisions, and filtering out
+  those where the file-id either gets a new name or a new text.  
+
+* Way to commit backdated revisions or pretend to be something by
+  someone else, for the benefit of import tools; in general allow
+  everything taken from the current environment to be overridden.
+
+* Cope well when trying to checkout or update over a flaky
+  connection.  Passive HTTP possibly helps with this: we can fetch all
+  the file texts first, then the inventory, and can even retry
+  interrupted connections.
+
+* Use readline for reading log messages, and store a history of
+  previous commit messages!
+
+----
+
+20050218090900.GA2071@opteron.random
+
+    Subject:      Re: [darcs-users] Re: [BK] upgrade will be needed
+    From:         Andrea Arcangeli <andrea@suse.de>
+    Newsgroups:   gmane.linux.kernel
+    Date:         Fri, 18 Feb 2005 10:09:00 +0100
+
+    On Thu, Feb 17, 2005 at 06:24:53PM -0800, Tupshin Harper wrote:
+    > small to medium sized ones). Last I checked, Arch was still too slow in 
+    > some areas, though that might have changed in recent months. Also, many 
+
+    IMHO someone needs to rewrite ARCH using the RCS or SCCS format for the
+    backend and a single file for the changesets and with sane parameters
+    conventions miming SVN. The internal algorithms of arch seems the most
+    advanced possible. It's just the interface and the fs backend that's so
+    bad and doesn't compress in the backups either.  SVN bsddb doesn't
+    compress either by default, but at least the new fsfs compresses pretty
+    well, not as good as CVS, but not as badly as bsddb and arch either.
+
+    I may be completely wrong, so take the above just as a humble
+    suggestion.
+
+    darcs scares me a bit because it's in haskell, I don't believe very much
+    in functional languages for compute intensive stuff, ram utilization
+    skyrockets sometime (I wouldn't like to need >1G of ram to manage the
+    tree). Other languages like python or perl are much slower than C/C++
+    too but at least ram utilization can be normally dominated to sane
+    levels with them and they can be greatly optimized easily with C/C++
+    extensions of the performance critical parts.
+

=== added file 'doc/requirements.txt'
--- doc/requirements.txt	1970-01-01 00:00:00 +0000
+++ doc/requirements.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,48 @@
+************
+Requirements
+************
+
+gcc requirements
+----------------
+
+* http://lists.gnu.org/archive/html/gnu-arch-users/2004-06/msg00082.html
+* http://gcc.gnu.org/ml/gcc/2004-06/msg00264.html
+
+Some of these are:
+
+* Must preserve existing history from CVS; must be able to export back
+  out to CVS in case they change their mind.
+
+* Support a single central blessed version.
+
+* Cheap branches and tagging.
+
+* Handle repeated merges; remember the last time something was merged.
+
+* Easy cloning.
+
+* Copy a named patch set (one or more changes) onto a particular
+  branch.
+
+* Unix, Windows, Mac.
+
+* What patches changed a particular symbol?
+
+* annotate function that shows deleted lines.
+
+* Reliable backups.  (bzr can do this simply by cloning, then
+  mirror-sync.)
+
+* Scale to enormously wide and long history.
+
+* Easy to get back to last-known-good state.
+
+
+
+kernel
+------
+
+ * http://www.kerneltraffic.org/kernel-traffic/kt20030323_210.txt
+
+   Discussion of BitKeeper, strengths and weaknesses, and
+   interoperation tools.

=== added file 'doc/revision-syntax.txt'
--- doc/revision-syntax.txt	1970-01-01 00:00:00 +0000
+++ doc/revision-syntax.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,77 @@
+Syntax for identifying revisions
+********************************
+
+There seem to be two main options: use a separate ``-r`` option, or
+put a revision identifier within the filename.
+
+``-r`` options are familiar from CVS and Subversion, and easy to
+specify, and cover almost all situations.
+
+Special identifiers in the filename are sometimes more concise, and
+allow for more complete specification of filenames in the presence of
+renames.  They may be more complex to implement, and will cause some
+filenames to be either forbidden or to require escaping.
+
+----
+
+
+How to interpret revisions in the presence of renamed files?  Suppose
+hello.c was renamed in r3; when we do ``bzr diff -r2 hello.c`` should
+we compare to 
+
+* the file currently called ``hello.c``, as it was in revision 2, even
+  if it then had a different name
+
+or
+
+* the file that was called ``hello.c`` in revision 2, even if that is
+  a different file-id?
+
+Often only one will work, but it is possible to have situations where
+in revision 2 there was a file called ``hello.c`` but it is not the
+same one that now has that name.
+
+If we can have a simple syntax that accomodates either that would be
+good.  One might be to mix revision numbers into the path, rather than
+a separate ``-r`` option.  For example::
+
+   hello.c@2
+   @2/hello.c
+
+   src/@2/hello.c
+
+The simplest case is to just append the number, but you can vary
+them.  It might even be possible to chain them, getting the file id
+from one revision and its state from another:
+
+  @70/hello.c@31
+
+This means "the file that was called ``hello.c`` in revision 70, give
+me its state in revision 31."  (If you wanted to do this across
+branches, I think you might need to get the file id and then look it
+up, etc.)
+
+Some more syntax: you can refer to a revision by its hash just by
+specifying that; we can distinguish them from anything else by their
+length::
+
+  hello.c@09fac8dbfd27bd9b4d23a00eb648aa751789536d 
+
+(Is that really safe?  Perhaps some punctuation is needed to
+distinguish it from a label.  But then I think people should rarely or
+never use them; perhaps it need not be allowed at all.)
+
+You can also give a date, which is used to find the most recent
+revision no later than that date::
+
+  hello.c@{2004-12-01}
+  hello.c@{yesterday}
+  ./@{10:30}/
+
+(Braces can be a bit scary for shell, but if there are no commas they
+are somewhat safe.)
+
+Or, once we have labels, you can use a label::
+
+  hello.c@release-2.2
+

=== added file 'doc/roadmap.txt'
--- doc/roadmap.txt	1970-01-01 00:00:00 +0000
+++ doc/roadmap.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,61 @@
+Roadmap for Bazaar-NG
+*********************
+
+(This document contains only things still-to-do, in in approximate
+order.  For a list of things already done, see the `development
+news`__.)
+
+__ news.html
+
+* get doctest going again now that we have predictable-order status
+  commands
+
+* note at top of .bzr.log
+
+* basic local versioning working: init, add, remove, mv, status, log,
+  diff, commit, revert
+
+  * revert command
+  * mv command
+  
+* some commands should work on selected files, if any are given:
+
+  * diff
+  * status
+  * log
+  * commit
+
+* work properly when invoked from a subdirectory
+
+* give a file-id to tree root?
+
+* use stat information to detect unchanged files without reading the
+  full text (or establish that this is not safe).
+
+* basic find command: find versioned, deleted, unknown, etc.
+
+* branch command
+
+* get a branch from an http server (remote Tree/Store/Branch proxy
+  classes)
+
+* write experimental weave algorithm in Python to see how it works?
+
+* update command: pull in changes from another branch that is a strict
+  superset of the destination
+
+* merge command: reconcile changes in this branch with those in
+  another.  punt on structural changes at first and only merge text,
+  then work out a nice way to resolve structure.
+
+* ``vc-bzr.el`` emacs support
+
+* *go self-hosting at about this point*, with parallel commits to baz
+
+* ignore patterns from ``.bzrignore``
+
+
+
+longer-term things:
+
+* Some kind of `compressed storage <compression.html>`_.
\ No newline at end of file

=== added file 'doc/rollup.txt'
--- doc/rollup.txt	1970-01-01 00:00:00 +0000
+++ doc/rollup.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,68 @@
+Roll-up changesets
+******************
+
+Sometimes it is useful to collapse changes; sometimes it is useful to
+pull in patches while keeping their original identity.  So (uniquely?)
+Bazaar-NG allows either option at the user's discretion.
+
+I'm not completely sure yet how this should be controlled: should it
+be an option at every stage, or should mergers generate roll-up
+changesets?  I think possibly the second.
+
+Rolled-up changesets can be represented as so::
+
+  mbp, 2005-04-01
+  import new quantum-computing feature
+
+    jrh, 2005-03-02
+    stub implementation for quantum computing
+
+    jrh, 2005-03-03
+    plus operator
+    
+    jrh, 2005-03-04
+    regexps
+
+    jrh, 2005-03-03
+    fix bugs, ready to go
+
+down to an arbitrary level of nesting.
+    
+When bringing changes into a branch, we have the choice of either
+rolling them up into a single changeset or bringing them across
+individually.  I'm not sure, but I think this may be best handled by
+having two separate commands:
+
+* *update* (or maybe *pull*) brings across revisions onto the current
+  branch, adding them one-by-one into the revision history.  This can
+  only be executed if the destination branch is a prefix of the source
+  branch and therefore we know the patches will apply perfectly.
+
+* *merge* pulls in one or more changes from another branch, and allows
+   the user to edit the merged state or fix any conflicts.  These
+   changes are then all marked as rolled-up by a new commit.  It is
+   possible to look up those changes inside the commit, if the
+   information is still accessible.
+
+In this model, Arch is missing the first command: you cannot put
+patches from one branch onto another -- and it would be hard to add
+it, since the unique branch id is part of the name of the patch name.
+
+Most other tools are missing the second: it is impossible to combine
+changesets and therefore the total history of any branch can grow very
+long; there is no way to make summaries within the tool itself.
+
+People might also want to retrospectively zip up several changes
+existing on a branch, but I think it may be better to make a new
+branch from before the changes and pull them across onto that.
+
+----
+
+One interesting application of this is in maintaining the ``NEWS``
+file present in many software distributions.  This summarizes the
+changes to the software in each release at a very high user-visible
+level.  Although this is very much version-control data it is not
+normally known to the VC system, except as another versioned file.
+
+One way to handle this is to have a *release* branch, where the commit
+message for each release the NEWS notes for that release.

=== added file 'doc/scalability.txt'
--- doc/scalability.txt	1970-01-01 00:00:00 +0000
+++ doc/scalability.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,20 @@
+***********
+Scalability
+***********
+
+bzr needs to scale up very well: projects with tens of thousands of
+commits, tens of thousands of files, and tens of thousands of
+branches.
+
+We are concerned with both the big-O performance of the design, and
+the multiplicative factors of the implementation.  Both is important.
+
+For example, darcs, svn and arch use more than one inode per working
+file (pristine, id file, etc).  This is only a constant factor, but
+enough to more than double the space used by a typical tree.  We would
+like to avoid it if we can.
+
+From a early stage in development the features which do work should be
+tested on large trees.
+
+

=== added file 'doc/security.txt'
--- doc/security.txt	1970-01-01 00:00:00 +0000
+++ doc/security.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,409 @@
+*****************************
+Security aspects of Bazaar-NG
+*****************************
+
+
+* Good security is required.
+
+* Usability is required for good security.
+
+    Being too strict "because it's the secure way" just means that people will
+    disable you altogether, or start doing things that they know is wrong,
+    because the right way of doing this may be secure, but [..] also very
+    inconvenient. 
+
+    -- Linus Torvalds
+
+.. contents:
+
+Requirements
+============
+
+David Wheeler gives some good requirements__:
+ 
+    Problem is, the people who develop SCM tools often don't think about what kind of security requirements they need to support. This mini-paper describes briefly the kinds of security requirements an SCM tool should support. 
+
+__ http://www.dwheeler.com/essays/scm-security.html
+
+    confidentiality_
+      Are only those who should be able to read information able to do so?
+
+    integrity
+      Are only those who should be able to write/change information able to do so? This includes not only limiting access rights for writing, but also protecting against repository corruption.
+
+    availability
+      Is the system available to those who need it? (I.E., is it resistant to denial-of-service attacks?)
+
+    identification/authentication
+      Does the system safely authenticate its users? If it uses tokens (like passwords), are they protected when stored and while being sent over a network, or are they exposed as cleartext?
+
+    audit
+      Are actions recorded?
+
+    non-repudiation
+      Can the system "prove" that a certain user/key did an action later?
+
+    self-protection
+      Does the system protect itself, and can its own
+      data (like timestamps) be trusted?
+
+    trusted paths
+      Can the system make sure that its communication with users is
+      protected?
+
+Attacker categories
+-------------------
+
+* Unprivileged outsiders.
+
+  (Almost always read-only, but people might want to allow them to
+  write in some cases, e.g. for wikis.)
+
+* Non-malicious developers with privilege.
+
+* Malicious developers with privilege.
+
+* Attackers who have stolen a privileged developer's identity.
+
+
+Access control
+--------------
+
+Dan Nicolaescu gives these examples of access control:
+
+  - security related code that is still emabargoed, only select few
+    are allowed to see it, it is not desirable to release this
+    information to the public because a fix is still being worked
+    on. It would be nice to be able to have this kind of code under
+    the same version control system used for normal development for
+    ease of use and easy merging, yet it is crucial to restrict access
+    to a branches, files or directories to certain people.
+
+  - feature freeze before a release. It would be good if the release
+    manager could disable writing to the release branch, so that the
+    last tests are run, and not have someone commit stuff by mistake. 
+
+  - documentation/translation writers don't need write access to the
+    whole source code, just to the documentation directories. 
+
+  - For proprietary companies restricting access is even more
+    important, for example only some engineers should access the
+    latest development version of some code in order to keep some
+    trade secrets, etc, etc.
+
+In Bazaar-NG, the basic unit of access control is the branch.  If
+people are not supposed to read a branch, or know of its existence,
+put it somewhere where they can't see it.  If people are allowed to
+read from but not write to a branch then set those permissions.  The
+code can later be merged into a public branch if desired with no loss
+of function.
+
+We largely rely on lower-level security measures controlling who can
+get read or write access to a branch.  If you have a branch that
+should be confidential, then put it on an appropriately-secured
+machine, with only people in a particular group allowed to read it.
+
+Not having separate repositories is probably a feature here -- unlike
+Subversion, no features depend on having branches be in the same
+repository.  Each repository can have different group ownership.
+(The directories should usually be setgid.)  It also makes it easier
+to see just what the access control is; there is only one object that
+can meaningfully have an ACL.
+
+The existence of a secret branch can be fairly well hidden from the
+world.  When its changes are merged in, all that is visible is the
+name, date, and branch name of the commit, not anything about the
+location of the source branch.
+
+The documentation case I would handle by having a separate
+documentation branch, which could perhaps be checked out into a
+subdirectory when it is required.  I think this is fairly common for
+larger projects even in CVS.
+
+
+
+
+Confidentiality
+---------------
+
+As dwheeler points out, this can be important even for open source
+projects, such as when preparing a security patch.
+Mechanisms that send email should have an option to encrypt the mail.
+
+I can't think of anywhere encrypted archives would be useful.  If you
+want to store it on an encrypted filesystem you can.  If you want to
+store encrypted files you can do that too, though that will leak some
+information in the metadata and branch structure.
+
+
+Security in distributed systems
+-------------------------------
+
+If I have a branch on my laptop, the software ultimately cannot
+prevent me doing anything to that branch -- physical access trumps
+software controls.  We can, at most, try to prevent non-malicious
+mistakes.
+
+The purpose of the software here is to protect other people, whose
+machines I do not control.  In particular, it should be hard for me to
+lie to them; the software should detect any false statements.
+
+In particular, these should be prevented:
+
+ * Claiming to be someone else.
+
+ * Attempting to rewrite history.
+
+
+Revocation
+----------
+
+Suppose Alice's code-signing key is stolen by an attacker Charles.
+Charles can sign changesets purporting to come from Alice.  
+
+Alice needs to revoke that key; hopefully she has saved a copy of the
+key elsewhere and can use that to revoke it.  Failing that she can
+mail everyone and ask them to delete it.  This can propagate through
+the usual GPG mechanism, which is very nice.
+
+Alice also needs to make a new key and get it trusted.
+
+This revocation does not distinguish between changesets genuinely
+signed by Alice in the past, and changesets fraudulently signed by
+Charles. 
+
+What can Alice do now?  First of all, she needs to work out what
+changesets signed by her key can still be trusted.  One good way to do
+this is to check against another branch signed by Bob.  If Bob's key
+is safe, we know his copy of Alice's changesets are OK and the full
+tree at various points is OK.
+
+Then:
+
+ * Go through her old changesets, check that they're OK -- perhaps
+   restore from a trusted backup.  Re-sign those changesets with a new
+   key bound to the same email address.  Publish the new signatures
+   instead.
+
+   (This seems to indicate it is a good idea to bind signatures to
+   changeset by author name/address rather than by key ID.)
+
+ * Roll-up all previous development into a new tree, then sign that.
+   This means there is no safe access to the previous individual
+   changes, but in some cases it may be OK.
+
+If a key is revoked at a particular time then perhaps we could still
+trust commits made before that time.  I don't know if GPG revocations
+can support that.
+
+
+Old keys
+--------
+
+Keys also expire, rather than being revoked.  What does this mean?
+
+Ideally we would check that the date when a changeset claims to have
+been signed is within the validity period of the key.  This requires
+more GPG integration than may at the moment be possible, but in theory
+we can do it.
+
+Also need to make sure that commits are in order by date, or at least
+reasonably close to being in order (to allow for some clock skew).
+
+One interesting case is when version is committed for which both the
+public and private keys have been lost.  This will always be
+untrusted, but that should not prevent people continuing to use the
+archive if they can accept that.
+
+This suggests that perhaps we should allow for multiple signatures on
+a single revision.
+
+
+Encumbrance attacks
+-------------------
+
+A special case where we need to be able to destroy history to avoid a
+legal problem.  Allowed as discussed elsewhere: either destroy commits
+from the tail backwards, or equivalently branch from a previous
+revision and replace with that.
+
+People who saw the original branch can still prove it happened; people
+who look in the future will not see any record.  
+
+Either way, probably requires physical branch access.
+
+
+Multiple signature keys
+-----------------------
+
+Should we allow for several signatures on a single changeset?  What
+would that mean?  How do we know what signatures are meaningful or
+worthwhile?
+
+
+Forensics
+---------
+
+dwheeler:
+
+   [O]nce you find out who did a malicious act, the SCM should make it
+   easy to identify all of their actions. In short, if you make it
+   easy to catch someone, you increase the attackers' risk... and that
+   means the attacker is less likely to do it.
+
+dwheeler asks that the committer's IP address be recorded.  Putting
+this in the changeset seems to cause too much of a
+privacy/confidentiality problem.  However, an active server might
+reasonably record the IPs of all clients.
+
+
+Non-repudiation
+---------------
+
+If a changeset has propagated to Bob, signed by Alice's key, then Bob
+can prove that someone possessing Alice's key signed it.  Alice's only
+way out is to claim her key was stolen.
+
+
+Trusted review
+--------------
+
+Can be handled by importing onto another branch.  Can have various
+levels for "quickly checked", "deeply trusted", etc.
+
+(Is it really necessary to import onto a new branch rather than add
+anotations to existing branches?  Copying the whole text seems a bit
+redundant.  This might be a nice place for arch-style taggings, where
+we just add a reference to another branch.)
+
+
+Hooks
+-----
+
+Automatically running hooks downloaded from someone else is
+dangerous.  In particular, the user may not have the chance to check
+the hooks are reasonable before they are run.
+
+Conversely, users can subvert client-side hooks.  If we want to run a
+check before accepting code onto a shared branch, that must run on the
+server.
+
+Enforcing server-side checks gives a good way to run build,
+formatting, suspiciousness checks, etc.  This implies that write
+access to a repository is through a mediating daemon rather than by
+directly writing. 
+
+
+
+Signing
+-------
+
+We use signing to prove that a particular person (or 'principal',
+possibly a robot) committed a particular changeset.
+
+It is the job of external signing software to help work out whether
+this is true or not.  This has several parts:
+
+ * Mathematical verification that a signature on a particular 
+   changeset header document is correct
+
+ * Determining that the signature corresponds to a particular public
+   key
+
+ * Determining that the public key corresponds to the person claimed
+   to have authored the changeset (identified by email address.)
+
+The second two are really PKI functions, and somewhat harder than the
+first.
+
+The canonical implementation is to use GPG/OpenPGP, but anything will
+do.  There are simpler RSA/DSA implementations which assume each user
+manually builds a list of trusted keys.
+
+This leaves open the question of which people should be trusted to
+provide software on a particular branch or at all.  This is not a very
+easy question for software to answer.  We assume that people will know
+by other means.  For public code, it may be that all changesets are
+re-signed by say samba-team@samba.org.
+
+I think it is fair to distinguish people by an email address, or at
+least by $ID@$DOMAIN.  There is no need to have this actually receive
+email, so spam need not be a problem.
+
+The signing design is inspired by the very usable security afforded by
+OpenSSH: it automatically protects where it can, and allows higher
+security to users who want to do some work (by offline verification of
+signatures).
+
+Using a signing mechanism other than GPG when key developers already
+have GPG and there is a big infrastructure to support it seems
+undesirable.  It is true that GPG is quite complex.
+
+The purpose of signing is to protect against unauthorized modification
+of archives. 
+
+Bazaar-NG can apply a GPG signature to both patches and manifests.  This
+vallows a later proof that the revision and the changeset were produced
+by the author they claim to have been written by.
+
+We cannot cryptographically prove that a particular patch was merged
+into a branch, because the person doing the merge might have subverted
+the patch in the process of merging it.  All we can prove
+cryptographically is that the merge committer asserts they took the
+patch.
+
+GPGME and PyMe seem to give a reasonable interface for doing this:
+there is a function to check a signature, and the return indicates the
+signing name, with possible errors including a missing key, etc.
+
+
+Sign branches, not revisions
+''''''''''''''''''''''''''''
+
+Aaron Bentley suggested the interesting idea of signing the mapping of
+revisions onto branches, rather than revisions themselves.  For
+example a branch could contain just a signed pointer to the most
+recent revision. 
+
+(It probably is useful to be able to check signatures on previous
+revisions, for example when recovering from an intrusion.)
+
+
+Protocol attacks
+----------------
+
+Both client and server should be resistant to malicious changesets,
+network requests, etc.  There's no easy solution.
+
+* Defense in depth.  Check reasonablenes at various points.
+
+* Disallow changesets that try to change files outside of the branch.
+
+
+Availability
+------------
+
+bzr can be configured so as to have no single point of failure to a
+denial-of-service attack (or at least nearly none):
+
+* Can have any number of mirrors of a branch.
+
+* If a central server is taken out, developers can continue working
+  with state they already have (unbind their branches), and can
+  collaborate by email or other means until the server is repaired or
+  replaced.
+
+* The origin branch can be on a machine whose location is secret and
+  which is not directly publicly accessible.
+
+* Branches can be moved between machines or IP addresses without
+  disrupting anything else.
+
+* Branches can be moved around out-of-band, as tarballs over
+  bittorrent, etc.
+
+I think the only possible denial of service attacks are those that aim
+to shut down the entire network, or block communication with
+individual developers, for example by flooding their email address.
+But if those people can get connected through some other means, they
+can continue.

=== added file 'doc/shared-branches.txt'
--- doc/shared-branches.txt	1970-01-01 00:00:00 +0000
+++ doc/shared-branches.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,137 @@
+***************
+Shared branches
+***************
+
+How much can we simulate the single-branch model of svn/cvs?  GNU arch
+does reasonably well, but at the cost of making disconnected/connected
+operation leave ugly merge marks in the project history.
+
+This does seem to be a drawback of the otherwise-good branch/tree
+fusion.
+
+`Greg Hudson`__ makes the very good point that the Linux kernel is
+quite unusual among free software projects in relying on human
+integrators, rather than having a shared branch between the
+committers.  The other case is very small projects (distcc?) where
+there is a single person with commit access.
+
+__ http://web.mit.edu/ghudson/thoughts/bitkeeper.whynot
+
+I think decentralized systems can still be very good, but they need to
+support this model very well: a team of committers, working on a
+single trunk branch, but merging from other branches as well.  The
+Samba team is more typical of a demanding open-source project than the
+kernel is.
+
+People fundamentally want to be able to share a tree and all commit
+into it.  It's fine to support other models (like sending patches to
+an owner/integrator/maintainer), but it is not reasonable to require
+that there be exactly one such person.
+
+arch-pqm is a clever kludge; shouldn't be required.  Setting up email
+on all clients, and scripts to automatically process email on the
+server is certainly possible.  But for some people it may not be easy;
+it is never trivial to debug; and particularly for Windows users it
+may be very hard.  If you don't control your own email server or
+cannot  easily run scripts it will be even more messy.
+
+The model of Bitkeeper, and the default model of Bazaar-NG, is that
+each branch has one owner and exists in one place.  People submit
+their patches to the owner of the branch.  This is a pretty good
+model, but has some limitations.
+
+It is a tough transition from CVS; it requires that people learn a
+whole new way of working as well as a new tool.
+
+If the person who owns the branch is away, should all integration
+work stop?
+
+I'm not totally confident in Darcs; it seems like the shared branch
+can reach a state that is not exactly the same as any of the
+checkouts.  Maybe not?  In other respects it is a good model.
+
+Possible solution: bound branches
+---------------------------------
+
+You can make a branch which is a write-through mirror of another
+branch.  They work like CVS checkouts in that you must be connected
+and fully up-to-date to commit.  These can hold as much history as you
+like from the main branch, so you can view history, annotate, make new
+branches when offline.  If you are offline for a long time then make a
+new branch, then integrate it back later.
+
+The effect is similar to systems which have separate working copies
+and storage: we have one branch used primarily as a workarea, and
+another used as storage.  I think that making them both branches
+is possibly cleaner: it expresses the way some state may be held
+locally, allows offline branching from the bound branch, etc.
+
+:: 
+
+    $ bzr get http://foo.net/foo ./foo-main
+    $ cd foo-main 
+    (make some changes)
+    $ bzr commit -m 'Add my neat feature'
+    bzr: error: this branch is not-up-to-date with master 
+        http://foo.net/foo
+    - run 'bzr update'
+    - or detach this branch from its parent to work independently
+    $ bzr update
+    - setting aside local changes
+    - pulling changes from parent
+    - putting back local changes
+    $ bzr commit -m 'Add my neat feature'
+
+The ``get`` command is very similar to ``branch``, but means that
+commits will be written back.
+
+This means that the ``pull`` or ``update`` command must be able to
+work even when there are local changes, by setting them aside.  This
+in turn means that local changes may conflict with remote changes, and
+that has to be resolved -- that is no worse than in pulling in changes
+from elsewhere.
+
+commit to a master repository should fail if the slave's patch history
+is not exactly equal to that of the master -- the slave has diverged.
+If the slave history is a prefix of the master history then an update
+will do it.  Otherwise, they have diverged and the slave gets
+detached.
+
+We can have shared server-side hooks, even for access control, at
+least in principle.
+
+Perhaps ``bind`` is a nicer word than ``slave``.
+
+It is conceptually possible to take an existing branch and bind it to
+another, as long as the history of the first is a prefix of that of
+the second.  One could also unbind a branch.  These should at most be
+advanced commands, because in general it is simpler just to make a new
+branch with the desired properties.
+
+Difficulties
+~~~~~~~~~~~~
+
+It may be a bit hard to get a remote commit exactly right,
+particularly if we want to keep a working copy there.  If working
+copies are optional, then turning it off will keep things simple but
+not totally avoid the problem.
+
+I think this is just an example of a general problem though: there is
+no totally satisfactory way to atomically update a working copy.
+(What happens to cvs or svn if you interrupt while it's doing this?
+Generally you get a broken wc.)  What we can do is create a lock while
+the update is taking place, which can be used to at least detect the
+problem. 
+
+If changes are allowed to the working copy of the master branch then
+they might conflict with what is committed by the slave.  Should those
+changes be merged into the working copy of the parent?  If so, they
+might conflict.  
+
+  (darcs handles this case by inserting conflict markers in the remote
+  file, which seems unsatisfactory to me.)
+
+So I am inclined to say that at the moment of pushing to a master
+branch, the destination should be clean.  If we have explicit edits
+then probably there should be no editable files there.  (We could
+perhaps make all the files read-only for the duration of the update.)

=== added file 'doc/short-demo.txt'
--- doc/short-demo.txt	1970-01-01 00:00:00 +0000
+++ doc/short-demo.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,152 @@
+******************************
+Learn Bazaar in twenty minutes
+******************************
+
+
+:Author:
+  Martin Pool <mbp@sourcefrog.net>
+
+:Date: November 2004, London
+
+
+*Bazaar* is an open source distributed version control system.  A
+version control system helps you develop software (or other documents)
+
+In Bazaar, branches hold a history of their changes.  All working
+copies are branches, and all branches are working copies.
+
+Let's get a copy of someone else's published project::
+
+    $ baz branch http://baz.alice.org/hello-2.6
+
+This creates a directory called ``hello-2.6`` in your current
+directory, containing Alice's *Hello World* 2.6 tree and a history of
+her changes.  We'll leave this directory containing a pristine copy of
+her work for future reference.
+
+We want to add a new feature.  Branching and merging is are cheap and
+easy in Baz, so development of each new feature should be done on a
+new branch -- this lets you merge them in different orders, and leave
+aside new development to fix a bug if you want.  It's good to choose a
+meaningful name for your development branches so that you can keep
+them straight.  So let's make an additional branch, based off our
+local copy of Alice's branch::
+
+    $ baz branch ./hello-2.6 ./hello-2.6-goodbye
+
+This command completed quickly: we didn't need to fetch anything from
+Alice's server to make a new branch.
+
+Now we have a second directory containing another copy of the source,
+with a different name.  Of course both are still the same as Alice's
+source.  Time to hack::
+
+    $ cd hello-2.6-goodbye
+    $ vi hello.c
+
+We add a new and much-desired ``--goodbye`` option, build and test
+it.  Having got to a good state, we think we're ready to commit our
+changes.  Many people find it helpful to review the changes before
+committing them, just to make sure there were no accidental mistakes::
+
+    $ baz diff | less
+
+This shows the changes relative to the version we started with.  If
+that looks OK, we're ready to commit::
+
+    $ baz commit -m 'Add --goodbye option'
+
+This records the changes into this branch.  We can see that they got
+recorded::
+
+    $ baz log | less
+
+This will show our change as the most recent, preceded by all our
+development.  If we only want to see our own changes, we can filter
+the log in various ways::
+
+    $ baz log --author bruce@ 
+    $ baz log --date today 
+
+(That second one might include anything Alice did before we started.)
+
+Since our changes were committed, we don't have anything outstanding,
+as we can see with this command::
+
+    $ baz diff 
+    No changes
+
+Thinking about it a bit more, we decide that it's too messy to mix the
+"Goodbye" implementation in with "Hello world".  We start up our
+editor and split it our into a new separate file, ``bye.c``.  By
+default, Baz assumes unknown files in the working directory are
+scratch files -- the same behaviour as CVS and Subversion.  We need to
+tell Baz that this file should be versioned, and then we can commit::
+
+    $ baz add bye.c
+    $ baz commit -s 'Refactor bye() into separate file'
+
+Of course this commits all our changes as a single atomic
+transaction.  If we wanted, we could tell Baz to build the program
+before committing to help ensure we never get a broken build.
+
+We're ready to publish our improved Hello World, but first we want to
+make sure we've integrated anything Alice has done while we were
+working.  First we update our mirror of Alice's branch::
+
+    $ baz sync ../hello-2.6
+
+This pulls the history of her branch onto our machine; we could
+disconnect from the network at this point and do all the merging work
+without needing to connect to ``alice.org``.   
+
+Now we'll pull Alice's new changes into our branch.  We can use a
+mirror of her branch, or we can go straight to her public branch.  In
+fact, we can merge from different copies of the same branch at
+different times, and Baz will still understand which changesets have
+already been merged.  Either of these commands will work::
+
+    $ baz merge ../hello-2.6
+    $ baz merge http://baz.alice.org/hello-2.6
+
+This pulls down any changesets on Alice's branch that aren't in ours,
+and applies them to our tree.  Since we've made changes in parallel
+with Alice, those changes might conflict.  Baz by default will insert
+CVS-style conflict markers into your branch if that happens, but you
+can also ask it to run a graphical merge tool or to tell emacs to do
+the merge.  Baz will help you merge changes other than file text, such
+as a file being renamed in one branch.  
+
+By running ``baz diff`` we can see the effect of her changes on our
+tree.  By running ``baz log --pending`` we can see a description of
+all of the changes that were pulled in.  Once the changes have been
+reconciled (which will often happen automatically), we can commit this
+to our branch::
+
+    $ baz commit -s 'Merge from Alice'
+
+Baz records that our change incorporates those patches from Alice::
+
+    $ baz log | less
+
+Now that we have the feature we wanted, we can publish our branch on
+the web.  We could copy it up using ``baz branch``, but because Baz
+branches are simply directories we can just rsync it onto a web
+server, even if the web server doesn't have Baz installed::
+
+    $ rsync -av ./hello-2.6-goodbye webserver.com:public_html/
+
+We send an email to Alice asking her to merge from this location.
+Typically she'll want to have a look at those changes before accepting
+them, and she can do that by running ``merge`` then ``diff``, as we
+did before.  If she likes the change, she can merge it, possibly
+applying some fixes in the process.  Next time we merge from her,
+we'll see our changes are in.
+
+
+
+.. Local variables:
+.. mode: rst
+.. compile-command: "rest2html short-demo.txt > short-demo.html"
+.. End:
+

=== added file 'doc/supportability.txt'
--- doc/supportability.txt	1970-01-01 00:00:00 +0000
+++ doc/supportability.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,23 @@
+************************
+Bazaar-NG Supportability
+************************
+
+The goal is to be able to diagnose and fix a bug the first time it is
+reported, even if the reporter or developer can't reproduce it.
+
+Done:
+
+* Verbose logs are always written to ``.bzr.log`` in the current
+  directory.  This include all error messages and some trace messages
+  that are not normally displayed.  It also includes backtraces if
+  an exception occurs.
+
+To do:
+
+* The --verbose option should send debug output to stderr.
+
+* Re-read changesets after writing them to a temporary file, but
+  before permanently committing them.  Make sure that they are valid
+  XML (against RELAX-NG schema), that they can be parsed, and that
+  they recreate the right revision.  This should help prevent the
+  archive ever getting corrupted, which is a pain to reverse.

=== added file 'doc/svk.txt'
--- doc/svk.txt	1970-01-01 00:00:00 +0000
+++ doc/svk.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,11 @@
+svk
+===
+
+The strategic strength is that it can trivially and reliably
+interoperate with upstream projects using Subversion.  This tends to
+satisfy people who need disconnected operation, and so to allow
+projects to feel safe about switching to Subversion.
+
+On the other hand it may be a bit flaky in implementation; being
+written in Perl on top of Svn bindings may not inspire confidence;
+relatively little documentation.

=== added file 'doc/tagging.txt'
--- doc/tagging.txt	1970-01-01 00:00:00 +0000
+++ doc/tagging.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,98 @@
+*******
+Tagging
+*******
+
+
+It is useful to be able to point to particular revisions on a branch
+by symbolic names, rather than revision numbers or hashes.
+
+
+Proposal: just use branches
+---------------------------
+
+This is probably the simplest model.
+
+In both Subversion and Arch, tags are basically just branches that do
+not differ from their parent revision.  This has a few advantages:
+
+* We do not need to introduce another type of entity, which can
+  simplify both understanding and implementation.  We also do not need
+  a special 
+
+* If branches are cheap (through shared storage, etc) then tags are
+  also appropriately cheap.
+
+* The general idea is familiar to people from those two systems (and
+  probably some others).
+
+* People often do put tags in the wrong place, and need to update
+  them, or want tags that move along from one state to another
+  (e.g. ``STABLE``.)  Tags-as-branches capture this through the usual
+  versioning mechanism, rather than needing to invent a parallel
+  versioning system for tags.
+
+There are some problems:
+
+* Users want tags to stay fixed, but branches are things that can be
+  committed-to.  So at one level there is a mismatch.
+
+* In particular, it can be easy to accidentally commit onto a tag
+  branch rather than a "branch branch", and that commit can easily be
+  'lost' and never integrated back to the right place.
+
+One possible resolution is to have a voluntary write-protect bit on a
+branch, which prevents accidental updates.  (Similar to the unix owner
+write bit.)  When it is necessary to update the branch, that bit can
+be removed or bypassed.
+
+This is an alternative to the Arch ``--seal`` mechanism.
+
+
+
+Proposal: tags within a branch
+------------------------------
+
+(This is probably "crack"; I don't think we'll do this.)
+
+You can place tags on a branch as shorthand for a particular
+revision::
+
+  bzr tag rel3.14.18
+
+  bzr branch foo-project--main@rel3.14.18
+
+Tags are alphanumeric identifiers that do not begin with a digit.
+Tags will cover an entire revision, not particular files.
+
+Another term sometimes used is "labels"; I think we're close enough to
+CVS's "tags" that it's good to be consistent.  However, it does
+possibly clash with Arch's ``tag`` command and ``id-tagging-method``
+(sheesh).
+
+In Subversion a tag is just a branch you don't commit to.  You *can*
+work this way in Bazaar if you want to.  (And until tags are
+implemented, this will be the way to do it.)
+
+I'm not sure if tags should be versioned objects or not.  Options:
+
+* Tags are added or changed by a commit; they mark previous revisions
+  but are only visible when looking from a later commit.
+
+* Tags are not versioned; if you move them they're gone.
+
+* Tags exist within their own versioning space.
+
+It is useful to have mutable tags, in case they're incorrectly placed
+or need to be updated.  At the same time we do not want to lose
+history.  I think in this model it is not helpful to update tags
+within revisions.  One approach would be to version tags within a
+separate namespace, so 
+
+  | STABLE.0
+  | STABLE.1
+  | STABLE.2
+
+as just STABLE it finds the most recent tag.
+
+(Is this kludgy?)
+

=== added file 'doc/taxonomy.txt'
--- doc/taxonomy.txt	1970-01-01 00:00:00 +0000
+++ doc/taxonomy.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,64 @@
+Taxonomy of version control systems
+===================================
+
+(ie a look at "cutting questions" that describe different design
+approaches.)
+
+
+History in working copy
+-----------------------
+
+Is history stored with working directory (bk, rcs, darcs), or
+separately (cvs, baz)?
+
+Storing in the working directory may be simpler in some respects;
+it's one less concept people need to learn.  On the other hand
+people typically have more working copies than branches, and this
+approach means having more copies of the history.
+
+Naively, storing everything in the working copy can mean that you
+keep multiple copies of the history, which would use a lot of disk,
+or 
+
+Rewriting history
+-----------------
+
+Can you change recorded history (darcs); only do this through a
+special mechanism (cvs, svn); or not do it at all?
+
+Being absolutely able to reproduce any point in time reliably is
+highly attractive.  On the other hand, sometimes people commit
+something (e.g. confidential information) that really should not be
+recorded.  And at a smaller level people might just commit the wrong
+message.
+
+
+Explicit edits
+--------------
+
+Can you edit any file in a working copy (cvs, tla) or must you
+specially mark the before editing (rcs, bk)?
+
+There are two reasons to mark files for editing.  One is so that
+people can be notified that a file is about to
+
+
+Track history of patches
+------------------------
+
+Can you see how a patch got to its current destination?  As far as I
+know only arch can do this -- you can see what branches it
+incorporates changes from.  Well, kind of; not in an entirely
+straightforward manner.
+
+
+
+Collapsing patches
+------------------
+
+When patches from other people are integrated, can they be rolled up
+into larger patches (arch) or do they retain their individual identity
+(bk, darcs)?
+
+
+

=== added file 'doc/testing.txt'
--- doc/testing.txt	1970-01-01 00:00:00 +0000
+++ doc/testing.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,27 @@
+***********************
+Test plan for Patchflow
+***********************
+
+This should be amenable to good automated testing.  Here are some
+ideas.
+
+* Corrupt the branch in various ways and make sure it is detected.
+
+  - To start with test all cases checked by check()
+
+* Commit.
+
+
+I'm using doctest_ for some API tests, and it looks pretty nice.  It
+adds some documentation of the pre/post-conditions of various
+operations.  It also encourages creating a clean and friendly Python
+API.
+
+Testing through the Python API does not cover all of the external
+shell interface, but it is much easier to write, because we don't need
+to deal with serializing everything to/from text.
+
+We may need additional tests to this.
+
+
+.. _doctest: http://docs.python.org/lib/module-doctest.html
\ No newline at end of file

=== added file 'doc/thanks.txt'
--- doc/thanks.txt	1970-01-01 00:00:00 +0000
+++ doc/thanks.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,23 @@
+******
+Thanks
+******
+
+Inspiration, suggestions, advice
+--------------------------------
+
+* Mark Shuttleworth
+* Robert Collins
+* David Allouche
+* Robert Weir
+* James Blackwell
+* Garrett Rooney
+* Andrew Tridgell
+* Paul Russell
+* Aaron Bentley
+
+Sponsor
+-------
+
+* Canonical_
+
+.. _Canonical: http://www.canonical.com/
\ No newline at end of file

=== added file 'doc/todo-from-arch.txt'
--- doc/todo-from-arch.txt	1970-01-01 00:00:00 +0000
+++ doc/todo-from-arch.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,372 @@
+***************************************** 
+Opportunities for improvement on GNU Arch
+***************************************** 
+
+
+Bazaar-NG is based on the GNU Arch system, and inherits a lot of its
+design from Arch.  However, there are several things we will change in
+Baz to (we hope) improve the user experience.
+
+The core design of Arch is good, brilliant even.  It can scale from
+small projects too large ones, and is a good foundation for building
+tools on top.  However, the design is far too complex, both in
+concepts and execution.  So the plan is to cut out as many things as
+we can, add a few other good concepts from other systems, and try to
+make it into a whole that is consistent and understandable.
+
+
+Good bits to keep
+-----------------
+
+* Roll-up changesets
+
+  No other system is able to express this valuable idea: "I merged all
+  these changes from other people; here is the result."
+
+  However, it should *also* be possible to bring in perfect-fit
+  patches without creating a new commit.
+
+* Star-merge
+
+  Find a common ancestor on diverged and cross-merged branches.
+
+* Apply isolated changesets.
+
+  We should extend this by having a good way to send changesets by
+  email, preferably readable even by people who are not using Arch.
+
+* GPG signing of commits.
+
+  Open source hackers almost all have GPG keys already, and GPG deals
+  with a lot of PKI functions to do with propagating, signing and
+  revoking keys.
+
+  Signed commits are interesting in many ways, not least of which in
+  detecting intrusion to code servers.
+
+* Anonymous downloads can be done without an active server.
+
+  Good for security; also very good for people who do not have a
+  permnanently-connected machine on which they can install their own
+  software, or which is very tightly secured.
+
+  It's neat that you can upload over only sftp/ftp, but I'm not sure
+  it's really worth the hassle; getting properly atomic operations
+  over remote-file protocols is hard.
+
+* Clean and transparent storage format.
+
+  This is a neat hack, and gives people assurance that they can get
+  their data back out again even if the tool disappears.  Very nice.
+  (Bazaar-NG won't keep the exact same format, but the ideas will be
+  similar.) 
+
+* Relatively easily parseable/scriptable shell interface.  Good for
+  people writing web/emacs/editor/IDE interfaces, or scripts based it.
+
+* Automatically build (and hardlink) revision libraries, with
+  consistency checks.
+
+  I don't know how many people want *every* revision in a library, but
+  it can be handy to have a few key ones.
+
+  In general making use of hardlinks when they are available and safe
+  is nice.
+
+* Rely on ssh for remote access, authentication, and confidentiality.
+
+* Patch headers separate from patch bodies.  (Sometimes you only want
+  one.)
+
+* Autogeneration of Changelogs -- but should be in GNU format, at
+  least optionally.  I'm not convinced auto-updating them in the tree
+  is worthwhile; it makes merges wierd.
+
+* Sealing branches.
+
+  It seems useful to prevent accidental commits to things that are
+  meant to be stable.  However, the set-once nature of sealing is
+  undesirable, because people can make mistakes or want to seal more
+  than once.
+
+  One possibility is to have a voluntary write-protect flag set on
+  branches that should not normally be updated.  One can remove the
+  flag if it turns out it was set wrongly.
+ 
+* ``resolved`` command in Bazaar-1.1
+
+  Good for preventing accidental breakage.
+
+* Multi-level undo -- though could perhaps be more understandable,
+  perhaps through ``undo-history``.
+
+
+Bits to cut out
+---------------
+
+One lesson from usability design is that it does not always work to
+have a complex model and then try to hide complexity in the user
+interface.  If you want something to be a joy to use, that must be
+designed in from the bottom up.
+
+  (Some developers may react to tla by thinking "eww, how gross" on
+  particular points.  As much as possible we might like to fix these.)
+
+* General impression that the tool is telling you how to run your life.
+
+* Non-standard terminology
+
+  Arch uses terms like "version" and "category" in ways that are
+  confusing to people accustomed to other version control systems.
+  This is not helpful.
+
+  Therefore: development proceeds on a *branch*, which is a series of
+  *revisions*.  Simple and obvious.
+
+* Too many commands.
+
+* Command-line options are wierdly inconsistent with both other
+  systems, with each others, and with what people would like to do.
+  For example, I would think the obvious usage is ``bzr diff [FILE]``,
+  but ``tla diff`` does not let you specify a file at all.
+
+  Most commands should take filenames as their argument: log, diff,
+  add, commit, etc.
+
+* Despite having too many commands, there are massive and glaring
+  gaps, such reverting a single file or a tree.
+
+* Commands are too different from what people are used to in CVS, and
+  often not for a good reason.
+
+* Identifiers are too long.  In part this is because Arch tries to
+  have identifiers which are both human-assigned and universally unique. 
+
+* Archive names are probably unnecessary.
+
+* Part of the reason for complexity in archives is that the Arch
+  design wants to be able to go and find patches on other branches at
+  a later time.  (This is not really implemented or used at the
+  moment.)
+
+  I think the complexity is unjustified: changesets and revisions have
+  universally unique names so they can simply be archived, either on
+  the machine of the person who wants them or on a central site like
+  supermirror.
+
+* The tool is *unforgiving*; if people create a branch with the wrong
+  name it will be around forever.
+
+* Branches are heaviweight; a record always persists in the archive.
+  Sometimes it is good to create micro-branches, try something out,
+  and then discard them.  If nobody wants the changes, there is no
+  reason for the tool to keep them.
+
+* Working offline requires creating a new branch and merging back and
+  forth.  This is both more work than it should be, and also polutes
+  the "story" told by branching.
+
+  As much as possible, the *accidental* difference of the location of
+  the repository should not effect the *semantics* of branches.
+  
+  (However, some merging may obviously be necessary when there is
+  divergence.) 
+ 
+* Archive registration.  This causes confusion and is unnecessary.
+
+  Proposed solutions such as archive aliases or an additional command
+  to register-and-get make it worse.
+
+* Wierd file names (``++`` and ``,,``, which persist in user
+  directories and cause breakage of many tools.  Gives a bad
+  impression, and it's even worse when people have to interact with
+  them.
+
+* Overly-long identifiers.  (One advantage of pointing to branches
+  using filenames or URLs is that the length of the path depends on
+  how close it is to the users location, and they can more easily use 
+
+* Too slow by default.
+
+  Arch can be made fast, but in the hands of a nonexpert user it is
+  often slow.  For most users, disk is cheaper than CPU time, which is
+  cheaper than network roundtrips.  The performance model should be
+  transparent -- users should not be surprised that something is slow.
+
+* Tagging onto branches.
+
+  Unifying tags and commits is interesting, but the result is hard to
+  mentally model; even Arch maintainers can't say exactly how it is
+  supposed to work in some cases.
+
+* Reinventing the world from scratch in libhackerlab/frob/pika/xl.
+
+  Those are all fine projects and may be useful in the future, but
+  they are totally unnecessary to write a great version control
+  system.  It is not an enormous project; it is not CPU-cycle
+  critical; something like Python will be fine.
+
+* Lack (for the moment) of an active server.
+
+  Given that network traffic is the most expensive thing, we can
+  possibly get a better solution by having intelligence on both sides
+  of the link.  Suppose we want to get just one file from a previous
+  revision...
+
+* Poor Windows/Mac support.
+
+  Even though many developers only work on Linux, this still holds a
+  tool back.  The reason is this: at least some projects have some
+  developers on Windows some of the time.  Those projects can't switch
+  to Arch.  Most people want to only learn one tool deeply, so it
+  won't be Arch.
+
+  Don't make any overly Unixy assumptions.  Avoid too-cute filesystem
+  dependencies.
+
+  Being in Python should help with portability: people do need to
+  install it, but many developers will already have it and the total
+  burden is possibly less than that of installing C requisite
+  libraries.
+
+* Quirky filename support.
+
+  Files with non-ascii names, or names containing whitespace tend to
+  be handled poorly, perhaps partly because of arch's shell heritage.
+
+  By swallowing XML we do at least get automatic quoting of wierd
+  strings, and we will always use UTF-8 for internal storage.
+
+* Complex file-id-tagging 
+
+  Nobody should be expected to understand this.  There are two basic
+  cases: people want to auto-add everything, and want to add by hand.
+  Both can be reasonably accomodated in a simpler system.
+
+* Complex naming-convention regexps in ``.arch-inventory`` and 
+  ``{arch}/id-tagging-method``.  (The fact that there are two
+  overlapping mechanisms with very different names is also bad.)
+
+  All this complexity basically just comes down to versioned, ignored,
+  unknown, the same as in every other system.  So we might as well
+  just have that.
+
+  There are relatively few cases where regexps help more than globs,
+  and people do find them more complex.  Even experienced users can
+  forget to escape ``\.``.  We can have a bit of flexibility with
+  (say) zsh-style extended globs like ``*.(pyo|pyc)``.
+
+* Some files inside ``{arch}`` are meant to be edited by the user, and
+  some are not.  This is a flaw common to other systems, including
+  Bitkeeper.  The user should be clear on whether they should touch
+  things in a directory or not.
+
+* Source-librarian function works poorly.
+
+  It is not the place of a tool to force people to stay organized; it
+  should just facilitate it.  In any case, a library without
+  descriptive text is of little use.  So bazaar-ng does not force
+  three-level naming but rather lets people arrange their own trees,
+  and put on their own descriptions (either within the tree, or by
+  e.g. having a wiki page listing branches, descriptions and URLs.)
+
+* Whining about inode mismatches on pristines/revlibs.
+
+  It's fine that there is validation, but the tool should not show off
+  its limitations.  Just do the right thing.
+
+* More generally, not quite enough consistency/safety checking.
+
+* Unclear what commands work on subdirs and what works on the whole
+  tree.
+
+* Hard to share work on a single branch -- though still not really too
+  bad.
+
+* Lack of partial commits of added/deleted files.
+
+* Separate id tags for each file; simple implementation but probably
+  costs too much disk space.
+
+* Way too many deeply-nested directories; should be just one.
+
+* ``.listing`` files are ugly and a point of failure.  They can cause
+  trouble on some servers which limit access to dot files.
+
+  Isn't it possible to have the top-level file be predictable and find
+  everything else needed from there?
+
+* Summary separate from log message.
+
+  Simpler to just have one message, and let people extract the first
+  line/sentence if they wish.
+
+  Rather than 'keywords', let arbitrary properties be attached to the
+  revision at the time of commit.
+
+
+
+Simpler disconnected operation
+------------------------------
+
+A basic distributed VCS operation is to make it easy to work on an
+offline laptop.  Arch can do this in a few ways, but none of them are
+really simple.
+
+http://wiki.gnuarch.org/moin.cgi/mini_5fTravellingOftenWithArch
+
+Yaron Minsky writes (2005-01-18):
+
+    I was wondering what people considered to be a good setup for using
+    Arch on a laptop.  Here's the basic situation.  I have a few projects
+    that reside in arch repositories on my desktop computer.    Basically,
+    I'd like to be able to do commits from my laptop, and have those
+    commits eventually migrate up to the main repository.  I understand
+    that the right way of doing this is to set up archives on the laptop. 
+    But what's the cleanest way of doing this?  And is there some way of
+    making the commits I do on the laptop show up cleanly and individually
+    on the desktop once they are merged in?
+
+
+Tagging-method
+--------------
+
+baz default is much less strict.  
+
+Much of tla depends on being able to categorize files.  Some hangovers
+from larch -- eg precious and backup are essentially the same.  junk
+is never deleted today.  
+
+Automatic version control with 'untagged-source source'.  But this is
+deprecated for baz?
+
+Annoyed by
+
+ - defaults
+ - having the feature at all
+ - complex way to define it
+
+Default of 166 lines.
+
+Remove id-tagging-method command or at most make it read-only.  If
+people really want to use deprecated methods they can just edit the
+file.
+
+So we can ship a default id-tagging which works the same as CVS/Svn:
+give warnings for files that are not known to be junk.  This is the
+default in baz right now.
+
+Also we have .arch-inventory, which is per-directory.
+
+
+
+Why not have 'baz ignore FILENAME'?  To remove ignores, perhaps you
+have to edit the .arch-inventory.  Print "FILTER added to
+PATH/.arch-inventory"; create and baz-add this file if it doesn't.
+
+Docs should perhaps emphasize .arch-inventory as the basic method and
+only mention =tagging-method as an advanced topic.
+
+
+
+Should this really be regexps, or just file globs?
\ No newline at end of file

=== added file 'doc/unchanged.txt'
--- doc/unchanged.txt	1970-01-01 00:00:00 +0000
+++ doc/unchanged.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,102 @@
+Detecting unchanged files
+*************************
+
+Many operations need to know which working files have changed compared
+to the basis revision.  (We also sometimes want to know which files
+have changed between two revisions, but since we know the text-ids
+and hashes that is much easier.)  
+
+The simplest way is to just directly compare the files.  This is
+simple and reliable, but has the disadvantage that we need to read in
+both files.  For a large tree like the kernel or even samba, this can
+use a lot of cache memory and/or be slow.  Some people have machines
+that do not have enough memory to hold even one copy of the tree at a
+time, and this would use two copies.
+
+So it is nice to know which files have not changed without actually
+reading them.  Possibilities:
+
+* Make the working files be hardlinks to the file store.  Easy to see
+  if they are still the same file or not by simply stat'ing them.  For
+  extra protection, make the stored files readonly.  Has the
+  additional advantage of reducing the disk usage of the working copy.
+
+  Disadvantage is that some people have editors that do not handle
+  this safely.  In that case the changes will go undetected, and they
+  could corrupt history.  Pretty bad.
+
+  We can provide a ``bzr edit`` command that breaks the link and makes
+  the working copy writable.
+
+* As above, but link to a temporary pristine directory, not to the
+  real store.  They can get a wrong answer, but at least cannot
+  corrupt the store.
+
+* Check the mtime and size of the file; compare them to those of the
+  previous stored version.  
+
+  The mtime doesn't need to be the time the previous revision was
+  committed.
+
+  There is a possibility of a race here where the file is modified but
+  does not change size, all in the second after the checkout.  Many
+  filesystems don't report sub-second modification times, but Linux
+  now allows for it and it may be supported in future.
+
+* Read in all the working files, but first compare them to the
+  size and text-hash of the previous file revision; only do the diff
+  if they have actually changed.  Means only reading one tree, not
+  two, but we still have to scan all the source.
+
+* Copy the file, but use an explicit edit command to remember which
+  ones have been changed.  Uneditable files should be readonly to
+  prevent inadvertent changes.
+
+The problem with almost all of these models is that it is possible for
+people to change a file without tripping them.  The only way to make
+this perfectly safe is to actually compare.  So perhaps there should
+be a paranoia option.  
+
+It is crucial that no failure can lose history.  Does that mean
+hardlinks directly into the file store are just too risky?
+
+It is most important that ``diff``, ``status`` and similar things be
+fast, because they are invoked often.  It may be that the ``commit``
+command can tolerate being somewhat slower -- but then it would be
+confusing if ``commit`` saw something different to what ``diff`` does,
+so they should be the same.
+
+For the mooted `edit command`__, we will know whether a file is
+checked out as r/o or r/w; if a file is known to be read-only it can
+be assumed to be unmodified.
+
+__ optional-edit.html
+
+The ``check`` command can make sure that any files that would be
+assumed to be unmodified are actually unmodified.
+
+File times can skew, particularly on network filesystems.  We should
+not make any assumptions that mtimes are the same as the system clock
+at the time of creation (and that would probably be racy anyhow).
+
+Proposal
+--------
+
+::
+  
+    if file is not editable:
+        unmodified
+
+    if not paranoid:
+        if same inum and device as basis:
+            unmodified
+        elif present as read-only:
+            unmodified
+        elif same mtime and size:
+            unmodified
+
+    read working file, calculate sha1
+    if same size and sha-1 as previous inventory-entry:
+        unmodified
+
+    possibly-modified

=== added file 'doc/unrelated-merge.txt'
--- doc/unrelated-merge.txt	1970-01-01 00:00:00 +0000
+++ doc/unrelated-merge.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,8 @@
+****************************
+Merging unrelated changesets
+****************************
+
+It ought to be possible to merge in even totally unrelated changesets,
+by just treating them as patches.  It is possible that the file ids
+will mismatch, in which case we could perhaps assume the filenames are
+compatible. 
\ No newline at end of file

=== added file 'doc/usability.txt'
--- doc/usability.txt	1970-01-01 00:00:00 +0000
+++ doc/usability.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,4 @@
+* http://www.asktog.com/basics/firstPrinciples.html
+
+* http://wiki.gnuarch.org/moin.cgi/BazaarMockupUI
+

=== added file 'doc/use-cases.txt'
--- doc/use-cases.txt	1970-01-01 00:00:00 +0000
+++ doc/use-cases.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,132 @@
+Bazaar-NG Use Cases
+*******************
+
+.. contents::
+
+
+
+Review changes 
+==============
+
+Look at somebody else's tree or email submissions.  
+
+Looking at the patch alone may not be enough; we might need to apply
+it to a tree, build it and see if we like it.
+
+
+
+
+Changes on branches
+===================
+
+Clearcase allows you to put all new development onto branches that are
+later merged back.
+
+Can we detect which development branches have unmerged changes?  Can
+we dispose of those branches?
+
+
+
+unmerge
+=======
+
+Get rid of any changes that have been merged in but not yet
+committed.  Shouldn't this just be ``bzr revert``?
+
+
+
+cross damage problem with PQM 
+=============================
+
+Lock 
+
+
+
+undo some uncommitted changes
+=============================
+
+If you've made some changes and don't want them::
+
+  baz undo foo.c
+
+This stores them as a changeset in a directory that you can move
+around.  You can set a name for it::
+
+  baz undo --name blargh-refactor foo.c bar.c
+
+You can get it back::
+
+  baz redo foo.c
+
+
+move some in-progress changes onto a local branch
+=================================================
+
+This is useful if we decide some changes on a bound branch should be
+done on a separate branch; in particular people will want to do this
+if they want to work in only one subdirectory of a complex config.
+
+Possibly this should be the default with no arguments for ``bzr
+branch``.  Or possibly there should be a separate ``bzr unbind``.
+
+
+
+ignore some files
+=================
+
+I'm working on a Python project, which leaves bytecode files in the
+working directory::
+
+  baz ignore \*.pyc
+  baz ignore \*.pyo
+
+or::
+
+  baz ignore '*.py[co]'
+
+OK, there is some danger here that people always forget to quote globs
+on the command line but maybe this will be enough.
+
+Maybe take only one at a time so that we can catch unquoted globs like
+this::
+ 
+  baz ignore *.pyc                      # wrong!
+
+If they do this, they see all '* added foo.pyc to .arch-inventory';
+then they can do this to get back::
+
+  baz undo .arch-inventory
+
+This is potentially much more pleasant than Subversion.
+
+
+
+Wrong commit message
+====================
+
+I accidentally commit some files with the wrong message and want to
+change them::
+
+   % bzr status
+   M    foo.c
+   % bzr commit -s 'fix foo'
+   M    foo.c
+   [oops!]
+   % bzr uncommit
+   % bzr status
+   M    foo.c
+   % bzr commit -s 'fix foo and bar'
+
+This fix should be done as soon as possible, before anything else
+depends on the change.
+   
+
+
+Monday morning
+==============
+
+Come in Monday morning; can't remember what you were doing.
+
+* log; look at what was committed
+* diff against upstream, or recent revisions
+* what else?

=== added file 'doc/web-interface.txt'
--- doc/web-interface.txt	1970-01-01 00:00:00 +0000
+++ doc/web-interface.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,24 @@
+*************
+Web interface
+*************
+
+The web interface may be the first way many people interact with a new
+VC system.  It may not be core functionality but it is important.
+
+mpe says he likes the bkbits.net one, in particular that you can
+quickly search the comments and pull out individual patches.  However,
+it does not really give people a good sense of how the tool works.
+
+The `Aegis web interface`__ is rather better, giving a good sense (for
+better or worse) of the ideas behind the tool, as well as the
+particular tree being viewed.  For example you can see that all
+changes in progress are registered, that one can identify conflicts
+before a merge is attempted and so on.  In part this is because there
+are many links ("Information available") and they are explained in
+some detail:
+
+  "This item will provide you with a list of changes to this project,
+  including those which have not yet commenced, those in progress, and
+  those which have been completed."
+
+__ http://aegis.sourceforge.net/webiface.html
\ No newline at end of file

=== added file 'doc/work-order.txt'
--- doc/work-order.txt	1970-01-01 00:00:00 +0000
+++ doc/work-order.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,64 @@
+* 
+
+
+
+* Build a past revision from history:
+
+  - Working; now rebuild only up to a particular point.
+  
+  - A generic test that can be applied to any test working directory
+    that all previous revisions can be successfully recreated.
+
+* Ignore-file support: finalize design and then implement it.
+
+* Command-line options: should be passed down as arguments to ``cmd``
+  functions. 
+
+  - ``commit`` message should be an option, not an argument.
+
+* Class representing a tree (or working directory or branch)
+
+  - Should this really be a class or is it better to just have a set
+    of global functions?  What data is held in memory other than the
+    directory name?
+
+  - List status and inventory sorted by file name.
+
+  - Add/move/delete files.
+
+* Store patches in a zip file?
+
+* When building diffs, show only the relevant tail of the two
+  filenames in the index line. 
+
+* Store patch headers in XML?  What parser/generator to use?  Maybe
+  tupletree-format, or Zope xmlpickle, or ElementTree_?
+
+.. _ElementTree: http://effbot.org/zone/element-index.htm
+
+* Make immutable files (e.g. recorded patches) read-only after they're
+  written.  This would be a good idea, except that it means people
+  need to use ``rm -rf`` to remove branches, which may be dangerous.
+
+
+Guiding principles
+------------------
+
+* In the first instance, just cache everything; don't worry about
+  recreating them from simpler components.  So keep a copy around of
+  all previous revisions, their inventory and manifest, etc.
+
+* Start writing a test framework into which new development can fit.
+
+* No need to handle move/rename or subdirectories yet.
+
+* Do try to add assertions against invalid states. 
+
+* Keep it simple in interface and implementation.
+
+
+
+
+.. Local variables:
+.. mode: rst
+.. End:

=== added file 'doc/workflow.txt'
--- doc/workflow.txt	1970-01-01 00:00:00 +0000
+++ doc/workflow.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,117 @@
+********
+Workflow
+********
+
+People want to manage submissions of patches; see `Havoc's post`__.
+
+__ http://log.ometer.com/2004-11.html#19
+
+The ideal interface is::
+
+    baz branch http://project.org/bzr/project-2.0
+    [hackety hack]
+    baz submit
+
+It would be nice if people could submit simple changes without needing
+to set up their own public branches.  I don't think people will want
+to allow random strangers to create branches on their machine, so this
+probably means submitting the changes by email.  To form such a patch
+we need to know what branch point counts as "upstream", and who to
+send the patches to.  As a reasonable default, we might use the last
+time we branched and the last 
+
+Some of this should be better done in integration with e.g. mail
+clients or external robots or bug trackers. 
+
+Bazaar-NG allows redrafting rejected patches in an interesting way: 
+
+  Person writes a feature on a new feature branch.  They can commit
+  several times, merge up to date, even have sub-forks to an arbitrary
+  extent.  When they're ready, they submit their changes to the
+  maintainer, either by mailing the diffs relative to the main branch,
+  or by the maintainer pulling from their tree.   If they don't like
+  it, they can not commit it to their tree, and hopefully give some
+  feedback to the contributor.  (I don't think that feedback needs to
+  go back through the tool; email or some other communication
+  mechanism is probably fine.)  The contributor can then keep working
+  in their branch, until it eventually gets merged.
+
+  Alternatively, the maintainer might want to merge the change but fix
+  it up themselves.  We keep track of the fact that it was merged, and
+  the maintainer can make arbitrary fixups either in the course of
+  merging it or afterwards.  When the contributor later merges back
+  everything will work.
+
+  Another case is that the maintainer wants to improve the patch but
+  not take it into their main tree.  What they can do here is take it
+  into a separate feature branch, fix it up, and then ask the
+  contributor to merge back from there.
+
+Maintainers__ would also like to keep track of patches that have been
+submitted but not yet accepted, so they're not lost and can be
+updated.  One way to do this would be to create a branch on the
+maintainer's machine for a submitted patch, and apply the submission
+to that.  The maintainer can fix it if they want, or take updates to
+it.  The submitter can see what, if anything, was done.  Because this
+branch is identified by a URL it can be cited in bug reports, and it
+might make sense to name the branch by the bug it is supposed to fix.
+
+__ http://gcc.gnu.org/ml/gcc/2002-12/msg00444.html
+
+
+
+Aegis-style review and integration
+----------------------------------
+
+Some projects might want all changes to be submitted for review before
+merging onto the mainline.  This might be done either by convention,
+or perhaps by not allowing individual developers to merge to the
+mainline but rather having specific privileged integrators.
+
+Aegis_ enforces a lot of workflow/process; it would be good to be able
+to do something similar on top of bazaar-ng either manually or as a
+higher-level tool.  Aegis's model is that each proposed change is
+essentially on a branch that later merges into the mainline, which
+makes a lot of sense.
+
+.. _Aegis: compared-aegis.html
+
+To do something like Aegis, follow this process:
+
+* Developer makes a new branch from the trunk to develop a feature,
+  called say ``project--devel--bug-123``.
+
+* When they have almost finished development, they re-merge from the
+  trunk to make sure they're up to date.
+
+* By some mechanism they ask a reviewer to consider their changes --
+  perhaps by sending email, or using a bug tracking system, or
+  something else.  They tell the reviewer the location of their
+  branch, which might be on an HTTP server for a public project, or on
+  a directory on a shared server.
+
+* The reviewer makes a new branch for review based off the trunk,
+  ``project--review--bug-123``, and merges the development branch into
+  it.  The merge should be perfect if the developer was up to date
+  with the trunk.  If the merge fails they can either bounce it back
+  to the developer or fix the merge themselves according to local
+  policy or their own discretion.  They then review, build and test
+  the branch.  If it's OK, they commit to their review branch and send
+  a note asking for it to be integrated (or perhaps they integrate
+  themselves.)
+
+* The integrator merges from the review branch onto the trunk,
+  builds/tests and commits.  Since they pull from the reviewer's
+  branch there is no way unreviewed changes can sneak through even if
+  the developer adds to their work branch after the review.
+  
+  This can be done by a robot, or by a reviewer.
+
+* The developer can look at the review, integration and trunk branches
+  to see that their changes have merged.
+
+This model is practiced by some people at Canonical using tla.  Since
+people work within a complex configspec, they like very much to be
+able to branch in-place so that they do not need to rebuild the whole
+config to start new development.  (Though perhaps the real fix is to
+make assembling a config simpler...)

=== added file 'doc/yaml.txt'
--- doc/yaml.txt	1970-01-01 00:00:00 +0000
+++ doc/yaml.txt	2005-03-09 04:51:05 +0000
@@ -0,0 +1,40 @@
+YAML
+****
+
+I am thinking about keeping changeset headers in YAML_, as a nice
+tradeoff:
+
+ * Standard data format, so we don't need to invent, write and debug
+   an ad-hoc format.
+
+ * More concise than XML, which is useful if we're storing a few.
+
+ * Reasonably readable for humans; thus suitable for sending in email
+   and giving people at least some chance to read and understand it.
+   Seeing this at the top of a patch would not be actively horrible as
+   long as we keep it reasonably small; that's not true for XML.
+
+ * Since YAML documents have a document header and terminator ('---'
+   and '...') we can pick them out of a text document and append
+   text patches directly afterwards.
+
+ * Fits well with Python internal data structures.
+
+ * There are parsers for various languages, so people can write their
+   own implementation if they really want.
+
+ * There is space to specify a document format/version at the top
+   (though this is not currently handled in ydump).  
+
+The ydump module is pretty primitive, but it should have enough.
+
+.. _YAML: http://www.yaml.org/
+
+
+Conclusion
+----------
+
+On the whole, I think this is not a good idea.  It is a nicer syntax
+for XML, but there are less bindings, and it does not achieve the goal
+of having the storage format look reassuring and giving confidence
+that the data could be retrieved by an alternative implementation.
\ No newline at end of file

